/**
 *	@file Decompress64Src.h
 *	@brief file in header, generated from 'Decompress64.h'
 *		using BWT / RLE / Huff / Base85 pipe
 *	@date 2014-11-26 10:20:21
 *	@author FileToHeader v2.03 (built Sep 11 2014)
 */

#pragma once
#ifndef __DECOMPRESS64_H_FILE_IN_HEADER_INCLUDED
#define __DECOMPRESS64_H_FILE_IN_HEADER_INCLUDED

/**
 *	@brief file in header, generated from 'Decompress64.h'
 */
class CDecompress64_h {
public:
	/**
	 *	@brief gets size of the data
	 *	@return Returns size of the data, in bytes, not including the terminating zero.
	 */
	static inline size_t n_Size()
	{
		return 5332; // matches original file
	}

	/**
	 *	@brief determines whether the stored string is dynamically allocated
	 *	@return Returns true if the caller of p_Data() needs to free the memory.
	 */
	static inline bool b_Dynamic()
	{
		return true;
	}

	/**
	 *	@brief gets CRC
	 *	@return Returns CRC32 of the stored data.
	 *	@note The stored CRC may differ from the original file if data processing was enabled.
	 */
	static inline uint32_t n_CRC32()
	{
		return 0x1fb89138; // matches original file
	}

	/**
	 *	@brief gets data
	 *
	 *	@return Returns data of the file on success, 0 on failure (not enough memory).
	 *
	 *	@note The data (despite it may be binary), is additionally null terminated to make
	 *		it easier to use (the terminating null is not counted in n_Size()).
	 *	@note See also b_Dynamic().
	 */
	static inline char *p_Data()
	{
		const char *p_s_base85 = "~0RR910RR911ONa40{{R31^@s64FCWD2mk;83;+NC4*&oF6#xJL8UO$Q~~~~009C8"
			"0|W;K2.z@c4G#<s6%Y~^6BHR17#k5CARHeWAtN3oDkLi+Cn+!{C,U4UJ1#FVGf#48LP#uqSvEI6ZdGkGaBEI2I"
			"W<&0U3GR~cs_YLP*Oy3SZP3WbU,>qNq0(1Y<hcVV}Y==,Tj7m<-rILBqRwAy1@wo1R~2}f)Ff8LU2|!p#oh@&N"
			">HJ0uts*6O}.#Hz6Sc6@gwdT!u.v$#NMjfUFAg<bhBX;HX@ICk3<>hF(j-zwBmR21}7tjKBEf,v2qkexu<aW9v"
			".8gX3Y8r!}FN5*f,>(wRWEnX.V.%Q^p%{_g}JW9R*m_0EV|DHcSz@S+3@QU2dJ$LGi9YJ3{){j$b+8wxMqiu@<"
			"j_,@uJ(|,Ky!Hbs^A3~w6fgna)&kQjCAeugn=#iPnQVGd!Oy||@=3$4;0iuBMPN@|8c)9*Lh)AUnb)Szrt$WGy"
			"aZiA1iG#U0Tz2oJiSYSZ&fn%{3GM5MBk5E>o@(wD7i0K2L+Ku+0p==*v$wzU^=|9@zumHi9S*luvBe!Zb+0F6I"
			"pIsseA;U*ee8>g!Y8@j33z4I+|L*2q5Ctm4vboiFlfLvl)NH,^&,l;7xDhQanZ9XV)_(b!yzBHv+9m{N=7$#_x"
			"i&-74tWYx&QrH>Dw0,jIp7$f1ZlomaGgR3Rf7J8IwFb12d.0Au<w{VS6&G$b&4FV*NZ~wZVo4MYXXSV2P6W4.u"
			"zy5R@pZHyv3_qF5-+iT22hOc3X=uWf6OF0QkNsK2r-XXO_qglQ{yEJ^ir{Vu3gF116|iTd6LTSbAOX%=cJ^ED4"
			"8iAPf;$<Q=mAv#a}S}~gY%Z8&1#~t^-lgS>PUYclD_2.n)UZG>v<-nZ*ne}1C+w98kN3*,w.2F9sneSK4WnNNB"
			"m&0OlykxnTSUVZU_bLvUSqznl>}JF~Y*h(u9bO9(.%@R!eg%pAGPz~D!Vq!zw|g}1,xS3)5ZHWJyfV.uZ_GM!T"
			"g;z~xU5eNk.9UMnm-V4h5K5CSxRzHtY-;<DgwOKwJ^7.km22=tOpGy3J^<zp+v&cGU(>Ij4fwBI&r0BXjnQB&N"
			"Xe~4MW$g^&C4wi_zb23C6yQribpPhVVmocy>jQ_my|-)mm2ws=Zw;I&I.E9)))*Hj6p%v9DcMj$1I~uJvz7K#="
			"Q^R15DHAnN.iu7F9;B0!PmK*9zI8O;7c4Gr88cr1e|2Yun^ydl#cCE@q)G<@w7_t^JdG*<Ba*Ny!(y!L)ZfBHX"
			"v$FLWyBklA<iiKQebISxMQlRv*8.2afN8<S@=_uG~G&h^hy=i%@bvJN9>ujCF)BWlwAK>Todxm|=m^8yshAa+Y"
			"@gahJD)Y~Io*X}qSD)wH;dVvNA$,ERj@,)u21pZzmj>7kw9N&OQExTdYXdSF#$~)FfVZ7|0lzqbC=YcF43S,p1"
			"=J>@u~!FjuoJYa0(0ozSxa=Jgff_hVTCE+c0(#Rf=rlZOfWLo4MW19$8MAf0#-Pu6AUCU.Lw>>.+Nh-aCZxRgs"
			"#S+y5$}c{};S5a<2aD9O3Xy$Qk.hC8Rz-xUEcSh-=<mOhd,A>R|~G5^_J~-,X<ExNeKg3wd|HO,bM|c@4Q~I<W"
			";XlLF54Di}@yHLxr}I43KK5kl!Gl.g)b8sB^L8lVwzSL7AgOywAwu.Knj!PJ-z&bTp)1Zk^lhc&-S6-9g75@uH"
			"LY8O4#6Ph3wuofjyeG~<VMd1!^)pz88vg%CcyC7L;3OQFUe-i8%HF5^Xy6}FM8mnQRraByO$ScUZ9e4|wqC.@w"
			"aZQGfJPl$M23dTARd<zO;rI*,5VmP1v2%wS7g9,TAm@3*R~8u_R9>7oI9%Yl8a&c+LR^8l4D;Asw;|Jwq8uvby"
			"Uv}crO9(Mw(P91&W0I<$2$Z%W.m(B.80bv.F48q&Kq%0X|4kVXU%TfaLl|,3&CU>vNvrg!I03LuA8^Mz.UaHs^"
			"xXTXER<=uP^TmayKR|42FxWYSb4bC5h^.WvPgPl9a%ZM789hSk(w@!Xn2BK,6SRPT*U~fjBlsg=p~j2(Cc.DRN"
			"F{%$+9RfbD|8Al,k~D&$=^B;3Z0djrnpUAuR=<l%T|sz0z}Y6KwV-ZV9i-7GQ%KWhXzp$I~Y0&r(Kk_k!$5&9I"
			"V(loQ4SVIVf5XlhJ4poJ-Nx6m+9XfKThQw*u<2DW!$jz8E.^Y*DT0v|EaO.R(C}9h<)5l.Ui_}Av-(8pOI-<pb"
			"^,7FO<Ivr{jLU-tQ_L#kb=QziB=1v^I18bkpkyZo,9lqczKaA5i}Ef(5n|-QG&<|Rpg<&CE,YX$&S1%kMn<.sq"
			"%m{Y!8}Z>5{CUiu{&5n2B6d!{lNWz^e(CnlryriQoZHcsr)nR$P=7#*LiGZ%tp_c$vDlYX.4N)boqii&JBjWs|"
			"FZma;RkI24o40iz*ya5)Odab8xxN8t9u4L=fkenS<#|COL#LMBxr<K{bVfa&IoMKeQ>#u7M{6<9k*h-NgEU";
		return (char*)p_Decode_BWT_MTF_RLE_Huff_Base85(p_s_base85, 5332, 3399, 276);
	}

protected:
	/**
	 *	@brief decompression routine
	 *
	 *	@param[in] p_s_base85 is null-terminated string containing Base-85 encoded compressed data
	 *	@param[in] n_data_size is size of the decompressed data
	 *	@param[in] n_huff_stage_size is size of the compressed data before Huffman encoding
	 *	@param[in] n_bwt_primary_index is primary index for the BWT algorithm
	 *
	 *	@return Returns pointer to the decompressed data on success, 0 on failure.
	 *
	 *	@note The data (although it may be binary), is additionally null terminated.
	 */
	static uint8_t *p_Decode_BWT_MTF_RLE_Huff_Base85(const char *p_s_base85,
		size_t n_data_size, size_t n_huff_stage_size, uint32_t n_bwt_primary_index)
	{
		size_t n_base85_length = strlen(p_s_base85), n_base85_size = 0;
		int p_b85_ic_tab[128] = {0};
		{
			for(int i = 0, j = -10, k = 55, l = -62; i < 85; ++ i, ++ j, ++ k, ++ l)
				p_b85_ic_tab[(j < 0)? k - 7 : (l < 0)? k + j / 26 * 6 : "!#$%&()*+-;<=>.@^_,{|}~"[l]] = i;
			const char *p_s_src = p_s_base85, *p_s_end = p_s_base85 + n_base85_length;
			for(size_t n_diff, n_rem = n_base85_length; p_s_src < p_s_end;
			   p_s_src += n_diff * 4 + 1, n_rem -= n_diff * 4 + 1)
				n_base85_size += (n_diff = (p_b85_ic_tab[*p_s_src] == 84))? 4 : min(n_rem, size_t(5)) - 1;
		}
		size_t n_prehuff_size = max(n_base85_size, n_data_size);
		size_t n_temp_buffer_size = max(n_prehuff_size + n_huff_stage_size,
			n_data_size * (1 + sizeof(uint32_t)));

		uint8_t *p_temp_buffer, *p_data;
		if(!(p_temp_buffer = new(std::nothrow) uint8_t[n_temp_buffer_size]) ||
		   !(p_data = new(std::nothrow) uint8_t[n_data_size + 1])) {
			if(p_temp_buffer)
				delete[] p_temp_buffer;
			return 0;
		}
		p_data[n_data_size] = 0; // null-terminate the data

		{
			uint8_t *p_dst = p_temp_buffer - 1;
			const char *p_s_src = p_s_base85, *p_s_end = p_s_base85 + n_base85_length;
			for(size_t n_rem = n_base85_length; p_s_src != p_s_end; -- n_rem, ++ p_s_src) {
				if(p_b85_ic_tab[*p_s_src] != 84) {
					uint32_t n_block = uint32_t(min(n_rem, size_t(5))), n_code = 0;
					_ASSERTE(n_block >= 2);
					for(unsigned int i = 0; i < 5; p_s_src += ((++ i < n_block)? 1 : 0))
						n_code = n_code * 85 + ((i < n_block)? p_b85_ic_tab[*p_s_src] : 84);
					for(unsigned int i = 1; i < n_block; ++ i, -- n_rem)
						*(++ p_dst) = n_code >> (8 * (4 - i));
				} else
					*(uint32_t*)((p_dst += 4) - 3) = 0;
			}
		}
		{
			const uint8_t *p_huff_src = p_temp_buffer, *p_huff_end = p_huff_src + n_base85_size;
			_ASSERTE(p_huff_src + 16 * sizeof(int32_t) <= p_huff_end);
			const int32_t *p_code_num = (const int32_t*)p_huff_src;
			int p_max_code[16], p_table_off[16], n_code_num = 0;
			for(int i = 0, n_code_word = 0; i < 16; ++ i, n_code_word <<= 1) {
				p_table_off[i] = (n_code_num += p_code_num[i]) - (n_code_word += p_code_num[i]);
				p_max_code[i] = n_code_word;
			}
			const uint8_t *p_symbol = (p_huff_src += 16 * sizeof(int32_t));
			_ASSERTE(p_huff_src + n_code_num <= p_huff_end);
			p_huff_src += n_code_num - 1;
			uint8_t *p_dest = p_temp_buffer + n_prehuff_size, *p_end = p_dest + n_huff_stage_size;
			for(uint8_t n_byte = 0, n_bit_num = 7; p_dest != p_end; ++ p_dest, n_byte <<= 1) {
				for(int i = 0, n_code = 0;; ++ i, n_byte <<= 1) {
					_ASSERTE(i < 16);
					if(!((++ n_bit_num) & 7)) { // every 8
						_ASSERTE(p_huff_src < p_huff_end);
						n_byte = *(++ p_huff_src);
					}
					n_code = (n_code << 1) | (n_byte >> 7);
					if(n_code < p_max_code[i]) {
						_ASSERTE(n_code >= p_max_code[i] - p_code_num[i]); // n_code >= p_min_code[i]
						*p_dest = p_symbol[n_code + p_table_off[i]];
						break;
					}
				}
			}
		}
		{
			const uint8_t *p_rle_src = p_temp_buffer + n_prehuff_size,
				*p_src_end = p_rle_src + n_huff_stage_size;
			for(uint8_t *p_rle_dest = p_temp_buffer; p_rle_src != p_src_end;) {
				uint8_t n_code = *p_rle_src;
				bool b_compressed = n_code & 1;
				int n_run_length = (n_code >> 1) + 2;
				_ASSERTE(p_rle_src + ((b_compressed)? 2 : n_run_length) <= p_src_end);
				for(; -- n_run_length; ++ p_rle_dest)
					*p_rle_dest = (b_compressed)? p_rle_src[1] : *(++ p_rle_src);
				p_rle_src += 1 << ((b_compressed)? 1 : 0);
			}
		}
		{
			uint8_t p_buckets[256] = {0}; // each bucket value encoded as offset to its index
			uint8_t *p_data = p_temp_buffer, *p_end = p_temp_buffer + n_data_size;
			for(; p_data != p_end; ++ p_data) {
				uint8_t n_index = *p_data;
				*p_data = p_buckets[n_index] + n_index;
				for(int i = n_index; i != 0; -- i)
					p_buckets[i] = p_buckets[i - 1] - 1;
				if(n_index)
					p_buckets[0] = *p_data;
			}
		}
		{
			uint32_t p_buckets[257] = {0}, *p_index_list = (uint32_t*)(p_temp_buffer + n_data_size);
			const uint8_t *p_src = p_temp_buffer, *p_end = p_temp_buffer + n_data_size;
			for(uint32_t *p_dest_idx = p_index_list; p_src != p_end; ++ p_src, ++ p_dest_idx)
				*p_dest_idx = (++ p_buckets[*p_src + 1]) - 1; // start accumulating in bucket 1
 			for(int i = 1; i < 255; ++ i) // exclusive prefix sum
				p_buckets[i + 1] += p_buckets[i];
			uint8_t *p_dest = p_data + n_data_size - 1, *p_begin_1 = p_data - 1;
			for(uint32_t i = n_bwt_primary_index; p_dest != p_begin_1; -- p_dest,
			   i = p_index_list[i] + p_buckets[p_temp_buffer[i]])
				*p_dest = p_temp_buffer[i];
		}
		_ASSERTE(!p_data[n_data_size]); // make sure the terminating null was not overwritten

		delete[] p_temp_buffer;
		
		return p_data;
	}
};

#endif // !__DECOMPRESS64_H_FILE_IN_HEADER_INCLUDED
