/**
 *	@file Decompress85Src.h
 *	@brief file in header, generated from 'Decompress85.h'
 *		using BWT / RLE / Huff / Base85 pipe
 *	@date 2014-11-26 10:20:32
 *	@author FileToHeader v2.03 (built Sep 11 2014)
 */

#pragma once
#ifndef __DECOMPRESS85_H_FILE_IN_HEADER_INCLUDED
#define __DECOMPRESS85_H_FILE_IN_HEADER_INCLUDED

/**
 *	@brief file in header, generated from 'Decompress85.h'
 */
class CDecompress85_h {
public:
	/**
	 *	@brief gets size of the data
	 *	@return Returns size of the data, in bytes, not including the terminating zero.
	 */
	static inline size_t n_Size()
	{
		return 5540; // matches original file
	}

	/**
	 *	@brief determines whether the stored string is dynamically allocated
	 *	@return Returns true if the caller of p_Data() needs to free the memory.
	 */
	static inline bool b_Dynamic()
	{
		return true;
	}

	/**
	 *	@brief gets CRC
	 *	@return Returns CRC32 of the stored data.
	 *	@note The stored CRC may differ from the original file if data processing was enabled.
	 */
	static inline uint32_t n_CRC32()
	{
		return 0xed59f047; // matches original file
	}

	/**
	 *	@brief gets data
	 *
	 *	@return Returns data of the file on success, 0 on failure (not enough memory).
	 *
	 *	@note The data (despite it may be binary), is additionally null terminated to make
	 *		it easier to use (the terminating null is not counted in n_Size()).
	 *	@note See also b_Dynamic().
	 */
	static inline char *p_Data()
	{
		const char *p_s_base85 = "~0RR910ssI20ssI20{{R31^@s63jhEB3jhEB3jhEB7ytkO5C8xG7ytkO~~~~009C8"
			"0|W;K4G9Pe3k(kt4iFU=6BZc~8XXiH9~c}UA|oU-Atfg%9yB>7C@e}UJuQ7NH!DFnb8k8|ZBlA7Mm$w_P)kEDQ"
			"As{~Oigf8b$(QMWqEo|SaDi%PhDO%Fgs#wLVRXNXh@=@sQ3Oc$T5Y8AW&6QXoL,;vJ!w$3JM^-Y6OHR1-POV0."
			"5{cCD,5IuPUHvL1cmzOc0R@3nVQgOQdOY4JwT-BTAsE3iAYkUJ3zZ3qUQvt{V2T2l@urFw*EKmXH29{jcu*A1}"
			"63{naL.+3v|Q4EmVVp(cEckcSHMITWU{KT1-E{Mf,%ReQ5^j_YAGhBVU!2jtX$r~HicWplU7qW|ny,+4XMkbGY"
			"z&*4.,hy7{0+3fg7u>3KT4op840k28lmp90JB@u<S^CE+A3J6}o{n8>skKy<addp|WVuu^T(|+0toVqGua3ZVg"
			"trbvPv-+;JG0M<tTC,U.kZUmb=f3w-8*,k-7Z0&i.cMoKpEUy9)Fw&xDxc9M8Z9y1Nbwf2X{B(F_C|KEPvzO>7"
			"T>@2^>kc+-)Bm}hi6AJ_&H2|-CjGb6^C.PC|Ba,luA5SiVUPpqMg0c^U;BISZg7TmSZ*Dd<|!L^m^BcTlsxAXU"
			"CgX7u|.fnK6h)&hK)4SI|oAJe4WwSzKZ3^wB6k|GwP(b(FyMYR^H(.#|1~HkO=Be2RpS(w|6lIDxS;vRXm7Qw*"
			"T#EeT6y8sa<~gHE0}&VhZrFwn2Lj2bfD$=f8-pLj6RfuhP(!*ynqLW63uQXE^j,s^a@OEg$LMRoOIUAOcv7h7B"
			"&>Ro.LAkVa3oO7m=je#G3+r2A~p)cL^e$U@S.c9HS*#<vWB=QBNA#;j.@+;<*H{yJ8UKN;4LFaS0b9MG55p-J<"
			"-4O1=VE@m0x##&jPTuzk!ea%.3;loA^cKRanRxuU6KyB8!h9Ze(A~4).p8fM7W3t%E_El!lPGvln~9x$84WGRA"
			"AJi*d>B#(MN$(L!%E=of{Crc>%7*GAWLxzL1c5QjL.A)s9.08zU$WQ{W62XhgZ#~pQfJo9fl3k>7Dd<YVL,|Uv"
			"{0w9ti|2j(OPpWb*g+$3.^B_zzOrbM$;b,p~sIifV@i5U(7njjEZUS$VvBM)vJ9Mhc73prncod.&OV%HVID30Z"
			"obkw,4nR2JM>UN,)z4.ytCq$zQ$ob((yy46qp.DAjYrkx,UZhe$w<LwTJ!aR3H_-6^*$62gK!$+5^BT~I>$2>w"
			"OOKXd@Jeu*;x95*nztknnYe0ifd%S6MkJg~;pi4X3Df2m39(1bMQ8a,MEHJRDT4g.y7a.i9H(Wn&zaZ|oDG8tD"
			"aDKauUrU;Pwt4Ox+Ti~.hw<9uADzeXJg|BE1>xoL&|()_qMrtb*ivBs56|bXz*VnvA4~NKOYXbelhyBgmGnWM)"
			"K<8w;qp}|%.SQK!t=J{JT,wm&flhL8!,+u6k^C1z6;87*pMJ;0)Xg%dqM6qL3#.RgMd(WU%I4|D47K>Xi}m6H8"
			"AQ2_CoCvpeiIJViQolr7SDLAhQLKPU6THkp7-VHEHu!fh|&Hv5JZ^p=m>w(.}doQkhLiNKH*>;oyNRj@1Zb1c5"
			"dziZbejJY_K=124>5v8PjB3VLZC9,2|yi1UUpb^d%}^b>CVfR@nty#{s),JNdE!BE*#3-ko@9PC0wf~l&9S>}S"
			"D@EZJs>03cm)$ZZFSU$RiHV>~3;q6-v-9W7=Fj}qzpw5,)5nO.21puJKSmjj40|cs33&cG0_RUfVyr)1$&,^5k"
			"OASHMeWUjzBqJjAgGf~|eNgsIN5;@&!{w!,7Zk;=kaaD61qP-IXe)~#{M7|;PJoy=>95Zrf)pKEi,Xp|&<YD!!"
			"Q>I+Fvde)NIQ#U9N7*Q!Rl~ZS-$-Nk3o)|OA%=,P(AClmD+E4hTVq|3I.aZbX~zPT0>{-F;s|q,U*_pcx|bjXk"
			"c9z7-==_cbnKC..IY.-vN9A;9)+|$<%3hf$$ts;qKRXae~_oG=kW37r}<1@=#isrKI1MI,2|ra8.#K12<k13WH"
			"rGwrH&.a@-41mU8W|U#O(wsvPiOu4!yL=PE2lhsNwfFj@m$#(RvIL=DAF^k&TQw**;1&Ve97XepkIAfqvZHQp@"
			"~bOrsvqe0h;lMG@|<f6PVscp*j14,rKX,@>vK{hHT2.WvPVuVV_){yTBn~EVpNy60%_,z^6-azjOxZ<&&H.~eD"
			"8Uo+iQ7b@Qq^9$YLwDkGp^!j6-IuFqFs11|Bc6U>.ShM62s<|Gy&n$!^h!}Es-Sdt4qfLeF,!iWSWF)h5UAP&2"
			".I!.nfKd+l@P>HOthfRTM(},p&&.ws7RG6rI9Zo@Zkj+&jEgeQ(.$A<Wpi@0JZ~w>-a)o##bX}RYJJ}&|#}3Nr"
			"K#~w!4Qn!Pj_Xv*#wk1F6r#t*z,dQ%GCLK34GsE-~Rz<!vQ07cr|@vRh7}KL}^E<IJu=(SC!9XpsdfVHT+BVI|"
			"_)SrD!;;DY<iXqklWHOkW1tq@|Igu<yrKS9)nAcIJ1^aU;oRB)g<s%L~.BHhM%YxWtPcLKcY&vqsJQAjQxdPbB"
			"D@7PlhlYf*axaxTBIq^w.aB@upXc@y.4;7@>=H3-4p6EK3H|Tl+5_7@det.asRf~w_RX|Jvg9|l!f|(dpF#SPW"
			"j5UH#3JiUprJs#DOg><z,hW";
		return (char*)p_Decode_BWT_MTF_RLE_Huff_Base85(p_s_base85, 5540, 3647, 283);
	}

protected:
	/**
	 *	@brief decompression routine
	 *
	 *	@param[in] p_s_base85 is null-terminated string containing Base-85 encoded compressed data
	 *	@param[in] n_data_size is size of the decompressed data
	 *	@param[in] n_huff_stage_size is size of the compressed data before Huffman encoding
	 *	@param[in] n_bwt_primary_index is primary index for the BWT algorithm
	 *
	 *	@return Returns pointer to the decompressed data on success, 0 on failure.
	 *
	 *	@note The data (although it may be binary), is additionally null terminated.
	 */
	static uint8_t *p_Decode_BWT_MTF_RLE_Huff_Base85(const char *p_s_base85,
		size_t n_data_size, size_t n_huff_stage_size, uint32_t n_bwt_primary_index)
	{
		size_t n_base85_length = strlen(p_s_base85), n_base85_size = 0;
		int p_b85_ic_tab[128] = {0};
		{
			for(int i = 0, j = -10, k = 55, l = -62; i < 85; ++ i, ++ j, ++ k, ++ l)
				p_b85_ic_tab[(j < 0)? k - 7 : (l < 0)? k + j / 26 * 6 : "!#$%&()*+-;<=>.@^_,{|}~"[l]] = i;
			const char *p_s_src = p_s_base85, *p_s_end = p_s_base85 + n_base85_length;
			for(size_t n_diff, n_rem = n_base85_length; p_s_src < p_s_end;
			   p_s_src += n_diff * 4 + 1, n_rem -= n_diff * 4 + 1)
				n_base85_size += (n_diff = (p_b85_ic_tab[*p_s_src] == 84))? 4 : min(n_rem, size_t(5)) - 1;
		}
		size_t n_prehuff_size = max(n_base85_size, n_data_size);
		size_t n_temp_buffer_size = max(n_prehuff_size + n_huff_stage_size,
			n_data_size * (1 + sizeof(uint32_t)));

		uint8_t *p_temp_buffer, *p_data;
		if(!(p_temp_buffer = new(std::nothrow) uint8_t[n_temp_buffer_size]) ||
		   !(p_data = new(std::nothrow) uint8_t[n_data_size + 1])) {
			if(p_temp_buffer)
				delete[] p_temp_buffer;
			return 0;
		}
		p_data[n_data_size] = 0; // null-terminate the data

		{
			uint8_t *p_dst = p_temp_buffer - 1;
			const char *p_s_src = p_s_base85, *p_s_end = p_s_base85 + n_base85_length;
			for(size_t n_rem = n_base85_length; p_s_src != p_s_end; -- n_rem, ++ p_s_src) {
				if(p_b85_ic_tab[*p_s_src] != 84) {
					uint32_t n_block = uint32_t(min(n_rem, size_t(5))), n_code = 0;
					_ASSERTE(n_block >= 2);
					for(unsigned int i = 0; i < 5; p_s_src += ((++ i < n_block)? 1 : 0))
						n_code = n_code * 85 + ((i < n_block)? p_b85_ic_tab[*p_s_src] : 84);
					for(unsigned int i = 1; i < n_block; ++ i, -- n_rem)
						*(++ p_dst) = n_code >> (8 * (4 - i));
				} else
					*(uint32_t*)((p_dst += 4) - 3) = 0;
			}
		}
		{
			const uint8_t *p_huff_src = p_temp_buffer, *p_huff_end = p_huff_src + n_base85_size;
			_ASSERTE(p_huff_src + 16 * sizeof(int32_t) <= p_huff_end);
			const int32_t *p_code_num = (const int32_t*)p_huff_src;
			int p_max_code[16], p_table_off[16], n_code_num = 0;
			for(int i = 0, n_code_word = 0; i < 16; ++ i, n_code_word <<= 1) {
				p_table_off[i] = (n_code_num += p_code_num[i]) - (n_code_word += p_code_num[i]);
				p_max_code[i] = n_code_word;
			}
			const uint8_t *p_symbol = (p_huff_src += 16 * sizeof(int32_t));
			_ASSERTE(p_huff_src + n_code_num <= p_huff_end);
			p_huff_src += n_code_num - 1;
			uint8_t *p_dest = p_temp_buffer + n_prehuff_size, *p_end = p_dest + n_huff_stage_size;
			for(uint8_t n_byte = 0, n_bit_num = 7; p_dest != p_end; ++ p_dest, n_byte <<= 1) {
				for(int i = 0, n_code = 0;; ++ i, n_byte <<= 1) {
					_ASSERTE(i < 16);
					if(!((++ n_bit_num) & 7)) { // every 8
						_ASSERTE(p_huff_src < p_huff_end);
						n_byte = *(++ p_huff_src);
					}
					n_code = (n_code << 1) | (n_byte >> 7);
					if(n_code < p_max_code[i]) {
						_ASSERTE(n_code >= p_max_code[i] - p_code_num[i]); // n_code >= p_min_code[i]
						*p_dest = p_symbol[n_code + p_table_off[i]];
						break;
					}
				}
			}
		}
		{
			const uint8_t *p_rle_src = p_temp_buffer + n_prehuff_size,
				*p_src_end = p_rle_src + n_huff_stage_size;
			for(uint8_t *p_rle_dest = p_temp_buffer; p_rle_src != p_src_end;) {
				uint8_t n_code = *p_rle_src;
				bool b_compressed = n_code & 1;
				int n_run_length = (n_code >> 1) + 2;
				_ASSERTE(p_rle_src + ((b_compressed)? 2 : n_run_length) <= p_src_end);
				for(; -- n_run_length; ++ p_rle_dest)
					*p_rle_dest = (b_compressed)? p_rle_src[1] : *(++ p_rle_src);
				p_rle_src += 1 << ((b_compressed)? 1 : 0);
			}
		}
		{
			uint8_t p_buckets[256] = {0}; // each bucket value encoded as offset to its index
			uint8_t *p_data = p_temp_buffer, *p_end = p_temp_buffer + n_data_size;
			for(; p_data != p_end; ++ p_data) {
				uint8_t n_index = *p_data;
				*p_data = p_buckets[n_index] + n_index;
				for(int i = n_index; i != 0; -- i)
					p_buckets[i] = p_buckets[i - 1] - 1;
				if(n_index)
					p_buckets[0] = *p_data;
			}
		}
		{
			uint32_t p_buckets[257] = {0}, *p_index_list = (uint32_t*)(p_temp_buffer + n_data_size);
			const uint8_t *p_src = p_temp_buffer, *p_end = p_temp_buffer + n_data_size;
			for(uint32_t *p_dest_idx = p_index_list; p_src != p_end; ++ p_src, ++ p_dest_idx)
				*p_dest_idx = (++ p_buckets[*p_src + 1]) - 1; // start accumulating in bucket 1
 			for(int i = 1; i < 255; ++ i) // exclusive prefix sum
				p_buckets[i + 1] += p_buckets[i];
			uint8_t *p_dest = p_data + n_data_size - 1, *p_begin_1 = p_data - 1;
			for(uint32_t i = n_bwt_primary_index; p_dest != p_begin_1; -- p_dest,
			   i = p_index_list[i] + p_buckets[p_temp_buffer[i]])
				*p_dest = p_temp_buffer[i];
		}
		_ASSERTE(!p_data[n_data_size]); // make sure the terminating null was not overwritten

		delete[] p_temp_buffer;
		
		return p_data;
	}
};

#endif // !__DECOMPRESS85_H_FILE_IN_HEADER_INCLUDED
