/**
 *	@file Test_Compressed.h
 *	@brief file in header, generated from 'Main.cpp'
 *		using BWT / RLE / Huff / Base85 pipe
 *	@date 2016-06-30 12:20:35
 *	@author FileToHeader v2.03 (built Jul 19 2016)
 */

#pragma once
#ifndef __MAIN_CPP_FILE_IN_HEADER_INCLUDED
#define __MAIN_CPP_FILE_IN_HEADER_INCLUDED

/**
 *	@brief file in header, generated from 'Main.cpp'
 */
class CMain_cpp {
public:
	/**
	 *	@brief gets size of the data
	 *	@return Returns size of the data, in bytes, not including the terminating zero.
	 */
	static inline size_t n_Size()
	{
		return 53112; // matches original file
	}

	/**
	 *	@brief determines whether the stored string is dynamically allocated
	 *	@return Returns true if the caller of p_Data() needs to free the memory.
	 */
	static inline bool b_Dynamic()
	{
		return true;
	}

	/**
	 *	@brief gets CRC
	 *	@return Returns CRC32 of the stored data.
	 *	@note The stored CRC may differ from the original file if data processing was enabled.
	 */
	static inline uint32_t n_CRC32()
	{
		return 0xf208554c; // matches original file
	}

	/**
	 *	@brief gets data
	 *
	 *	@return Returns data of the file on success, 0 on failure (not enough memory).
	 *
	 *	@note The data (despite it may be binary), is additionally null terminated to make
	 *		it easier to use (the terminating null is not counted in n_Size()).
	 *	@note See also b_Dynamic().
	 */
	static inline char *p_Data()
	{
		const char *p_s_base85 = "~0RR910ssI20ssI21ONa41^@s62mk;82><{94gdfE4FCWD5dZ)H82|tP5dZ)H6aWA"
			"K8~^|S~009C80|W;K2.z@c4Ga$s5fBp+6&Dm17#SNK9~vPg93mbmBPSpvD<&!^Eio@JGcGwSK|DP)HZnCkMLPd"
			"eH$Or+Lq1zZOHoQhOifQtNk@HMKze*tP*QhUR)1l0RDOYPcwB&Sba{J,Vpv*(ZFP2IlWAp(NLOB8XL4+nqp7oK"
			"$Ia#S_i&k.p,u,<r>KIft%tR@yoia9)7IPFzhv=hl=.E_Qz3i@1R(+yPUM6jK!s3HQ3.S;L@SykBo|CoD21s+F"
			"OU_>AY6(eT=FC&As|4iWPu_S0;#bGNL46>Q({5{p!J|g5QGRoyTL(<pellcnnFN<W(o,tA{HQ^vJ%v3Z7hLx7$"
			"gedyu}bg-ZZr+g#{3<Q3ccuC<V0Kga}I$M1+M>h)@es$QL5W70MxT1#nPNA,}Amg4$$(3s74|mSDR|AcefD.JS"
			"U0dCDPF(I7&(WQ72_%#sAIZbA|Tv=*j,2o@(agn<IYX>|~ou4I7<0YPL75{O+upt1#1au9.lGD1NMiDV@JplMv"
			"9L@q$8G,@gXltO~YN(&(_C6Fi@Sc3fp5TFzS+F1gq(&Au{EJl.<Z!Cdw8d;sl5P={{3=ky+k,+$m2oR8k0IF4Z"
			"fe1nb3sYi1gt-E!C.Rnyfoci}P*Dotu2BjBY6}ohSqX74NK1&)sZ~-J0U-z$V4%q%3wSKZK.^WYWP}UObRhyl1"
			";iGhpoKtPX9NgHOOfe7kdTB3Lb%ezX;iBHfLuXAWD8NE7no^nE${;Vf{b4=WD8TJ2oeN>5JJoqL3zfM4K1TfGb"
			"DtFSO^pXg9L=2*pMVB1;}Y!vITHlfpvn^g#}kw($vWyOL;^qg3PiKxpkl+1S$zZiueIRl0p^BAXf#MRf)|Z0tB"
			"%dUZJJbc#;Hx0ut*QR~l6X0HCr3a|DE{3ITrT((;WhN+D)6u4IrUaizqv5mnYv3#e&o3IToKU4;;_8c<+.EWu,"
			"EgbT_vzn~NXxGuuT6ctQc#+P,~sM7mI5VnmgjV{rph|=&HS(+pWSd>D!Rj4R7Bp^zoOZyCx1fXekg1FM+Rbp8o"
			"c9cS>EJlb>ZbAeKpsr+)CCF)U8d;ekA!0PDG_g8T1Ry}FG_x9AMG&,.LW3lPF0&+rFYG9VnM5cWT9!brG,h%Ig"
			"8!hwAuoWk1q3E9kfImBG{2k{V6iNLRH76DsbnS83ITbHkdUfqgdu&>MwLvG1iFk868VOgoM}|5-e8cI#8C@TrB"
			"aAr>@Y$W&|fepEQG%CL@Y,nbqz1=8eK&Yy+ccg(t)Lz()X4.pt2HxTt=73LZC0aXoLxVQKbbCt~9#_mSqsX&@{"
			"6eT!xiKmw3|sf{7JSQ3~Y{t~9!am;B(jg4$UE,3({fwtds.pLF}D-9G8}Pr7~6.w|IDvJM~P5P!Un@P104SG<f"
			"A6qYf927Euj!}lq)+,&SzFm9<O3JRd=TF1no%l+ROgub&(Kk-)#F)5I)aLHZf@}Gh(aImJZuuh>%lw*U.%7}po"
			"C=U}UF(VtBC{qT1t<>ppN{&Z|@+WhqN5AA{C>kg}RGMXJOeP36$M9F~S*n~dNB3mKw|9B-;)OH~P$5a3^mP8(I"
			"Tb44.r1)QM5r5y$c8zCECksUxw%k;AIP9.c^FdL)47-W<%XSsrY4B|VkQqA)!LApP=AbBC^,^@zS0t^c{&7OiD"
			"{EIhzf5q{4S4uAf+hoG^%}UVgwq.NXcH*2^C08h<<|D6bnNg86T%<<3SP$4hh1RtxeSK5k*%A!r*A!$yQMegkT"
			"N9>1&|}_<Hx}aw~#ph2rUL2jkLYP~B70I9n$GbRA5nB4($HIx^0Z8rW2W>rHgYB9}mvploTlKO#Vz2AXovn<yh"
			"NnNW9L&cj1W6RQ3).EA|;4pD--&AD0N^iCZwN>!Lx-8~->mBS(+-GgDi(={ocuiOge38,F9#KE+J)ZGy<2tg^j"
			"O-F.x^dPhfgbL<TC=.lZ=AkfbTHZobAM(p$(EV7jbgG0O#F{~n^jBHz$G%+*knVL;BXLU<gZ5;SN+49pIdn{y#"
			"ZA-y3StmhW^R@<J)sK$W-E=TEj(T@fB)!-heSEnzsW^wOIknft#D|.*5BdsdFzfhuUewP,7zfI&w6Kh@;R4xg2"
			"J<BI$2wNs2DA(R,*pK,g)dG!=Qt!4o>}BhilS>nt;O-;r^sb5(Wt#Tq$^GT7zVuxuU5{.o}QhNDufwaHc}qG,f"
			"u%8tY&57Qs<m)5.RrE+ew3xua,{bg7a;7V^mcHBfaLUZ7VpLIqOD6~SUOyGpLm=ZSCd2F;^>ZnBs{.K*fKAM8J"
			"viULr6@&q$@whzjA&sB.^{()A9kgMK%b;qB_xnO@ueI(dlc1AxiM^XPO2,fxRu~=W{f^u6B(cQM8M4%B!@vmn6"
			"m;w-w7QS$Bc_+jOF;oc!QMy#7F*OQeWQY^FNJ|q>gDvt=aV>(PxlB4<^VbL!1AEd<H@|{.zxCoBl,,r_seh^sp"
			"DR0HY7L04N1V2&t!YOu-juebTixpIc$UUL&({YIlpR~gDh#LMo2o$fDvc_QE1f+;Xeh(UIE|{AEF39.!0E#bs2"
			"}TF&+lPxi>Kfm{W0f^@Jp-ASbogn#+*FM4~ZZ1f9T_L6l@M#&TVmK7I_|;ogM*0%O>uJrBCKw>*<NRBgCX!y9e"
			"m=(Ld!u>I4.YG5EJtoa(uPLJ|}jAp%fBz&sp4*GvQT6xUo}e&6KG_H7Qyoe*2j=qX~u4)cQiq5bWFgl#rri;C*"
			"w)9U*{%iceULG0!7;CK,=5V.XVDcWJaaiI(Nx92a@E^s4I<w;T#B.^@h#@uaMhERO;So,r@SYWSvS_LbxJ.o=R"
			"{.2%w)Ta!M691>s!{ecx,8~Z{DqGNL<hk94$l4K-W{RWWww@>Hcp|BIA<F7BhsPR1#BEe<RMO@}U&B*RE}o;Lr"
			"Xes7_(P,ac.)o1SPJ^Kn.3@gHz+oB<UomobL+5tt2L>ox-5jCq8Dh=+HA)eomMzOg$xQo>27%AHbt>O(OSW4(<"
			"y,36&ira1(Cmr=2@2W56zk5@u%hJ^TF&rG|L1Eqw=jz7*orDc}Ae<ulRz&P)p2kw@L9AIe6Vq7SHLn-v)!+e)u"
			"Ya#PmAT;W^v)Al@7UZ-MOFDEUIR1}!=drqr$wTRb&zY|N#rfS~dGCRDLQ4w@5{0m1O$Orh^Z6$L>f@NpJK>zI2"
			"pEcc$;>Wd)J21XCvJp{q@w2PTMxKawB,z>gq5bk.x{#o);r&T@K@0FG+L_)w%oLqbt=rC5).Wxh*xd!}Qa+_57"
			"T}){.9Qticd5p^q1Evk$Os7ojF5ORt{pAr~t@v>Z+IuGrT_WBZpFKJsxhV23z1d9QeUz)uPR{yn1SlF<n-y@%x"
			"fnoY2h;IIb}_A;9bQ^p*rBVBwU~SNpR>lC2I#*Pcyfm3Ez(TvigZ.&5TbBb!ti.F=0z.&lN!Vp$>9h0zAUeJ+4"
			"A)m6g7rJgl.qb6}ax>WXX!OFMFKNB1B^O8$-*QT%f~@2M8^2_te9h3qazK6TG*)mj.#&@fR1.pt3<#_<V>kHfE"
			"m=m(gsgFhr.LTlpiV^*2+HI>%NJbkLL!y3^TCi<nzhXHwY1!V7HlZpRbhs3HZECkuW_#>GiO^Ph,pGqn-i_Fqn"
			"k<&5lQao)+JgL4cS>he5HGe<(}I(XFXQgjxbDO3MnMwG1rDau2Jp@D^sj@%L)Y$vic+A@~8o%cxWlqgcSVyUe#"
			"om9==O5=_>Q_+fWdSYF~C9xIqGht{nqIu.Cr,)vtI=Xbt,m@8J=JC%ScR|#BC6*yb4yZadLIj(ZpcDkbq=FS7="
			";fw5;flyH@p2y};A~VYxX%iozbgZrmasG-B8qpQ&WAxiT*BFh9(rMF<GPN>+e#S~4Ek<ilbdtQw2536r_YABSU"
			"jf@$,FEnNhV8go!VS@tj-go-@8~1VE^QeE!&MK-LdSYC$kQU,E4{BG^sXQv7OnQ3CiYMjFT@%yfvC(XM(0G;$6"
			"y3fX9bg*FGm@_kEBLP@iyT@B{OjbRa^hM53UobG,<dimP(%9*YzHXs~m1pj6.(m|pe}sLi(u(A)FjJ=k=6nX@j"
			"0PIuUQGc=9SWK18j.0f0MU|d8qgYGR&b{b(7Lh&uCMd#vsd{bpWz+NOX5}CJi<$v-s#1;<V=TNH-g#i$M{_8x*"
			"zlfm=hWPWN&_}*u6KoE;Q8mfWKz76{9(qZ.W3u7x<&@K9U9oiX.>&m8IU=iw+kkqXy&*Dgw=5dLv#yi2HK9(3z"
			"=}K6|1U^AOsK+dXnZ!oW2D>AQF=X=Hih&>k8Q(ex1NwRLh<j#WOVJO+gg;xcJtG~;atZfJnz8W)<KF3L4}+t%z"
			"ia<MhFxi4FOrX6JVKGeRc-{YM<RpO$$WoMJcMPpsZC%Aj}ac>!B|W6YaKo)WXoD|0q)sqyng823bmEz)T;f3hH"
			">ATEwvetj;u*^71$.jHi,Hj_QO#>G4N)WzJXHOO=nWIfM6>jpr}M.I%Ik+aXy78s2A)7lWg*S}w5LT.=A=RehL"
			"Eky^910*i_ZBnaPO*4yVgKZXlj{<W}OA5Aeta7KD6VxOiAs|yK59X8dm6cAA7P1~Td$zYEDtDhauUD=H&Pi0vs"
			"p@T}Mj2Jzo8CWSK)bwdKT~Zrz-Lkx5W)Ge$#ywGtkgSJ}+T>*#bI{pQ,Eu(l&oa4$,GlZ_1r*E#)bb@Vw_>^$s"
			"|G%!#<b9mxeFNgx3#D;Vg(M#gg8BoAa9yzCA19IrWtuOwJLs}N;5V+67},zYn-ftsRI#_yb|%^S)pbc)GJf-d5"
			";*1aS=2!d@x2(W86(8Q)s8p)KffH69um&cszDGsX2A@O;G2CO<ei*#e@}JEd^$f_5%s#QYmwr8PC#G*+.k(x,t"
			"YmOB<Z^QBAtiQ*cqMLDGtE8RtW-V5O-wJstS;z+9!Iu+-{*>9gfHqPZ&Mofc1KJ9gkn21#d=x*kZinlNWpgVNK"
			"IrgT~unn5PZR+.yxEritn&vltxvT0!^6iOP73PURFMQT8VcvNJUkV@<%C6hT0YC#Q2l4=jck*3MjVQU#2Tn9!t"
			".5IZ!I*;I>f|_OUEiL6SE*%%,vC&-kDYmVdV9o0g@^GCmhW#,xmh47~W)-RaRmr<jaKj{VrYi))0lwF0>O)tws"
			"dYB&pBP<gG_@#&#A#wQu{)4~AV^CR$P^7Kl~)>Fg_7d4I$G&LfX|M5F*~dE_E4%1IP{*=O{*Fq!GtDKrW.__@Z"
			"uU,Q~jUTu3EJJY;p=_3oum$a8)RUyrLIS(%uTAOL>AjaKC{1mw8U!_r%>(_sSo.H2X!jpCaoYU)!itGSFtb&gm"
			"hUwR;rYyyvl;eNNu@.^!7s{yY$tAhiXUC^Y)bJs(zi!TnhtHg(ab__<rt_,CkRf1ag&Tb<n~_CbCY9EVcl3wdf"
			"St9a#96-#xA)D#;LUZ.F87P8{Enpi>7xR#JtDJOQ+9;MVi<=SDCwyt21QVlgT={@cOl^iON{VBii;9f,=t{v{9"
			"m2)YFkiAEef+P_{2w(e+%s|0%8X-_hps_5Nwv8-IJU>oCxs}i*nGdvhE0mx2TBkp_fBo1,(sMsd9+U_{JW,Hta"
			"4gI&M@Eog)~iourb,gp@_Yl8,vAYN%KmKvbw7zC)oxsK7(l%r2l,vL-1#q1{(krB_d,LSK8toAvf5qHX9jgvtq"
			"UT)X|=+VOcAS%X}40@5ci(fl-I-L$4mPwjI6Syu*&h4>h~oY5}>CcW;DCT)B>n4DNS}hvDVNJ5XbM2@UOsOKNy"
			"uw7=+f-a#Rk$q#n8Lq6UGu_&!#{)tEn+(Qv9Tn}p_4D7Kp=33m55J#bjJ8Auugfz;Xi-Z+sLhn7X~9wjI^J{&U"
			"n@W6=Lq!ww.VucFz7$OPcd@K+#6OpoY3WwaKG|ciqOq~p7^bctMRoD>#wFOXH&CA7RPZ9A8Vp3}0q>}@|R2@yp"
			"ZV*@90Qm(V_;raAGY#%D$hI_TPSsN<wvJ)~VE(F*;8244R;4pVN+6+JToex@)k.k2bqSF7UEzsOgyZuXN,gw}9"
			"S~(ZBrW<6*,1m!awDiU8ly-;8$P#!oS>3Nw87SAE0{|*QsD6#m.2d5CWBwsp}iTwf$@C#8(=HM^~QW&X~{sEFu"
			"6~F.$,,8,beqs;ofxgNumsSx;&sQarxts(Y|u-TFpkj)}=k7%%T(<xghec<L86W-&=EuF1G2|sT_,),W%o9Dz}"
			">+^<8NSr_0kUFNHyhn|c(}tEX+.;RUcv-cu3j,k.9Z*fF$(pKX4._$Vm69woaG*Hd<Qe!uF+VHK(W-b{y$y*@Q"
			"ZP2(v}6Tm((86ui~(c(5(qv2,6y4lfnb=kr,fd(;1#nlwW#hd-5X%KM#O*&|PtI;hCpUu!#50Bubf=9j8j)A&_"
			"e,(d)IpqUYgSjCLV.gsbJ<=KaUzJqZu&Q)eZ5<RIG|VJo4e1.(LF3cbtzhh*+2GwHi,}&6ve@p^$YK.N;6mq25"
			"NmPWRKo4qRKX&O4_,EC0VEWSM~X11Wz;A<cni@-DxwQgm8Pfpn2ixctm})I>iJHVVY6G(^eSOfQtu~nA%1Demo"
			"mI_#H.+M10.vFNdTX;-.k(7(3MDLtDITP.(@kN(b!iVBc*jK9x=U&xH@%5L9MNVYO52PM;UNkkd3!LTiYDtDVu"
			"jgnv-kaEeOI,(0JZF<9g*ChM%WPN#b2$H9mA5ET}w5,!||-n_em1%sp!z(0;UpgcM<D!,x>>pOPPuez(T;<-WB"
			"Z!=53XOgH>&aA.6Qt).AvJ+L)5GSbA6ndw*_Q}u)G(2,z&wuNqBgfDrrpn<KU!BnyZsM4rS%6<|3u=y$rFkC@Y"
			"X+YB23(jspgbSz^AgT*!X;4)Ut7(Vf@i#uAjQmh~SWJUKC^E<Rqx.rk(,i8qxOF^le@}o=r&#N4@OWxuk6AN,Y"
			"LxN(#u64;nJ5JIg.N@wrr|d{bAdqgk9uVjy,b2M&OEmALH%~iIrU|)qvS4Kdp4M!7=+1vF()HGaVDmZW7&-*Ly"
			";pulPRAAqh+ihvfwy5z9QlgM6Oa%2*N4+M&w2I^Pdp_%T_jKqQnj7u%!wHbagW5TdBoBR^>fLu;AHw6)F)w-(f"
			"8S#+)Z#Wl)cCIQi+_d;_GhUY-,&ZtN&=LAbexBB9S_C)48n1IckT^8y956-J0u63o-;z@-lU&|kP==,gCy;DjU"
			"zb{rB9a|E>uZz<aoiG+|_6UM#+++<A#aoeb=1t3s()4.khAUT}{W)28AjEqQDz%qlP#0d*VQV(RYAV_EL2X|j7"
			"3cy#8KBM9CeEDBPhhF8w$jW%u{W8gU2ikDLQjvN}L041hSPzoAu{NJ43gHR_t_q|rnoy#mA^4U=v>=$9D}^Cpk"
			"V}L2vU*W+r^6X.h^$-W,l&PFhIrgFCkJz<Lpjlg#3ggt=_s6pvQc9PP*60kb3mmX6SoL3jI7)O)NOGzlOJ$;u."
			"3k#C^,@z=8!M@2G_(kzW^$N{.d&oE$AO+CLgWu.WqcZl}aPS5z#<W<_Sx68c<-<OL+;4c+%<,TufG,#32HMM1+"
			"DC0GfbsY(%CCr!.AQ5Vw%I7$FMflTT@M5ZX{QplF3qP*Dm9m<fRA$UIzw9K$Tf;o+%jp<F#sp!8;bM<_ld4JdF"
			"qUl9Hty-pso$$0-i3VpmvZuUMS(;P>2ylr=eH$55y57<;eU%n4,{cEgpu_%|Or*amf3kbT@q)WIxL43t0&)abI"
			"!Gfc_;&gVpa)5SXxnxD4;UWh06~bT.7%K%}$pf2I;rMJ|Ap0H6ppaOeO9hGziu9zbg&.L^j<C}bk<Pi8OuwtMP"
			"*ohelt<Ty-+x)orK0F!d5t(SK*yLXf,W=yfM=;}he#-)c9.QO^m>AEDdHX_Fu_!^&l_qV-^8~ZMFv}46s{#W3g"
			"%KKxMF.8_XPu|pigoQgBon8UIB4E7zj;{#AXWqaC=NO)nVJTrb&ClssUU*Tu(|vYrEhw4m*A>gsIwL>{ITqX+&"
			"+gf=tVaruuz,gnq#8t{.DyhUL&;v.ibaj5>,^j-@l,P<~F&d14L;L5W&>>2xXj@L+*reasJe<s|G&8{;}b*Rj@"
			"q)<HukK6+l!jz%;pb1oGSCdrn_P+;gegXgpqr1ZrKb#R>VBNP,wfQvvVEvAn>qlZ)Bv-(|S&^xjSCUyE}.kG@n"
			"<@eZSEr,+=b|j3=@RE7BHc#5flv5MP%A-nK4wy4qDw%0}uF65rJI6*4L}xWE*Pi}RVM9Ic4H,CyK}6gZ=$*==q"
			"T*rRj>Xo0,=z4v@oK>eESb={F{Fyh*Bv%.oM=!i&dD%SbHz@{;;7g(QB>jfxDJVPhXJ;u+_f#zy(*{XVb^OihU"
			"@rn**kYryCY%.2U@{PeMi*#7P2!PvJ#CSPrwx9w~New.A*o>J>7=Oh>f<VuL%)i-bGNLK^,JPLJ1EJJ1APVy)*"
			"Ux;P)z+dQf<-3ZeL*!3a<btg;1DqxBzY5+G,$Y6h0_$QC1&1tm.(AW#YcR3;6,;Dhc9{02}aeXXYo1i~!dqicy"
			"oFWUzLZVEBLJ|^ZMK%gB#!R=0433DV%C=_~,F(Gx7m~{z*awP*5%,GSrf{1vHFHrU,_s$hvey-CL>DpVRr>RG|"
			"+@rhRQ+-$CH+,,5XdhMl#i!|~>bYx&)7E!<$GkPPAGRXZDwwq>zJC>E+wk0^{GV<NKN<|6F97a7=ZU-aL>yH9-"
			"Oir*3Q+uWycVIl4T_%#V~_a!r%tsG0PU{$%GDd;iA},RKZ4~X=(uZer>OLIY7l{cgf9X8*Btcqg1B|+93Y}Hf|"
			"fsX${*LfvIy%4xt9=S_msKWbDjqQNo<ao3S73pijLitH!ypM,7-M_eFte!@3qQ*ArN69dQ,SN%r=DTaOc1++#M"
			"VI48OR4;wN}<fvP|&g1JxMGq,(s9Q5tvKBM>n,A4yKjaH.tp810d1+lq.XYdXWWo!&P&XCK{85jneL$Veo@7x5"
			"&Y2^%hj2KaP1n(%!>SV+E#pgIrtV,4#vjf8~C^!!8vn!n;v#jBeG9Ws4joXp(,~jEZ{9iP5><=M*$7!kV=%{V$"
			"DZt-}(}h1zj5Y@jCY3jN>9+l1@o>4aJA7*$mG8Ms47m@L{sNw(hVkzBF+Dz,<Hu+GTX~<TB>r=m_-YlX@ci{WP"
			"EqlT^oipF<Tk$f,IPry(3NQA2{8i@n1aB*V#pWJVIQ<.{Mnl>9tzqzl&q*QNIuNXp0*H=<AY12dM28Mt,Vub@2"
			"eo7>J;-Ik^-NOL8Hs}zMs^eulYmocppdRLJQP-VF!t&!OmRl7X@>>f8o+N^}N9.R30>qlOuC!>gT{Tx%BDGDUC"
			"SpRPN69*KWJZXHC3lp#SHSgl)|F^3zUuN!3waNul^NWe|<#M!iO;G|I7tM.PmESU(D>BZEa%vmJ|5+ab!_cXAD"
			"a6(mMADN=DbPY>E&cnf1w1_^i+=p8{+9Yd.k4gu7n7SfxA-Z@o0tW1z-Bx#6sI#@~+k,v_,T!xnrS%QFgf~ec6"
			"|6MyLU)TKo=SYt-4T|S&RGxo,pjPd|1cUX$jHLz0da9X1lliL$rG+RV2t!s*3Tzf3,qc&c<4e.O{$tuUt_}{AY"
			"VfTM(*K|0)adty0K<5of8YK*L*(lSsBoxtL2tYYrd2+Gp9A6f1BiUbNzZs-7yDuPgYeYxe3^($HQC-C$OXJV3="
			"i>s3Wj^e{%VxqYt&_kaMSL2OusNt@nTy)wwwZ}JVRs!>K|8GPq=XV!7v(khskjJkU8qi7Z6@h*N7+xxOMR<Bg,"
			"r03T9;|)Q8wni+O@Vm<jle8U#+EH3wB;3I@L9Ex.2ce%Md&j_LtHy4aznO-vBc2$*!0NC${g0dfbJE+K>h#C4<"
			"vH-(^d!xJRZ7Vue+iK$Ex3n2npjVhK%cMd#4{!mo~{RK4a#-SadXbbWSViUY60iK}o2XKf8-f3|$x}KCIGz<_l"
			"+#M-oKw^Sdylrn9TuUh*<qRMfAo#T$E#}0TU{GL$C^,@%Bqce7;va4UC^Xk4P,y=55RnOs5v9bk6x_ifFPIfeF"
			"j|7S!2&>txL56)EKwj@gQ;yo_=AAF1b*q=eFv1eb14w|i)0q!6}d)=qR<aepTG|gdV})@KLB44U&0Ijz%RZF&I"
			"{}thy}<Z4v4TTHkmMVNJzvIMBqs-ro<rv%*jFY69=IxAdw0P9k~L,DagTi!_%}MXlc|Hf}6e.{o{AAK!HKA2uf"
			"DbrPdSX34>xmh+&9j#4qIx,@>8|mLY{hE0mzT1H;Y>cuWqI+EU)x|44OWG,E>9Y-;BYltc&Cqs&u.wvY9d$I!b"
			"+3*1xT|Blr#z|dHPR5F0w)IH1Zkd0v3;@VyT)UvC4OptHsT!Q$TU|^8394dnAFq5R8InhKCAI6u}>#4gPc,(Mh"
			"VsmKOO;B6y+_cH3S*02TvoL.m95FIdJiD%R{twYg6ow6ZU>(DES@Ox*A@t-Ja4l3Ma5#PQV-NF9tgbY@LHc<Fz"
			"&+)<UmY<y;PsRtZ>FR1ElzSmvps5)Qq=th9$=f4q$maZWjY1gG,R<5%%EVdTPT%NojPO^1fXw+<t<F3EJB^-Fp"
			"BCGsZ18m@V=n9gj_I%yfC<7w8OJOs4)Bzg^1Jb9M2NcA{EOaE+a|~2.9Wt(uhzRVpB1B%VPG-1G%$cR2#WwWZ="
			"s*Foi;9<4aMsQp^>>YEcxpYyBbkV1<B$vjzJ@r7nDKp&ADJK2@6(4YQHMGonbOka+VsZ3u&R$$Zh6-es6u5#LI"
			"W$iHAZAZtpGa^z9(txlf5pkquJ@hS2S<sXi)TK*n*%zTwgR2Lw;4+p$GScLIC9+@#q<8.@Aa}VQ5jg2%i!7.FD"
			"NNk-.B+8WCB,H$Nx)QZ0<>FbNo6!U4m<&3.eC4tQ,$aBOX#O.SKW-m*9ZGLMKOkM9YMdlJh|y%OStBm+jppxZC"
			"4bI6dV,~^vj@~Q*@#xA%Ffk^N3^3^d4XKR%W&fb7RQ-~V,AzWnvE-zP~d%w_KdBO1m+wzgTyV^G_GNi3;aV{Gc"
			"ewn=BZ2tsq8{^G_FBSnxob#i>%>$l8Ki50l+Gs3qz><qN1f_6EZwv%(R$V47Q0F>R^zSOfz8dFi0L@uM*7*w1-"
			"szFgx(tVVQucbGU)r8sapyJ!t|8o>U<RBDs{_dUuBJpfUN1blUiop@agtWDcWmurPpKK&nv-,axo3fl*v-L$HO"
			"2Q><xy0HCGQ^8%<&WfFA<iNj&A*2;o|bfi!m+}wd-&GNzl;&g9aX,r3Pl.|DK,wXds>^8tw0dFaY_Lkt3;vTz&"
			"{=mIKLG+|RP_kjcxkC8U4@-lCPx)A7MFtiJHwAM^MnI},xf4hp0>m9iK.>tar%G0dQ)vXQb4a3;Cg5_eVJL^#Y"
			")RQX-lK)YCu#H8l+dIY.MVy!;DW=U$NLS8n+&Z@k~u_EtREn>1VCp{&-g},C6I1_cN<Vq3%rHUAl|QrX>|L8t7"
			"+1~f=n9yuv|,cVkjWCCd3F_7G*kI^@Q&QnMGYHc@~89p$JDo{}cqkc<OAs.&dC.&^(s$^zQHrcbG_NuMyt5kBZ"
			"ErI8^oYn{qFV;8@2J=EFz_b4>HH$ikz-*B^~yX&iB2pz>^W34;_tLT+@-2Btn&DG;c3txg^N11Y=m(s4bj)WOG"
			"WhWAM<6i^l9VUsI0IpzGcgc@mv5H_<p<YU*TClX$x!D3<O4bG=WbqfNUs_wYrZhB~yjxh<XDhMkF+,|MH3zP=1"
			"weA!;L}g82c_=.3B-d)zwa3^~6ARju(7@kQelXzK>dw(i3lj_9Nu(Xx98~I+hqBHFmuc-moJ5q~P-NRvI$Xm|8"
			"F*L(w+2;GvRI#{aMm3(LRLi(QyS@QYiXz@YhlN2eZdiL-VKspRg^ShJs#0UCK!ti!f<&K77d_,HFKmL(N,r9R="
			"DYwCd)zz6;0czmXvibiSo+WUP(wOp$3MO&gajR#f_9HXbVHwh8bfzqaj@V{ME~1fxH-I%_c~$%%*{A=ZRE>dog"
			"5VoW@xgRH+zOz~QBh<#y{9>K.dUHu+4Y0$t-zkkYx(ft6z=,HvOGO,>QeMNUW814^tdl$Mh!t2^MV>KB8_69Q;"
			"cQ87X3NF=~Wcce@a2a%OjR+tMQP*Ec5(M*v^u{p^={1xI-<!Tv0WMI9=1RzLDG8Hs#ptpjkQszh+oI|4!P+N#9"
			"jV#T~V^.!<P!j;N3_pbSP~#z<2*_fa6c&(fW66V6I#XpNlnq.MiiE&ApK;1eX@vw.hVyxO3umkae<|bV28m{nQ"
			"z{zPGbx6daVc{DFjEj;Y$J#-,%Nw(3y@#rHe!S#IR+p314@KJ;@BLtI0z7aN||v#g(4Rcn3V53k=cOJ$5s)E@X"
			")^C=.V<6A%(&14~C$-OCV4SQzRf.U~{Na4bBRlS{rdcH7(5VafP~BG+xUFP*xviq.id_uxy(lqoSt79bJYBr$Q"
			"kyA#JwPyHh*}sU*3}P.#;<k(EMVr^%bBW7rN0Xu01~n+)*<w6_|MtT4na1+}KL,AcUTwn0o1sZ9xk=ct0Y^oEC"
			"OLEzXV3>(y{z!0Dpz*BcSTsP,lm.$2$sC#@0cpgYPcyYTyzZ^uWY=nd*19JtWFPKv0yUQpEs9~5cL6)VMYnf>d"
			">xF;mHhppzGS@PlLgG^$&rzkRN($wWE}^A~xd{T~zJc;zV0Znoz8a2}f}KPAN1~w$=sP!z=0q88CBnE&7(+JFr"
			"%aWgYt%5qGfP%URODrZl5Mzg.GC$.xu;o8I@a=->3WXJr8rX_@WT<.+r-OCn-YU0je>&)#O_&G-QXHQ<6*OEAt"
			"u8_)@PHQuQU*qCQSS>K3K5<21BK.iUk(&>T,q,puo>~bwQ+)#5~Xz>m6sP%OMGBG,{#O!FUvsbv$T6,5o6(95^"
			"HwRB^JQ!VE8<<1&a<Ix1}z0Z^yx25@xTF%dfh*1jOqQ!NNRDgwP@g^5HjwmnyYx<WVyLey)F96H1jCg8y_x,U~"
			"MLSG@XV8iSB-}r+4K)&!s@L!-G=o).CxdZP9a*bA_^en.H%po1i;taNjk9bDY4SGwiC81=lSuw$aAe>H(*dH%j"
			"6zJy.nTqGN&_W6gDNJDf<)(zxC-uR3gVCvOgk{LIg2b{dlo@0&oXoQY@~*+{-Q^7G3Z@.oz8h->8,x(C9f0=jE"
			"Rd=f|4=_E!vO@#9;GBu9_}VsGqYQNL5Aif<{DUyFYphF-dlc;qTs$Djv%^&kL57#jVP*77~IKEk&~$FloaGTg}"
			"(4C$7cl@Y)e5|>Mh)2.h*gQrao.7;rFOC;.oBP3qV+g.=fxYe.e*j>l#^|JOmO6NoXliKrBuhW(L78^cF!);Pn"
			"Zqm!$$)mPaV4VNupUlzi93Q48-4F7T#hsJ^EL$ADk>w5,msL1j{_b3zjo4lM=_g$QMMmdwJR07rN(v&6Wt!cbX"
			";wH@EuEtp=T!YXNC$SbtNq#DG@9|Jp}CJH%vlxcAV,=f,bKPf~iltO}uI0cw2!hPi!zxtbygD)R12noy;N;24;"
			"Et;JkZxKz4x~ESBb*o3L;%}!Aqy~G;5lUr<PA3LQl<Txun0ZDh1#ssDI17;4^#bc5RB3$!OSEZk8dn-!g;mc&p"
			"@Ia69s5i<7TybKOBm,HR3_y!G^tHHa_k=kiG(k}oyOOg6a)W^6~TUR--s)PAQTj}R1~7)nWAd}--%5{scIdIX="
			"<GtAT~j##vr<=,j(.>Xwt;N33dJ9t.*i3)T$jY5t#S%e1)nUy}^abU32(@4MS&W^;^qGF7nAWw8<d~r9M%A^cr"
			"7u|MC;5NE{A}ym&23F<TMt;izqc@^qaAdTGk<2!jLN)oiFmodc>~5M^hGt=fDmKXhQP8c1|vQu(7Y&pU$RJk.7"
			"@t35#RJV=BY@;GR4^DIMT0=Z8$oCl|{70<=V2+8.A#YOE~h!}xbXHVxIQ|276_Kidw_2&2p5V()Oo*,UMA4Mde"
			"e}_j_f<i)q6-yvlkdGD2G&l=0n)P*_BqPNY9}B.hvkw>j<D=>x<x}dB1yL%+A6rbm<ANaB))dtAN(IjvnFe9sw"
			"=i%~7XCus@Kr2<T;Px)A$6G{7_Yi}$FmJgyy5H~W*bA>mCg+|dL^8o79l-H2@5bn#A!fI@U_jJz@+WAI-Ngkw3"
			"N#3p,Fc=WC)JXok84%poAp{43J{6fx$$rQzf+m^M@LkTrXTf_zvAr9!rE=6-+OS6-UylaJp#;QQ~^#%2H258Ru"
			";cf8cPrkb+6Ml2i._8@7bp!ZbqfE~qaz&<nuHh&Nn&V&Qv~L#gC|My8Nr9F.j*3o.<^^)y=q%_.wA=Fn*BQ8&b"
			"L;OSuKkTgahzw8KupIPD(JHpUfWS9x4N9%<yZgL1>>.qj.a9J_x6@aE8H8.>4;3)%2rc)%7_J*Ps0tXB09azL5"
			"Y>,elGKqiu34+YotR6H$&>^9rrr@(()Tlpra)4V+ou)q(&kl~j&gG=Kfa=~gON78*d6rsGRPzpt,AZ=$zEPR>g"
			".@wQnYSLUBQC=0X&})wC%Bw(4IuHZXvn6HbfGDZ4,Y(aXy9PNL3$~OJCwimM<UcaI^fHYP^O,Oz7FLY=z!<=!R"
			"8rxhtZy+jcQ.4sH!%)fo2Q9=Y7,>0n|7Q{,m4==qQD>cU.wWBO@p+KwCoB9dd(o&T7G>fABK6b1iY%Z3V<>Kw|"
			"~77f0g_n1&dJP&,xv{~$-uIjjZ{SwNu6U|7x!rM-gd3G<E|8eq&U-9bUY%M(r0GucT<CDEx(lH9sn>FOyZ0tuD"
			"0qKAp%VnSk)UA_PO2h^a_rn@_~$Nyue;RFeG8W>c1Y5xd4OCZwb>2tnjn-,SRs4I+R1FHOH9|=)hJry,K4Kb>Z"
			"CD>bgA7O(*TA3+9FnEyACNT@giMdEA6SycgN;y@+x#^%Lpg@HA4Z*@$DWoh%3lXvwCJ7W-oZ4W7#|GpeV|tcSR"
			"s&c!QV3}>uL7f(3B(p95Uyn@sZ}V&a|#8iv~x.S8d;V=u3<efn#3^F%R3!m3x$UQ32;(OaSrXHrGEfdthKi%3I"
			"cwDi2N5fEP@!8Wf<,aVr)S&$Goy.Zfs(i2gn}tNRh!XTf,{TDVeek6_BTtaJ$Br-97=O_fO{y^#!Qa,wKBr<sB"
			"9yOYA8HH-<0@3=l0YWY|PvWV-=B+9-wj#+US(WDO6HVgIzk7<RyPVmFr|r3I1}p<Ka1Xbb-7Pa&m3YCY-(mtfL"
			">,rs5EjS<pj3_8sMoJ(yDF+6$fFl5URrs>nb!a-K!bLt7HN>O%$g}I4>L_WfjpA$q%X.(!HI4A,LB!8|CupP~e"
			"=Rn&Z.J|g=GXqn|a=O95V*$I=3a2z9fQHl=P5XPf_0+dv)k>HoQF0qzVvSPerNX(vh)5+tlrENA5$#!y>gNgwq"
			"7wJq7Sf$9@e0&+.Sh)*,vP,{b<12z3L#t;^8_CYxo@-+Q,UwONw(rF9<um,Uz9ohv8--5^=3Kc<}Gn}KyZSYTD"
			"h8YGeEw9.qBzfFWoK7F@ouYDuSp!vW!<ZBVrh51)18a5pbutwg9d^3JO@qw8^~oVY3rrFfF|4gVRIJLtVjuLds"
			"=K8<Q9&,p0$g6l3BXF$b7V(5w{6.1MxQ69ZiMh8dRS(pm%A)(eq^%yh;B&)Pm~><)DWQph>)1&M>8wfYC*S)4E"
			".NZ3MvP<nWv%M)OpVUjSW^G&hB*+~fDaGc99c$qDo!<a0Bn1oam8EB2o^&e70LIyF5XLjBP2FXgLl&e5#_|BgY"
			"i69tSrv!QZ-alAsu6US9,pltvc.q~LnC^bj,xMY(7g3k@i3j;k4gR9YhgdjRAu1q;iu6&{P.B7f>IHLTf+Tf0p"
			"n<fdTpR*}(1JuaER;0|HpH7*H*%6V358-sw8BQz4<4@Z{A<c.LgZ0v)u>DueokelFyqL3lpN_m,hrj9.#$uS(w"
			"I;>u,+BsqNjAhjq+(gVy<-5#;&2dP1^PXsYEC;K!wC9QrFXmlM@Gh2L|nj->I<~Vo.wLgHKY(7hrPg4*&HOor|"
			"c$V2mKywEeakW%i16SCkLA!NCgb7@)J;g2bXS_Y}lfg&.w#K~<n68@~DCV>1{qLaCAvC<O-O2$nc1nDHo@sL=_"
			"9(ec!OUG|iMnV5LwAHZ(1sHKr|lodhdHttyq$KDeMra~C_%Pb>m927+HETDLU>oloAYf-GA-QS_iY_6w{Nf#wS"
			"$Tkb8*&|5wJi=f+wFOY7@~VPRQ3.&n5P.C01XVb72Mg8-sxbtJ5KTio%_(WfG2Ugh=zD2XNj<=(;ZIQLvkkrB$"
			"^rF<7!PGZT(@Es%XuX}pq|00#4iKaexUyt,Z3-U1r;w-#K$a<mP$~1T53r{Tmzu=9^Syc$EOO0uyfpKVq%z}vJ"
			"%A097Cx<VTsW^>uOLJh+pI^$XtU;hfeTN9{2~CI+{xewSROXp@l}Y#5KfgJ|(B&%5w.cTci{QT7v(4(FfZF|4="
			"+md_Gg|Dy5o@r8AlO0n|D_Ku#d4H-{pSx9VZ>j&<rVVvU)aNyH(1Lx}GS_ms$Zjjp1LCv!#!OR&ixmj.!c9Y4l"
			"6Eg-uJQQ_qYs69*=iGW{WgoKd25RSj5<eg=iFzUXnW%O;b,srOUC${fZ;Zr!r2Y4wIbvH>>E{>Nzc_x&aPNW!G"
			"YgdUj($Zj5aXTJf8PhG8LHrrb=hw00gefgbXTH>%NhHqNU{<PD=J0h*f-OS;nh+&Z+N!LnrW6YVMpJ@NZb1}.R"
			"D;I,sW5aY6cVfy+MP|&Y%$vr!D4*7XA}<)z-hxLZOUfStyAgpgE!6vm36|I#2,W,ggZl}Dtu,a1XC5h)4Z_@dU"
			"!xQ%(1w|1Wp0ACsK<Xs%)B^7;C)Ky!0I-f{CapDRK#crBSa4D2h~SkYtJjxKCM6j9+Nc$j3}h=@^6(nw}$F7d;"
			"eoLlY2.QszyB&k@Yj%0.53qeD,@0k!{eqjK1wHfj{}2P&uq.mSjHQ3fdVqvF.jPpDT5W@%WhsB!ExM&2mXY3RZ"
			"M$ug)!Qj6SVi7MbNQmM>bv{LWDq$+xW.*(vJlyNm1U$_h2H5@}qn=724$F>ZY6Bk|~@#aHgxcYD4aJeH4iGWZO"
			"1-Nc7gT=BpShgBW8v>UJgU0d%2oNL>6H2h%KUUDk_6F5UAoKizx}iNoqVpC*<JcMe2IN>-g2c(7=vN0*Bv2lsY"
			"vwX%r.|WnRMRs~fMu1!drKh7rK}32nkSJ-YNtXcat4EiLY,Bnfk6TUC@g_^6hiw8e+Vm%is3ne.FYyeMwQEN3i"
			"(VERNoZo2tfmoU+|5u,NrHDEHDag%y,qRrmU)l#c}RiLU@PVgGMCPJIYCoP817=SX(ezn~}t&(T.()#n@=%L2s"
			"C)U)7nC4oUWuSiU1l0=+>sDM7(zWU)77wumrLeLgZagq}yQ0=;8GmXMSJgX%!oA+w<5OjysMs$hIR23NJh*q<)"
			"Nkc_E$Oe#4PgiJA1@<bY*GaA~HkwpiQl(}T=v.8>RDT8I=4<;u.EsH!1sZ_Muek^HtzBdVhh$RM0n~MGibckLP"
			"l7kE>2hV9^p-,l<ah;f8=D0DzG,U4gDp3mK!BiX@kRc&KL@ZCl#0~<mtDza&3z!i.r7Co~Q%X(CTB^HF6.P_+%"
			"y4~n&j)5uQB|B$5RtPUd$BreeL*2Bt=mc^meIG^Idwl~K.sm+l9*q1cF.VZT!;i+1VH8>FoDxbjv^1I0@BG4=H"
			"Y@S0VpB{sc@#JwE_|llR(5Q#^0zdP@m2d=LG{%Qj,<~Vme2d*_#PORNSn~64k+f.=)5v5C1WQ1t+{B<Kfi>m)N"
			"~Ih2X-6bsQ,Nj36oRI55l=IXi,Q2<!(3M4+W*$y@*27<qzfKZ1}LT*^nbk27@wcT_dFC<RcD>.nocY07AU!9>&"
			"zDuaUvX6FN>RQ_cJO9EX2eqxr1><&s~S!F2%jHX2@WqiUdQ!6Zwb{%18F!h;_us2*6BAkbrMw|k~qZfE%{z2~9"
			"a8(aKl+x%zA!sFvAN+%baIfu;dh.Ah{G&_2=K-kY1i,Tg&Wd>&R_GlwD2{zaEI1wW%(f%ysfRQ1t#d8t#LqK@W"
			"1dpBVoV(~&d}>XlzAZ8o&.3ZaPyoeizrw&Vl}(_N6Kno%aMp$3.{*b(4D2O3(Rcs1T-(s7+fvX8>(eAC@Yl2a1"
			"-{5R9~(%x{S45mg-({^hVPw=EkmUM%U3am._-d%s2BmZR!f#ZrG1x{R7c&G)Rdi10S>#-X0i-MkhHS@{7jJKLM"
			"t|*bB@a%*XR{s4A90_whW4AE@RVh8Q>wFdmFd8wcPV.iR!%1I4s8xc5$_7{39}zi4>AZ4T2cOtc_8kQ;W7vao5"
			"o$Q^S$NgTtrdb1!m=23L-fRD;$%9Yb|#M6n;n%l&+B<g|P+_xb4^C^UE@HaeJGUje,PFfVXRW>1r6~g{=M%0}#"
			"i1AsL)-OBGisE#5y!*A_dNYEHCvu2Y4;{=rtfzfPUGQ0GJVOl6T$C*%{DJCJ4}-wBSx%uq>bi~H8;K+-,=y_(r"
			"ORR$fw!pax,x$5x8MZ_48$86PNg,DFttO%2hMdZ-i<yZ2rNy.RZT<1+Hm>{XZgPwsruIrxG;zdVh#hU4u#.eLW"
			"n8n3Em5+CZ(Gk275t&>N;oRJw3fasydV(J#N=WH#1^bdM^bKSZP^W52}f>3)*Ur9vwGD8Crr}psE+C!b%Q=;XH"
			"x&gupH)PBuE_2b1Om4l=3hJ~MCKKIu}O$$z{)#k6T$!67faVdF#b<_~$Nat*.ORVcpl%s-=OTM%954GDMx{(=6"
			"9|EMd7EJoMgIvP7LH(X-WwjX=)<N";
		return (char*)p_Decode_BWT_MTF_RLE_Huff_Base85(p_s_base85, 53112, 27897, 18103);
	}

protected:
	/**
	 *	@brief decompression routine
	 *
	 *	@param[in] p_s_base85 is null-terminated string containing Base-85 encoded compressed data
	 *	@param[in] n_data_size is size of the decompressed data
	 *	@param[in] n_huff_stage_size is size of the compressed data before Huffman encoding
	 *	@param[in] n_bwt_primary_index is primary index for the BWT algorithm
	 *
	 *	@return Returns pointer to the decompressed data on success, 0 on failure.
	 *
	 *	@note The data (although it may be binary), is additionally null terminated.
	 */
	static uint8_t *p_Decode_BWT_MTF_RLE_Huff_Base85(const char *p_s_base85,
		size_t n_data_size, size_t n_huff_stage_size, uint32_t n_bwt_primary_index)
	{
		size_t n_base85_length = strlen(p_s_base85), n_base85_size = 0;
		int p_b85_ic_tab[128] = {0};
		{
			for(int i = 0, j = -10, k = 55, l = -62; i < 85; ++ i, ++ j, ++ k, ++ l)
				p_b85_ic_tab[(j < 0)? k - 7 : (l < 0)? k + j / 26 * 6 : "!#$%&()*+-;<=>.@^_,{|}~"[l]] = i;
			const char *p_s_src = p_s_base85, *p_s_end = p_s_base85 + n_base85_length;
			for(size_t n_diff, n_rem = n_base85_length; p_s_src < p_s_end;
			   p_s_src += n_diff * 4 + 1, n_rem -= n_diff * 4 + 1)
				n_base85_size += (n_diff = (p_b85_ic_tab[*p_s_src] == 84))? 4 : min(n_rem, size_t(5)) - 1;
		}
		size_t n_prehuff_size = max(n_base85_size, n_data_size);
		size_t n_temp_buffer_size = max(n_prehuff_size + n_huff_stage_size,
			n_data_size * (1 + sizeof(uint32_t)));

		uint8_t *p_temp_buffer, *p_data;
		if(!(p_temp_buffer = new(std::nothrow) uint8_t[n_temp_buffer_size]) ||
		   !(p_data = new(std::nothrow) uint8_t[n_data_size + 1])) {
			if(p_temp_buffer)
				delete[] p_temp_buffer;
			return 0;
		}
		p_data[n_data_size] = 0; // null-terminate the data

		{
			uint8_t *p_dst = p_temp_buffer - 1;
			const char *p_s_src = p_s_base85, *p_s_end = p_s_base85 + n_base85_length;
			for(size_t n_rem = n_base85_length; p_s_src != p_s_end; -- n_rem, ++ p_s_src) {
				if(p_b85_ic_tab[*p_s_src] != 84) {
					uint32_t n_block = uint32_t(min(n_rem, size_t(5))), n_code = 0;
					_ASSERTE(n_block >= 2);
					for(unsigned int i = 0; i < 5; p_s_src += ((++ i < n_block)? 1 : 0))
						n_code = n_code * 85 + ((i < n_block)? p_b85_ic_tab[*p_s_src] : 84);
					for(unsigned int i = 1; i < n_block; ++ i, -- n_rem)
						*(++ p_dst) = n_code >> (8 * (4 - i));
				} else
					*(uint32_t*)((p_dst += 4) - 3) = 0;
			}
		}
		{
			const uint8_t *p_huff_src = p_temp_buffer, *p_huff_end = p_huff_src + n_base85_size;
			_ASSERTE(p_huff_src + 16 * sizeof(int32_t) <= p_huff_end);
			const int32_t *p_code_num = (const int32_t*)p_huff_src;
			int p_max_code[16], p_table_off[16], n_code_num = 0;
			for(int i = 0, n_code_word = 0; i < 16; ++ i, n_code_word <<= 1) {
				p_table_off[i] = (n_code_num += p_code_num[i]) - (n_code_word += p_code_num[i]);
				p_max_code[i] = n_code_word;
			}
			const uint8_t *p_symbol = (p_huff_src += 16 * sizeof(int32_t));
			_ASSERTE(p_huff_src + n_code_num <= p_huff_end);
			p_huff_src += n_code_num - 1;
			uint8_t *p_dest = p_temp_buffer + n_prehuff_size, *p_end = p_dest + n_huff_stage_size;
			for(uint8_t n_byte = 0, n_bit_num = 7; p_dest != p_end; ++ p_dest, n_byte <<= 1) {
				for(int i = 0, n_code = 0;; ++ i, n_byte <<= 1) {
					_ASSERTE(i < 16);
					if(!((++ n_bit_num) & 7)) { // every 8
						_ASSERTE(p_huff_src < p_huff_end);
						n_byte = *(++ p_huff_src);
					}
					n_code = (n_code << 1) | (n_byte >> 7);
					if(n_code < p_max_code[i]) {
						_ASSERTE(n_code >= p_max_code[i] - p_code_num[i]); // n_code >= p_min_code[i]
						*p_dest = p_symbol[n_code + p_table_off[i]];
						break;
					}
				}
			}
		}
		{
			const uint8_t *p_rle_src = p_temp_buffer + n_prehuff_size,
				*p_src_end = p_rle_src + n_huff_stage_size;
			for(uint8_t *p_rle_dest = p_temp_buffer; p_rle_src != p_src_end;) {
				uint8_t n_code = *p_rle_src;
				bool b_compressed = n_code & 1;
				int n_run_length = (n_code >> 1) + 2;
				_ASSERTE(p_rle_src + ((b_compressed)? 2 : n_run_length) <= p_src_end);
				for(; -- n_run_length; ++ p_rle_dest)
					*p_rle_dest = (b_compressed)? p_rle_src[1] : *(++ p_rle_src);
				p_rle_src += int(1 << ((b_compressed)? 1 : 0)); // fix an x64 warning here
			}
		}
		{
			uint8_t p_buckets[256] = {0}; // each bucket value encoded as offset to its index
			uint8_t *p_data = p_temp_buffer, *p_end = p_temp_buffer + n_data_size;
			for(; p_data != p_end; ++ p_data) {
				uint8_t n_index = *p_data;
				*p_data = p_buckets[n_index] + n_index;
				for(int i = n_index; i != 0; -- i)
					p_buckets[i] = p_buckets[i - 1] - 1;
				if(n_index)
					p_buckets[0] = *p_data;
			}
		}
		{
			uint32_t p_buckets[257] = {0}, *p_index_list = (uint32_t*)(p_temp_buffer + n_data_size);
			const uint8_t *p_src = p_temp_buffer, *p_end = p_temp_buffer + n_data_size;
			for(uint32_t *p_dest_idx = p_index_list; p_src != p_end; ++ p_src, ++ p_dest_idx)
				*p_dest_idx = (++ p_buckets[*p_src + 1]) - 1; // start accumulating in bucket 1
 			for(int i = 1; i < 255; ++ i) // exclusive prefix sum
				p_buckets[i + 1] += p_buckets[i];
			uint8_t *p_dest = p_data + n_data_size - 1, *p_begin_1 = p_data - 1;
			for(uint32_t i = n_bwt_primary_index; p_dest != p_begin_1; -- p_dest,
			   i = p_index_list[i] + p_buckets[p_temp_buffer[i]])
				*p_dest = p_temp_buffer[i];
		}
		_ASSERTE(!p_data[n_data_size]); // make sure the terminating null was not overwritten

		delete[] p_temp_buffer;
		
		return p_data;
	}
};

#endif // !__MAIN_CPP_FILE_IN_HEADER_INCLUDED
