/**
 *	@file Test_TextMode.h
 *	@brief file in header, generated from 'Main.cpp'
 *		stored as plain text
 *	@date 2016-06-30 12:20:35
 *	@author FileToHeader v2.03 (built Jul 19 2016)
 */

#pragma once
#ifndef __MAIN_CPP_FILE_IN_HEADER_INCLUDED
#define __MAIN_CPP_FILE_IN_HEADER_INCLUDED

/**
 *	@brief file in header, generated from 'Main.cpp'
 */
class CMain_cpp {
public:
	/**
	 *	@brief gets size of the data
	 *	@return Returns size of the data, in bytes, not including the terminating zero.
	 */
	static inline size_t n_Size()
	{
		return 53112; // matches original file
	}

	/**
	 *	@brief determines whether the stored string is dynamically allocated
	 *	@return Returns true if the caller of p_Data() needs to free the memory.
	 */
	static inline bool b_Dynamic()
	{
		return true;
	}

	/**
	 *	@brief gets CRC
	 *	@return Returns CRC32 of the stored data.
	 *	@note The stored CRC may differ from the original file if data processing was enabled.
	 */
	static inline uint32_t n_CRC32()
	{
		return 0xf208554c; // matches original file
	}

	/**
	 *	@brief gets data
	 *
	 *	@return Returns data of the file on success, 0 on failure (not enough memory).
	 *
	 *	@note The data (despite it may be binary), is additionally null terminated to make
	 *		it easier to use (the terminating null is not counted in n_Size()).
	 *	@note See also b_Dynamic().
	 */
	static inline char *p_Data()
	{
		const char *p_text_array[] = {
			"/*\r\n"
			"								+----------------------------------+\r\n"
			"								|                                  |\r\n"
			"								|    ***   File to header   ***    |\r\n"
			"								|                                  |\r\n"
			"								|   Copyright \xa9 -tHE SWINe- 2009   |\r\n"
			"								|                                  |\r\n"
			"								|             Main.cpp             |\r\n"
			"								|                                  |\r\n"
			"								+----------------------------------+\r\n"
			"*/\r\n"
			"\r\n"
			"#include \"../UberLame_src/NewFix.h\"\r\n"
			"#include \"../UberLame_src/CallStack.h\"\r\n"
			"#include <string.h>\r\n"
			"#include <stdlib.h>\r\n"
			"#include <stdio.h>\r\n"
			"#include <vector>\r\n"
			"#include <string>\r\n"
			"#include <algorithm>\r\n"
			"#include \"../UberLame_src/Integer.h\"\r\n"
			"#include \"../UberLame_src/Tga.h\"\r\n"
			"#include \"../UberLame_src/Jpeg.h\"\r\n"
			"#include \"../UberLame_src/MinMax.h\"\r\n"
			"#include \"../UberLame_src/StlUtils.h\"\r\n"
			"#include \"../UberLame_src/Buffer.h\"\r\n"
			"#include \"../UberLame_src/Compress.h\"\r\n"
			"#include \"../UberLame_src/Base64.h\"\r\n"
			"#include \"../UberLame_src/Base85.h\"\r\n"
			"#include \"../UberLame_src/Crc.h\"\r\n"
			"#include \"../UberLame_src/Dir.h\"\r\n"
			"\r\n"
			"#if defined(_MSC_VER) && !defined(__MWERKS__) && !defined(for) && _MSC_VER <= 1200\r\n"
			"#define for if(0) {} else for\r\n"
			"#endif // _MSC_VER && !__MWERKS__ && !for && _MSC_VER <= 1200\r\n"
			"// msvc \'for\' scoping hack\r\n"
			"\r\n"
			"#define APP_VERSION \"v2.03\"\r\n"
			"\r\n"
			"bool ReadFile(TBuffer &r_t_output, const char *p_s_filename)\r\n"
			"{\r\n"
			"	FILE *p_fr;\r\n"
			"#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\r\n"
			"	if(fopen_s(&p_fr, p_s_filename, \"rb\"))\r\n"
			"#else //_MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\r\n"
			"	if(!(p_fr = fopen(p_s_filename, \"rb\")))\r\n"
			"#endif //_MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\r\n"
			"		return false;\r\n"
			"	int n_length;\r\n"
			"	if(fseek(p_fr, 0, SEEK_END) ||\r\n"
			"	   (n_length = ftell(p_fr)) < 0 ||\r\n"
			"	   fseek(p_fr, 0, SEEK_SET)) {\r\n"
			"		fclose(p_fr);\r\n"
			"		return false;\r\n"
			"	}\r\n"
			"	if(!r_t_output.Resize(n_length, false)) {\r\n"
			"		fclose(p_fr);\r\n"
			"		return false;\r\n"
			"	}\r\n"
			"	if(fread(r_t_output.p_Data(), n_length, sizeof(uint8_t), p_fr) != 1) {\r\n"
			"		fclose(p_fr);\r\n"
			"		return false;\r\n"
			"	}\r\n"
			"	fclose(p_fr);\r\n"
			"	return true;\r\n"
			"}\r\n"
			"\r\n"
			"bool ReadFile(std::string &r_s_output, const char *p_s_filename)\r\n"
			"{\r\n"
			"	FILE *p_fr;\r\n"
			"#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\r\n"
			"	if(fopen_s(&p_fr, p_s_filename, \"rb\"))\r\n"
			"#else //_MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\r\n"
			"	if(!(p_fr = fopen(p_s_filename, \"rb\")))\r\n"
			"#endif //_MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\r\n"
			"		return false;\r\n"
			"	int n_length;\r\n"
			"	if(fseek(p_fr, 0, SEEK_END) ||\r\n"
			"	   (n_length = ftell(p_fr)) < 0 ||\r\n"
			"	   fseek(p_fr, 0, SEEK_SET)) {\r\n"
			"		fclose(p_fr);\r\n"
			"		return false;\r\n"
			"	}\r\n"
			"	r_s_output.erase();\r\n"
			"	if(!stl_ut::Resize_To_N(r_s_output, n_length)) {\r\n"
			"		fclose(p_fr);\r\n"
			"		return false;\r\n"
			"	}\r\n"
			"	if(fread(&r_s_output[0], n_length, sizeof(char), p_fr) != 1) {\r\n"
			"		fclose(p_fr);\r\n"
			"		return false;\r\n"
			"	}\r\n"
			"	fclose(p_fr);\r\n"
			"	return true;\r\n"
			"}\r\n"
			"\r\n"
			"void EscapeString(std::string &r_s_str) // throws\r\n"
			"{\r\n"
			"	for(size_t i = 0, n = r_s_str.length(); i < n; ++ i) {\r\n"
			"		if((uint8_t(r_s_str[i]) < \' \' && r_s_str[i] != \'\\t\') || // keep tabs, we "
			"like it\r\n"
			"		   r_s_str[i] == \'\\\'\' || r_s_str[i] == \'\\\"\' || r_s_str[i] == \'\\\\\')"
			" { // need to handle quotes\r\n"
			"			char n_seq = 0;\r\n"
			"			switch(r_s_str[i]) {\r\n"
			"			case \'\\n\':\r\n"
			"				n_seq = \'n\';\r\n"
			"				break;\r\n"
			"			case \'\\r\':\r\n"
			"				n_seq = \'r\';\r\n"
			"				break;\r\n"
			"			case \'\\\\\':\r\n"
			"				n_seq = \'\\\\\';\r\n"
			"				break;\r\n"
			"			case \'\\\'\':\r\n"
			"				n_seq = \'\\\'\';\r\n"
			"				break;\r\n"
			"			case \'\\\"\':\r\n"
			"				n_seq = \'\\\"\';\r\n"
			"				break;\r\n"
			"			/*case \'\\t\':\r\n"
			"				n_seq = \'t\';\r\n"
			"				break;*/ // keep tabs, we like it\r\n"
			"			case \'\\f\':\r\n"
			"				n_seq = \'f\';\r\n"
			"				break;\r\n"
			"			case \'\\a\':\r\n"
			"				n_seq = \'a\';\r\n"
			"				break;\r\n"
			"			case \'\\b\':\r\n"
			"				n_seq = \'b\';\r\n"
			"				break;\r\n"
			"			case \'\\v\':\r\n"
			"				n_seq = \'v\';\r\n"
			"				break;\r\n"
			"			};\r\n"
			"			// see if we can find escape sequence for this character\r\n"
			"\r\n"
			"			if(n_seq) {\r\n"
			"				r_s_str[i] = n_seq;\r\n"
			"				r_s_str.insert(i, 1, \'\\\\\');\r\n"
			"				++ i;\r\n"
			"				++ n; // !!\r\n"
			"			} else {\r\n"
			"				char p_s_xseq[64];\r\n"
			"				stl_ut::Format(p_s_xseq, sizeof(p_s_xseq), \"x%02x\", int(r_s_str[i]))"
			";\r\n"
			"				r_s_str[i] = \'\\\\\';\r\n"
			"				r_s_str.insert(i + 1, (const char*)p_s_xseq);\r\n"
			"				size_t l = strlen(p_s_xseq);\r\n"
			"				i += l;\r\n"
			"				n += l; // !!\r\n"
			"			}\r\n"
			"			// escape low characters\r\n"
			"		} else if(uint8_t(r_s_str[i]) >= 128) {\r\n"
			"			char p_s_xseq[64];\r\n"
			"			stl_ut::Format(p_s_xseq, sizeof(p_s_xseq), \"x%02x\", int(uint8_t(r_s_str["
			"i]))); // make sure it is not negative\r\n"
			"			r_s_str[i] = \'\\\\\';\r\n"
			"			r_s_str.insert(i + 1, (const char*)p_s_xseq);\r\n"
			"			size_t l = strlen(p_s_xseq);\r\n"
			"			i += l;\r\n"
			"			n += l; // !!\r\n"
			"			// escape big characters\r\n"
			"		}\r\n"
			"	}\r\n"
			"	// todo - not sure what happens if \"\\x12\" escape sequence is followed by a [0-9"
			"a-f] letter?\r\n"
			"	// maybe need to escape even simple letters until the next letter is another one\r"
			"\n"
			"}\r\n"
			"\r\n"
			"// t_odo - skip mutliline comments, actually not that hard, first erase the single lin"
			"e comment,\r\n"
			"// then just make sure that there is no \"\\\"\" before the \"/*\" and then erase ever"
			"ything up to the next \"*/\"\r\n"
			"// not checking for the line comments\r\n"
			"\r\n"
			"// note that decoupling comments from printing would make it much easier\r\n"
			"\r\n"
			"/*void Strip_LineComment(std::string &r_s_comment, std::string &r_s_line,\r\n"
			"	size_t n_line, size_t n_line_num, uint64_t &r_n_file_size)\r\n"
			"{\r\n"
			"	r_s_comment.clear();\r\n"
			"	// !!\r\n"
			"\r\n"
			"	size_t n_pos;\r\n"
			"	if((n_pos = r_s_line.find(\"//\")) != std::string::npos &&\r\n"
			"	   (r_s_line.rfind(\'\\\"\', n_pos) == std::string::npos ||\r\n"
			"	   r_s_line.find(\'\\\"\', n_pos) == std::string::npos) && // not arround strings,"
			" seems dangerous (can have strings before or in, but not on both sides)\r\n"
			"	   (r_s_line[r_s_line.length() - 1] == \'\\n\' || (r_s_line[r_s_line.length() - 2]"
			" == \'\\\\\' &&\r\n"
			"	   r_s_line[r_s_line.length() - 1] == \'n\') || n_line + 1 == n_line_num)) { // mu"
			"st be the whole line here (so that the comment also ends)\r\n"
			"		if(r_s_line[r_s_line.length() - 1] == \'n\') {\r\n"
			"			size_t e = r_s_line.length() - 1, n_slash_num = 0;\r\n"
			"			while(e > 0 && r_s_line[e - 1] == \'\\\\\') {\r\n"
			"				-- e;\r\n"
			"				++ n_slash_num;\r\n"
			"			}\r\n"
			"			_ASSERTE(n_slash_num > 0);\r\n"
			"			if(!(n_slash_num & 1))\r\n"
			"				return;\r\n"
			"		}\r\n"
			"		// this can still turn out bad, the end \"\\n\" might be something like \""
			"\\\\n\" and\r\n"
			"		// the backslash does not belong to the \"n\" and hence the line does not in f"
			"act end in a newline\r\n"
			"		// or it can be \"\\\\\\n\" and then it is ok \"\\\\a\\\\n\" does not get conf"
			"used - so only need to count\r\n"
			"		// the consecutive backslashes and if even, it is not a newline\r\n"
			"\r\n"
			"		size_t n_end = r_s_line.length();\r\n"
			"		if(n_end > 1 && r_s_line[n_end - 2] == \'\\\\\' && r_s_line[n_end - 1] == \'n"
			"\')\r\n"
			"			n_end -= 2;\r\n"
			"		else if(n_end > 1 && r_s_line[n_end - 1] == \'\\n\')\r\n"
			"			-- n_end;\r\n"
			"		// skip the newline at the end\r\n"
			"\r\n"
			"		r_s_comment.insert(r_s_comment.end(),\r\n"
			"			r_s_line.begin() + n_pos,\r\n"
			"			r_s_line.begin() + n_end);\r\n"
			"		// extract the comment\r\n"
			"\r\n"
			"		while(n_pos > 0 && isspace(uint8_t(r_s_line[n_pos - 1])))\r\n"
			"			-- n_pos;\r\n"
			"		// skip whitespace before the comment\r\n"
			"\r\n"
			"		size_t n_comment_escape_num = 0;\r\n"
			"		for(size_t i = 0, n = r_s_comment.length(); i < n; ++ i) {\r\n"
			"			if(r_s_comment[i] == \'\\\\\') {\r\n"
			"				if(i + 1 < n && r_s_comment[i + 1] == \'x\')\r\n"
			"					n_comment_escape_num += 3; // e.g. \\x01\r\n"
			"				else\r\n"
			"					++ n_comment_escape_num;\r\n"
			"				++ i; // to avoid counting backslash escape seq. twice\r\n"
			"			}\r\n"
			"		}\r\n"
			"		// counts escape sequences in strings (!!)\r\n"
			"\r\n"
			"		r_n_file_size -= n_end - n_pos; // account for it in the file size\r\n"
			"		r_n_file_size += n_comment_escape_num; // these were accounted for twice\r\n"
			"		r_s_line.erase(r_s_line.begin() + n_pos,\r\n"
			"			r_s_line.begin() + n_end);\r\n"
			"		// erase the comment from the original string\r\n"
			"	}\r\n"
			"}*/\r\n"
			"\r\n"
			"#if 0\r\n"
			"void Base64_Evolution()\r\n"
			"{\r\n"
			"	int p_ic_tab[128] = {0};\r\n"
			"	/*for(unsigned int i = 0; i < 128; ++ i) {\r\n"
			"		p_ic_tab[i] = (isalpha(i))? (i | 32) - \'a\' + ((i < \'a\')? 0 : 26) :\r\n"
			"			(isdigit(i))? i - \'0\' + 52 : (i == \'+\')? 62 : 63;\r\n"
			"	}*/\r\n"
			"	for(int i = 0; i < 64; ++ i)\r\n"
			"		p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : \"+/\"[i - 62"
			"]] = i;\r\n"
			"		//p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : (i - 51) * "
			"4 - 1] = i;\r\n"
			"		//p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : (i > 62)? "
			"\'/\' : \'+\'] = i;\r\n"
			"		//p_ic_tab[(i < 26)? \'A\' + i : (i < 52)? \'a\' - 26 + i : (i < 62)? \'0\' - "
			"52 + i : (i == 62)? \'+\' : \'/\'] = i;\r\n"
			"		//p_ic_tab[\"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
			"\"[i]] = i;\r\n"
			"}\r\n"
			"#endif // 0\r\n"
			"\r\n"
			"void PrintHelp()\r\n"
			"{\r\n"
			"	fprintf(stderr, \"error: missing program arguments.\\n\"\r\n"
			"		\"usage:\\n\"\r\n"
			"		\"FileToHeader <input-file> <header-file> [options]\\n\"\r\n"
			"		\"where input-file is source file, containing data in text or binary format,"
			"\\n\"\r\n"
			"		\"and header-file is output file to contain this data.\\n\"\r\n"
			"		\"\\nOptions may be the following:\\n\"\r\n"
			"		\"--verbose parameter turns on verbose output (default off)\\n\"\r\n"
			"		\"--name-after overrides input file name for naming the class (in case the inp"
			"ut file\\n\"\r\n"
			"		\"             is an intermediate of a longer processing chain and does not ha"
			"ve a name)\\n\"\r\n"
			"		\"--class-name overrides the default class name (not checked for syntax errors"
			")\\n\"\r\n"
			"		\"--binary forces binary encoding with compression (binary data / obfuscation)"
			"\\n\"\r\n"
			"		\"--text saves the input file as transparent text (default)\\n\"\r\n"
			"		\"--max-cstr-len sets maximum \\\"C\\\"-string length (default 32767)\\n\"\r\n"
			"		\"--max-line-len sets maximum line length in the generated header\\n\"\r\n"
			"		\"               (only applies to the lines with data; default 100)\\n\"\r\n"
			"		\"\\nThe following options only apply in text mode:\\n\"\r\n"
			"		\"--keep-newlines transcripts newlines as they are found in the file\\n\"\r\n"
			"		\"--unix-newlines forces single \\\'\\\\n\\\' newlines (default)\\n\"\r\n"
			"		\"--strip-comments enables processing of C++ line comments (the coments are pr"
			"esent\\n\"\r\n"
			"		\"                 in the header, but are not part of the string)\\n\"\r\n"
			"		\"--line-numbers enables putting line numbers as comments in the output file"
			"\\n\"\r\n"
			"		\"                 for example to aid debugging without the original file, etc"
			".\\n\"\r\n"
			"		\"--trim-line-whitespace enables throwing away line whitespace\\n\"\r\n"
			"		\"--discard-empty-lines enables throwing away lines with nothing but whitespac"
			"e\\n\"\r\n"
			"		\"\\nThe following options only apply in binary mode:\\n\"\r\n"
			"		\"--shared-decompress enables shared decompressor class (disabled by default)"
			"\\n\"\r\n"
			"		\"--force-text-ops enables text processing operations (disabled by default)\\n"
			"\"\r\n"
			"		\"--base-64 forces the use of Base-64 instead of the default Base-85\\n\");\r"
			"\n"
			"}\r\n"
			"\r\n"
			"#include \"Decompress64.h\"\r\n"
			"#include \"Decompress64Src.h\"\r\n"
			"#include \"Decompress85.h\"\r\n"
			"#include \"Decompress85Src.h\"\r\n"
			"\r\n"
			"//#include \"Test_TextMode3.h\" // simple test\r\n"
			"\r\n"
			"void TrimSpace_but_EndLine(std::string &r_s_line)\r\n"
			"{\r\n"
			"	size_t b = 0, e = r_s_line.length();\r\n"
			"\r\n"
			"	while(e > b && (r_s_line[e - 1] == \'\\r\' || r_s_line[e - 1] == \'\\n\'))\r\n"
			"		-- e;\r\n"
			"	// keep newline\r\n"
			"\r\n"
			"	size_t e2 = e;\r\n"
			"	while(b < e2 && isspace(uint8_t(r_s_line[b])))\r\n"
			"		++ b;\r\n"
			"	while(b < e2 && isspace(uint8_t(r_s_line[e2 - 1])))\r\n"
			"		-- e2;\r\n"
			"	// find whitespace\r\n"
			"\r\n"
			"	r_s_line.erase(e2, e - e2);\r\n"
			"	r_s_line.erase(0, b);\r\n"
			"}\r\n"
			"\r\n"
			"int main(int n_arg_num, const char **p_arg_list)\r\n"
			"{\r\n"
			"	if(n_arg_num < 3) {\r\n"
			"		PrintHelp();\r\n"
			"		return 0;\r\n"
			"	}\r\n"
			"\r\n"
			"	/*{\r\n"
			"		int m = CMain_cpp::n_Size();\r\n"
			"		const char *p_s_text = (const char*)CMain_cpp::p_Data();\r\n"
			"		int n = strlen(p_s_text);\r\n"
			"		if(m == n)\r\n"
			"			printf(\"recorded and actual length (%d) matches\\n\", m);\r\n"
			"		else\r\n"
			"			printf(\"recorded (%d) and actual (%d) length do not match\\n\", m, n);\r"
			"\n"
			"		uint32_t n_crc = CCrc_32::n_Crc(n, p_s_text);\r\n"
			"		if(n_crc == CMain_cpp::n_CRC32())\r\n"
			"			printf(\"recorded and actual CRC (0x%08x) matches\\n\", n_crc);\r\n"
			"		else\r\n"
			"			printf(\"recorded (0x%08x) and actual (0x%08x) CRC do not match\\n\", CMai"
			"n_cpp::n_CRC32(), n_crc);\r\n"
			"		FILE *p_fw = fopen(\"test_writeback.h\", \"wb\");\r\n"
			"		fprintf(p_fw, \"%s\", p_s_text);\r\n"
			"		fclose(p_fw);\r\n"
			"		if(CMain_cpp::b_Dynamic())\r\n"
			"			free((char*)p_s_text);\r\n"
			"	}*/ // simple test\r\n"
			"\r\n"
			"	unsigned int n_max_string_length = 32767; // to avoid c++ compilers complaining\r"
			"\n"
			"	unsigned int n_max_line_length = 100;\r\n"
			"	bool b_verbose = false;\r\n"
			"	bool b_binary_mode = false;\r\n"
			"	bool b_prefix_line_numbers = false; // in text mode, add /* 123 */ line numbers in"
			" front of the strings with the lines\r\n"
			"	bool b_overriden_newline_mode = false; // if --keep-newlines or --unix-newlines wa"
			"s specified\r\n"
			"	bool b_unix_newlines = true; // in text mode, replaces \"\\r\\n\" sequences for on"
			"ly \"\\n\"\r\n"
			"	bool b_strip_line_comments = false; // in text mode, get \"// line comments\" and "
			"put them outside of the text, effectively reducing the payload\r\n"
			"	bool b_shared_decompress = false; // whether to make the decompression routine sha"
			"red (potentially leads to link conflicts)\r\n"
			"	bool b_treat_binary_as_text = false; // force text processing in binary mode as we"
			"ll\r\n"
			"	bool b_trim_line_whitespace = false; // throw away leading and trailing whitespace"
			" (except the newline) on each line\r\n"
			"	bool b_discard_empty_lines = false; // throw away lines that only contain whitespa"
			"ce (including a newline)\r\n"
			"	bool b_use_base85 = true; // use Base-85 instead of Base-64 (default)\r\n"
			"	const int n_tab_size = 4;\r\n"
			"	// config\r\n"
			"\r\n"
			"	const char *p_s_infile = p_arg_list[1];\r\n"
			"	const char *p_s_name_file = p_s_infile;\r\n"
			"	const char *p_s_outfile = p_arg_list[2];\r\n"
			"	const char *p_s_classname = 0;\r\n"
			"\r\n"
			"	for(int i = 3; i < n_arg_num; ++ i) {\r\n"
			"		if(!strcmp(p_arg_list[i], \"--verbose\") || !strcmp(p_arg_list[i], \"-v\"))\r"
			"\n"
			"			b_verbose = true;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--keep-newlines\") || !strcmp(p_arg_list[i], "
			"\"-kn\")) {\r\n"
			"			b_unix_newlines = false;\r\n"
			"			b_overriden_newline_mode = true;\r\n"
			"		} else if(!strcmp(p_arg_list[i], \"-h\") || !strcmp(p_arg_list[i], \"--help\")"
			") {\r\n"
			"			PrintHelp();\r\n"
			"			return 0;\r\n"
			"		} else if(!strcmp(p_arg_list[i], \"--unix-newlines\") || !strcmp(p_arg_list[i]"
			", \"-un\")) {\r\n"
			"			b_unix_newlines = true;\r\n"
			"			b_overriden_newline_mode = true;\r\n"
			"		} else if(!strcmp(p_arg_list[i], \"--shared-decompress\") || !strcmp(p_arg_lis"
			"t[i], \"-sd\"))\r\n"
			"			b_shared_decompress = true;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--line-numbers\") || !strcmp(p_arg_list[i], "
			"\"-ln\"))\r\n"
			"			b_prefix_line_numbers = true;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--strip-comments\") || !strcmp(p_arg_list[i],"
			" \"-sc\"))\r\n"
			"			b_strip_line_comments = true;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--trim-line-whitespace\") || !strcmp(p_arg_li"
			"st[i], \"-tlw\"))\r\n"
			"			b_trim_line_whitespace = true;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--discard-empty-lines\") || !strcmp(p_arg_lis"
			"t[i], \"-del\"))\r\n"
			"			b_discard_empty_lines = true;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--binary\") || !strcmp(p_arg_list[i], \"-b\")"
			")\r\n"
			"			b_binary_mode = true;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--text\") || !strcmp(p_arg_list[i], \"-t\"))"
			"\r\n"
			"			b_binary_mode = false;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--force-text-ops\") || !strcmp(p_arg_list[i],"
			" \"-fto\"))\r\n"
			"			b_treat_binary_as_text = true;\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--base-64\") || !strcmp(p_arg_list[i], \"-b64"
			"\"))\r\n"
			"			b_use_base85 = false;\r\n"
			"		else if(i + 1 == n_arg_num) {\r\n"
			"			fprintf(stderr, \"warning: parameter: \\\'%s\\\': \"\r\n"
			"				\"unknown parameter or needs a value (skipping)\\n\", p_arg_list[i]);"
			"\r\n"
			"		} else if(!strcmp(p_arg_list[i], \"--max-line-len\") || !strcmp(p_arg_list[i],"
			" \"-mll\"))\r\n"
			"			n_max_line_length = atol(p_arg_list[++ i]);\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--max-cstr-len\") || !strcmp(p_arg_list[i], "
			"\"-mcsl\"))\r\n"
			"			n_max_string_length = atol(p_arg_list[++ i]);\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--class-name\") || !strcmp(p_arg_list[i], \"-"
			"cn\"))\r\n"
			"			p_s_classname = p_arg_list[++ i];\r\n"
			"		else if(!strcmp(p_arg_list[i], \"--name-after\") || !strcmp(p_arg_list[i], \"-"
			"na\"))\r\n"
			"			p_s_name_file = p_arg_list[++ i];\r\n"
			"		else\r\n"
			"			fprintf(stderr, \"warning: unknown parameter: \\\'%s\\\' (skipping)\\n\", "
			"p_arg_list[i]);\r\n"
			"	}\r\n"
			"	// parse command-line\r\n"
			"\r\n"
			"	if(b_binary_mode) {\r\n"
			"		if(!b_treat_binary_as_text) {\r\n"
			"			if(b_prefix_line_numbers || b_overriden_newline_mode || b_strip_line_comme"
			"nts ||\r\n"
			"			   b_trim_line_whitespace || b_discard_empty_lines) {\r\n"
			"				fprintf(stderr, \"warning: --force-text-ops not specified, all\"\r\n"
			"					\" text operations ignored in binary mode\\n\");\r\n"
			"			}\r\n"
			"		} else {\r\n"
			"			if(b_prefix_line_numbers)\r\n"
			"				fprintf(stderr, \"warning: --line-numbers ignored in binary mode\\n\")"
			";\r\n"
			"		}\r\n"
			"	} else {\r\n"
			"		if(b_treat_binary_as_text)\r\n"
			"			fprintf(stderr, \"warning: --force-text-ops ignored in text mode\\n\");\r"
			"\n"
			"		if(!b_use_base85)\r\n"
			"			fprintf(stderr, \"warning: --base-64 ignored in text mode\\n\");\r\n"
			"	}\r\n"
			"	// check command-line\r\n"
			"\r\n"
			"	if(b_verbose)\r\n"
			"		printf(\"FileToHeader \" APP_VERSION \" (built \" __DATE__ \")\\n\\n\");\r\n"
			"	// print version\r\n"
			"\r\n"
			"	n_max_string_length = max(n_max_string_length, n_max_line_length);\r\n"
			"	// must be at least the same\r\n"
			"\r\n"
			"	n_max_line_length -= 2; // the quotes\r\n"
			"	n_max_line_length -= 3 * n_tab_size; // the tabs\r\n"
			"\r\n"
			"	if(b_verbose)\r\n"
			"		printf(\"loading input file ...\\n\");\r\n"
			"\r\n"
			"	uint64_t n_file_size = -1, n_orig_file_size = -1;\r\n"
			"	bool b_is_dynamic = false;\r\n"
			"	uint32_t n_crc32 = 0, n_orig_crc32 = 0;\r\n"
			"	std::string s_data;\r\n"
			"	int n_base = (b_use_base85)? 85 : 64; // if compressed\r\n"
			"	try {\r\n"
			"		std::string s_file;\r\n"
			"		std::vector<int> line_no;\r\n"
			"		char p_s_line_no_format[64];\r\n"
			"		char p_s_hide_line_no[64];\r\n"
			"		std::vector<std::string> line_list;\r\n"
			"		std::vector<std::vector<std::string> > line_comment_list;\r\n"
			"		// text processing data (shared now)\r\n"
			"\r\n"
			"		if(!b_binary_mode || b_treat_binary_as_text) {\r\n"
			"			if(!ReadFile(s_file, p_s_infile)) {\r\n"
			"				fprintf(stderr, \"error: failed to load \\\'%s\\\'\\n\", p_s_infile);"
			"\r\n"
			"				return -1;\r\n"
			"			}\r\n"
			"			// read\r\n"
			"\r\n"
			"			if(s_file.find(\'\\0\') != std::string::npos) {\r\n"
			"				fprintf(stderr, \"error: file \\\'%s\\\' contains null characters;\"\r"
			"\n"
			"					\" must be saved as binary\\n\", p_s_infile);\r\n"
			"				return -1;\r\n"
			"			}\r\n"
			"\r\n"
			"			n_orig_crc32 = CCrc_32::n_Crc(s_file.length() * sizeof(char), s_file.data("
			"));\r\n"
			"			// calculate the original CRC32\r\n"
			"\r\n"
			"			n_file_size = s_file.size();\r\n"
			"			n_orig_file_size = n_file_size;\r\n"
			"			// take size now\r\n"
			"\r\n"
			"			if(b_unix_newlines) {\r\n"
			"				size_t n_pos = 0;\r\n"
			"				while((n_pos = s_file.find(\"\\r\\n\", n_pos)) != std::string::npos) {"
			"\r\n"
			"					s_file.erase(n_pos, 1);\r\n"
			"					++ n_pos;\r\n"
			"				}\r\n"
			"			}\r\n"
			"			// take binary newlines \'\\r\\n\' and make them only \'\\n\'\r\n"
			"\r\n"
			"			stl_ut::Split(line_list, s_file, \"\\n\");\r\n"
			"			for(size_t i = 0, n = line_list.size(); i + 1 < n; ++ i)\r\n"
			"				line_list[i] += \'\\n\'; // keep newlines\r\n"
			"			// split to lines\r\n"
			"\r\n"
			"			if(b_trim_line_whitespace) {\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i)\r\n"
			"					TrimSpace_but_EndLine(line_list[i]); // trim space\r\n"
			"			}\r\n"
			"			// trim line whitespace\r\n"
			"\r\n"
			"			if(b_verbose && b_binary_mode)\r\n"
			"				printf(\"forced text processing | \");\r\n"
			"			if(b_verbose)\r\n"
			"				printf(\"have %d lines\\n\", line_list.size());\r\n"
			"			// verbose\r\n"
			"\r\n"
			"			if(line_list.back().empty())\r\n"
			"				line_list.erase(line_list.end() - 1);\r\n"
			"			// erase the last empty line (without even newline on it), it looks weird"
			"\r\n"
			"\r\n"
			"			if(b_prefix_line_numbers) {\r\n"
			"				stl_ut::Format(p_s_line_no_format, sizeof(p_s_line_no_format),\r\n"
			"					PRIsize, line_list.size());\r\n"
			"				size_t n_line_num_log10 = strlen(p_s_line_no_format);\r\n"
			"				stl_ut::Format(p_s_line_no_format, sizeof(p_s_line_no_format),\r\n"
			"					\"/* %%%dd */ \", n_line_num_log10);\r\n"
			"				// make format string for line numbers\r\n"
			"\r\n"
			"				char p_s_hide_line_no_format[64];\r\n"
			"				stl_ut::Format(p_s_hide_line_no_format, sizeof(p_s_hide_line_no_format"
			"),\r\n"
			"					\"   %%%ds    \", n_line_num_log10); // just spaces\r\n"
			"				stl_ut::Format(p_s_hide_line_no, sizeof(p_s_hide_line_no), p_s_hide_li"
			"ne_no_format, \"\");\r\n"
			"				for(int b = 0, e = strlen(p_s_hide_line_no); b < e; ++ b) {\r\n"
			"					if(b + n_tab_size < e) {\r\n"
			"						p_s_hide_line_no[b] = \'\\t\';\r\n"
			"						e -= n_tab_size - 1;\r\n"
			"						p_s_hide_line_no[e] = 0;\r\n"
			"					}\r\n"
			"				}\r\n"
			"				// make string for hidden line numbers (retarded but working)\r\n"
			"\r\n"
			"				n_line_num_log10 += 7; // 7 = strlen(\"/* \") + strlen(\" */ \")\r\n"
			"				if(n_max_line_length > n_line_num_log10)\r\n"
			"					n_max_line_length -= n_line_num_log10;\r\n"
			"				// include the line numbers in line length calculation\r\n"
			"\r\n"
			"				line_no.resize(line_list.size());\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i)\r\n"
			"					line_no[i] = i + 1;\r\n"
			"				_ASSERTE(line_no.size() == line_list.size());\r\n"
			"				// make a list of line numbers (a stupid approach, but easy to get rig"
			"ht)\r\n"
			"			}\r\n"
			"\r\n"
			"			if(b_strip_line_comments) {\r\n"
			"				line_comment_list.resize(line_list.size());\r\n"
			"				bool b_in_multiline_comment = false;\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\r\n"
			"					std::string &r_s_line = line_list[i];\r\n"
			"					// get a line\r\n"
			"\r\n"
			"					_ASSERTE(!r_s_line.empty() && (i + 1 == n || r_s_line[r_s_line.len"
			"gth() - 1] == \'\\n\'));\r\n"
			"					// make sure each line ends in newline at this stage\r\n"
			"\r\n"
			"					size_t b = 0, e = r_s_line.length();\r\n"
			"					if(b_in_multiline_comment) {\r\n"
			"						if((b = r_s_line.find(\"*/\")) != std::string::npos) {\r\n"
			"							++ b;\r\n"
			"							_ASSERTE(r_s_line[b - 1] == \'*\' && r_s_line[b] == \'/\')"
			";\r\n"
			"							// ignore everything else, just look for the end of the co"
			"mment\r\n"
			"\r\n"
			"							size_t b2 = 0;\r\n"
			"							while(isspace(uint8_t(r_s_line[b2])))\r\n"
			"								++ b2;\r\n"
			"							// find the beginning of the comment text\r\n"
			"\r\n"
			"							_ASSERTE(b > 0);\r\n"
			"							size_t e4 = b - 1;\r\n"
			"							while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - 1])))\r\n"
			"								-- e4;\r\n"
			"							// find the end of the comment text\r\n"
			"\r\n"
			"							std::string s_comment;\r\n"
			"							s_comment.insert(s_comment.begin(), r_s_line.begin() + b2,"
			" r_s_line.begin() + e4);\r\n"
			"							if(!s_comment.empty())\r\n"
			"								line_comment_list[i].push_back(s_comment);\r\n"
			"							r_s_line.erase(r_s_line.begin(), r_s_line.begin() + (b + 1"
			"));\r\n"
			"							// process the comment\r\n"
			"\r\n"
			"							b = 0; // !!\r\n"
			"							e = r_s_line.length(); // this changed\r\n"
			"							b_in_multiline_comment = false; // !!\r\n"
			"						} else { // the comment is this whole line\r\n"
			"							b = 0;\r\n"
			"							size_t e2 = e;\r\n"
			"							while(e2 > b && (r_s_line[e2 - 1] == \'\\n\' || r_s_line[e"
			"2 - 1] == \'\\r\'))\r\n"
			"								-- e2;\r\n"
			"							// find end of line\r\n"
			"\r\n"
			"							size_t b2 = 0;\r\n"
			"							while(b2 < e2 && isspace(uint8_t(r_s_line[b2])))\r\n"
			"								++ b2;\r\n"
			"							// find the beginning of the comment text\r\n"
			"\r\n"
			"							size_t e4 = e2;\r\n"
			"							while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - 1])))\r\n"
			"								-- e4;\r\n"
			"							// find end of the comment text\r\n"
			"\r\n"
			"							std::string s_comment;\r\n"
			"							s_comment.insert(s_comment.begin(), r_s_line.begin() + b2,"
			" r_s_line.begin() + e4);\r\n"
			"							if(!s_comment.empty())\r\n"
			"								line_comment_list[i].push_back(s_comment);\r\n"
			"							r_s_line.erase(r_s_line.begin(), r_s_line.begin() + e2);\r"
			"\n"
			"							// process the comment\r\n"
			"\r\n"
			"							e = b;\r\n"
			"							// nothing else to do on this line\r\n"
			"						}\r\n"
			"					}\r\n"
			"					// parse continuing comment\r\n"
			"\r\n"
			"					for(; b < e; ++ b) {\r\n"
			"						if(r_s_line[b] == \'\\\'\') {\r\n"
			"							++ b;\r\n"
			"							for(; b < e; ++ b) {\r\n"
			"								if(r_s_line[b] == \'\\\\\') {\r\n"
			"									++ b;\r\n"
			"									// can be whatever after it (mostly a single chara"
			"cter,\r\n"
			"									// sometimes hexadecimal number), but will correct"
			"ly skip \"\\\'\"\r\n"
			"								} else if(r_s_line[b] == \'\\\'\')\r\n"
			"									break;\r\n"
			"								// found the other (unescaped) apostrophe\r\n"
			"							}\r\n"
			"							if(b == e || r_s_line[b] == \'\\\'\')\r\n"
			"								continue;\r\n"
			"						}\r\n"
			"						// eat \"C\" character literals\r\n"
			"\r\n"
			"						if(r_s_line[b] == \'\\\"\') {\r\n"
			"							++ b;\r\n"
			"							for(; b < e; ++ b) {\r\n"
			"								if(r_s_line[b] == \'\\\\\') {\r\n"
			"									++ b;\r\n"
			"									// can be whatever after it (mostly a single chara"
			"cter,\r\n"
			"									// sometimes a hexadecimal number), but will corre"
			"ctly skip \"\\\"\"\r\n"
			"								} else if(r_s_line[b] == \'\\\"\')\r\n"
			"									break;\r\n"
			"								// found the other (unescaped) quote\r\n"
			"							}\r\n"
			"							if(b == e || r_s_line[b] == \'\\\"\')\r\n"
			"								continue;\r\n"
			"						}\r\n"
			"						// eat \"C\" string literals\r\n"
			"\r\n"
			"						if(r_s_line[b] == \'/\' && b + 1 < e) {\r\n"
			"							if(r_s_line[b + 1] == \'/\') {\r\n"
			"								size_t e2 = e;\r\n"
			"								while(e2 > b && (r_s_line[e2 - 1] == \'\\n\' || r_s_li"
			"ne[e2 - 1] == \'\\r\'))\r\n"
			"									-- e2;\r\n"
			"								// find end of line\r\n"
			"\r\n"
			"								size_t b2 = b + 2;\r\n"
			"								while(b2 < e2 && isspace(uint8_t(r_s_line[b2])))\r\n"
			"									++ b2;\r\n"
			"								// find the beginning of the comment text\r\n"
			"\r\n"
			"								while(b > 0 && isspace(uint8_t(r_s_line[b - 1])))\r\n"
			"									-- b;\r\n"
			"								// will erase the preceding whitespace as well\r\n"
			"\r\n"
			"								std::string s_comment;\r\n"
			"								s_comment.insert(s_comment.begin(), r_s_line.begin() +"
			" b2, r_s_line.begin() + e2);\r\n"
			"								if(!s_comment.empty())\r\n"
			"									line_comment_list[i].push_back(s_comment);\r\n"
			"								r_s_line.erase(r_s_line.begin() + b, r_s_line.begin() "
			"+ e2);\r\n"
			"								break;\r\n"
			"							}\r\n"
			"							// found a line comment\r\n"
			"\r\n"
			"							if(r_s_line[b + 1] == \'*\') {\r\n"
			"								size_t e2 = e;\r\n"
			"								while(e2 > b && (r_s_line[e2 - 1] == \'\\n\' || r_s_li"
			"ne[e2 - 1] == \'\\r\'))\r\n"
			"									-- e2;\r\n"
			"								// find end of line\r\n"
			"\r\n"
			"								size_t b2 = b + 2;\r\n"
			"								while(b2 < e2 && isspace(uint8_t(r_s_line[b2])))\r\n"
			"									++ b2;\r\n"
			"								// find the beginning of the comment text\r\n"
			"\r\n"
			"								size_t e3 = b2 + 1;\r\n"
			"								while(e3 < e2 && (r_s_line[e3 - 1] != \'*\' || r_s_lin"
			"e[e3] != \'/\'))\r\n"
			"									++ e3;\r\n"
			"								// find the end of the comment text\r\n"
			"\r\n"
			"								while(b > 0 && isspace(uint8_t(r_s_line[b - 1])))\r\n"
			"									-- b;\r\n"
			"								// will erase the preceding whitespace as well\r\n"
			"\r\n"
			"								std::string s_comment;\r\n"
			"								if(e3 < e2 && r_s_line[e3 - 1] == \'*\' && r_s_line[e3"
			"] == \'/\') {\r\n"
			"									// the comment ends on this line\r\n"
			"\r\n"
			"									_ASSERTE(e3 > 0);\r\n"
			"									size_t e4 = e3 - 1;\r\n"
			"									while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - 1])"
			"))\r\n"
			"										-- e4;\r\n"
			"									// find end of the comment text\r\n"
			"\r\n"
			"									s_comment.insert(s_comment.begin(), r_s_line.begin"
			"() + b2, r_s_line.begin() + e4);\r\n"
			"									r_s_line.erase(r_s_line.begin() + b, r_s_line.begi"
			"n() + e3 + 1);\r\n"
			"									// get the comment\r\n"
			"\r\n"
			"									e = r_s_line.length(); // this changed\r\n"
			"									-- b; // compensate for ++ b in the outer loop\r\n"
			"									// (there can be more separate comments on a singl"
			"e line!)\r\n"
			"								} else {\r\n"
			"									b_in_multiline_comment = true; // the comment carr"
			"ies to the next line\r\n"
			"\r\n"
			"									size_t e4 = e2;\r\n"
			"									while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - 1])"
			"))\r\n"
			"										-- e4;\r\n"
			"									// find end of the comment text\r\n"
			"\r\n"
			"									s_comment.insert(s_comment.begin(), r_s_line.begin"
			"() + b2, r_s_line.begin() + e4);\r\n"
			"									r_s_line.erase(r_s_line.begin() + b, r_s_line.begi"
			"n() + e2);\r\n"
			"									e = b; // we are finished with this line\r\n"
			"								}\r\n"
			"								// extract the comment\r\n"
			"\r\n"
			"								if(!s_comment.empty())\r\n"
			"									line_comment_list[i].push_back(s_comment);\r\n"
			"							}\r\n"
			"							// found a multiline comment\r\n"
			"						}\r\n"
			"						// eat comments\r\n"
			"					}\r\n"
			"					// parse \"C\" strings, characters and comments / C++ comments\r\n"
			"				}\r\n"
			"				// for each line\r\n"
			"\r\n"
			"				for(size_t i = 0, n = line_comment_list.size(); i < n; ++ i) {\r\n"
			"					std::vector<std::string> &r_comments = line_comment_list[i];\r\n"
			"					for(size_t j = 0, m = r_comments.size(); j < m; ++ j) {\r\n"
			"						std::string &r_comment = r_comments[j];\r\n"
			"						size_t n_pos = 0;\r\n"
			"						while((n_pos = r_comment.find(\"/*\")) != std::string::npos)\r"
			"\n"
			"							r_comment[++ n_pos] = \'+\';\r\n"
			"						n_pos = 0;\r\n"
			"						while((n_pos = r_comment.find(\"*/\")) != std::string::npos)\r"
			"\n"
			"							r_comment[n_pos] = \'+\';\r\n"
			"						++ n_pos;\r\n"
			"					}\r\n"
			"				}\r\n"
			"				// replace comments inside comments to avoid warnings when building th"
			"e header\r\n"
			"			}\r\n"
			"			// extract comments from the text\r\n"
			"\r\n"
			"			if(b_discard_empty_lines) {\r\n"
			"				_ASSERTE(line_no.empty() || line_no.size() == line_list.size());\r\n"
			"				std::string s_line, s_dummy;\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\r\n"
			"					s_line = line_list[i];\r\n"
			"					// get a copy of the line\r\n"
			"\r\n"
			"					stl_ut::TrimSpace(s_line);\r\n"
			"					// trim space\r\n"
			"\r\n"
			"					if(s_line.empty()) {\r\n"
			"						if(line_comment_list[i].empty()) {\r\n"
			"							line_list.erase(line_list.begin() + i);\r\n"
			"							if(!line_no.empty())\r\n"
			"								line_no.erase(line_no.begin() + i);\r\n"
			"							if(!line_comment_list.empty())\r\n"
			"								line_comment_list.erase(line_comment_list.begin() + i)"
			";\r\n"
			"							-- i;\r\n"
			"							-- n;\r\n"
			"							// no comments, just delete the line\r\n"
			"						} else {\r\n"
			"							line_list[i].clear();\r\n"
			"							// there is a comment, just keep the empty line as a place"
			"holder\r\n"
			"						}\r\n"
			"					}\r\n"
			"					// discard empty ones\r\n"
			"				}\r\n"
			"				_ASSERTE(line_no.empty() || line_no.size() == line_list.size());\r\n"
			"			}\r\n"
			"			// discard empty lines\r\n"
			"\r\n"
			"			{\r\n"
			"				n_crc32 = CCrc_32::n_Start();\r\n"
			"				n_file_size = 0;\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\r\n"
			"					n_crc32 = CCrc_32::n_Crc(line_list[i].length() * sizeof(char), lin"
			"e_list[i].data(), n_crc32);\r\n"
			"					n_file_size += line_list[i].length();\r\n"
			"				}\r\n"
			"				n_crc32 = CCrc_32::n_Finalize(n_crc32);\r\n"
			"				// calculate CRC\r\n"
			"			}\r\n"
			"			// count file size after all the changes\r\n"
			"\r\n"
			"			if(b_verbose && b_binary_mode) {\r\n"
			"				printf(\"saved \" PRIsizeB \"B in text processing\\n\",\r\n"
			"					PRIsizeBparams(n_orig_file_size - n_file_size));\r\n"
			"			}\r\n"
			"		}\r\n"
			"		if(!b_binary_mode) {\r\n"
			"			std::for_each(line_list.begin(), line_list.end(), EscapeString);\r\n"
			"			// escape strange characters\r\n"
			"\r\n"
			"			uint64_t n_print_size = 0;\r\n"
			"			for(size_t i = 0, n = line_list.size(); i < n; ++ i)\r\n"
			"				n_print_size += line_list[i].length();\r\n"
			"			// count length\r\n"
			"\r\n"
			"			if(n_max_line_length > 0) {\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\r\n"
			"					size_t n_tab_num = std::count(line_list[i].begin(), line_list[i].e"
			"nd(), \'\\t\'); // may not compile in msvc60\r\n"
			"					if(line_list[i].length() + n_tab_num * (n_tab_size - 1) > n_max_li"
			"ne_length) { // * (n_tab_size - 1) because one character is counted already\r\n"
			"						std::string &r_s_line_i = line_list[i];\r\n"
			"						int n_cut;\r\n"
			"						unsigned int l = r_s_line_i.length(), chars = 0;;\r\n"
			"						for(n_cut = 0; unsigned(n_cut) < l; ++ n_cut) {\r\n"
			"							unsigned int chars2 = chars + ((r_s_line_i[n_cut] == \'\\t"
			"\')? n_tab_size : 1);\r\n"
			"							if(chars2 > n_max_line_length && (chars > n_max_line_lengt"
			"h ||\r\n"
			"							   (n_max_line_length - chars) < (chars2 - n_max_line_leng"
			"th + 1)))\r\n"
			"								break; // find the precise position of the cut, minimi"
			"zing the distance from the cut line\r\n"
			"							chars = chars2;\r\n"
			"						}\r\n"
			"						/*int n_cut = n_max_line_length - n_tab_num * (n_tab_size - 1)"
			"; // try to fixup (not precise)*/\r\n"
			"						if(n_cut <= 0)\r\n"
			"							n_cut = n_max_line_length; // ...\r\n"
			"						if(n_cut >= r_s_line_i.length())\r\n"
			"							n_cut = r_s_line_i.length(); // 2016-06-16 - fixed a bug w"
			"ith out of bounds access triggered by lines with many tabs on them where the imprecise"
			" estimate overshoots past the length of the line\r\n"
			"						_ASSERTE(n_cut > 0);\r\n"
			"						// decide where to cut to have no more than n_max_line_length "
			"characters in the header\r\n"
			"\r\n"
			"						while((n_cut > 0 && r_s_line_i[n_cut - 1] == \'\\\\\') ||\r\n"
			"						   (n_cut > 1 && r_s_line_i[n_cut - 2] == \'\\\\\' && r_s_line"
			"_i[n_cut - 1] == \'x\') ||\r\n"
			"						   (n_cut > 2 && r_s_line_i[n_cut - 3] == \'\\\\\' && r_s_line"
			"_i[n_cut - 2] == \'x\'))\r\n"
			"						   n_cut -= (r_s_line_i[n_cut - 1] == \'\\\\\')? 1 : (r_s_line"
			"_i[n_cut - 1] == \'x\')? 2 : 3;\r\n"
			"						// can\'t leave \'\\\\\' at the end of the line (shouldn\'t cu"
			"t escape sequences in two parts)\r\n"
			"						// note that \'\\\\x12\' will still be cut by this (the compil"
			"ers do not like that) // t_odo - test it\r\n",
			"\r\n"
			"						if(n_cut <= 0 || n_cut == r_s_line_i.length())\r\n"
			"							continue;\r\n"
			"						// leave long line, couldn\'t cut because of abuse of escape s"
			"equences\r\n"
			"\r\n"
			"						std::string s_second_line;\r\n"
			"						s_second_line.insert(s_second_line.end(),\r\n"
			"							line_list[i].begin() + n_cut, line_list[i].end());\r\n"
			"						line_list[i].erase(line_list[i].begin() + n_cut, line_list[i]."
			"end());\r\n"
			"						line_list.insert(line_list.begin() + (i + 1), s_second_line);"
			"\r\n"
			"						++ n; // !!\r\n"
			"\r\n"
			"						if(!line_no.empty())\r\n"
			"							line_no.insert(line_no.begin() + i + 1, -1); // insert -1 "
			"*after* so the lines do not repeat\r\n"
			"						if(!line_comment_list.empty())\r\n"
			"							line_comment_list.insert(line_comment_list.begin() + i, st"
			"d::vector<std::string>()); // insert empty comment *before* as there will likely be mo"
			"re space on the subsequent lines\r\n"
			"						// duplicate line numbers and comments as well, if we need the"
			"m\r\n"
			"					}\r\n"
			"				}\r\n"
			"				_ASSERTE(line_no.empty() || line_no.size() == line_list.size());\r\n"
			"				_ASSERTE(line_comment_list.empty() || line_comment_list.size() == line"
			"_comment_list.size());\r\n"
			"			}\r\n"
			"			// break long lines to multiple ones (but without introducing new line bre"
			"aks)\r\n"
			"\r\n"
			"			if(n_print_size > n_max_string_length) { // note that n_print_size could b"
			"e n_file_size as well, but some compilers might actually limit that instead\r\n"
			"				s_data = \"\\t\\tconst char *p_text_array[] = {\\n\";\r\n"
			"				size_t n_cur_size = 0;\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\r\n"
			"					size_t n_last_line = line_list[i].length();\r\n"
			"					if(n_cur_size + n_last_line <= n_max_string_length) {\r\n"
			"						if(i)\r\n"
			"							s_data += \"\\n\";\r\n"
			"						n_cur_size += n_last_line;\r\n"
			"					} else {\r\n"
			"						if(i)\r\n"
			"							s_data += \",\\n\";\r\n"
			"						n_cur_size = n_last_line;\r\n"
			"					}\r\n"
			"					s_data += \"\\t\\t\\t\";\r\n"
			"					if(b_prefix_line_numbers) {\r\n"
			"						char p_s_line_no[64];\r\n"
			"						if(line_no[i] > 0) {\r\n"
			"							stl_ut::Format(p_s_line_no, sizeof(p_s_line_no),\r\n"
			"								p_s_line_no_format, line_no[i]);\r\n"
			"							s_data += p_s_line_no;\r\n"
			"						} else\r\n"
			"							s_data += p_s_hide_line_no;\r\n"
			"					}\r\n"
			"					s_data += \"\\\"\";\r\n"
			"					s_data += line_list[i];\r\n"
			"					s_data += \"\\\"\";\r\n"
			"					if(!line_comment_list.empty() && !line_comment_list[i].empty()) {"
			"\r\n"
			"						for(size_t j = 0, m = line_comment_list[i].size(); j < m; ++ j"
			") {\r\n"
			"							s_data += \" /* \";\r\n"
			"							s_data += line_comment_list[i][j];\r\n"
			"							s_data += \" */\";\r\n"
			"						}\r\n"
			"						// insert comments\r\n"
			"					}\r\n"
			"				}\r\n"
			"				s_data += \"\\n\\t\\t};\\n\";\r\n"
			"				// need to split it\r\n"
			"\r\n"
			"				std::string s_size;\r\n"
			"				if(!stl_ut::Format(s_size, \"\\t\\tchar *p_s_text;\\n\\t\\tif(!(p_s_te"
			"xt = new(std::nothrow) char[\"\r\n"
			"				   PRIu64 \"]))\\n\\t\\t\\treturn 0;\\n\", n_file_size + 1))\r\n"
			"					throw std::bad_alloc(); // retrhow\r\n"
			"				s_data += s_size;\r\n"
			"\r\n"
			"				/*s_data += \"\\t\\t*p_s_text = 0;\\n\"\r\n"
			"						  \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof("
			"p_text_array[0]); i < n; ++ i)\\n\"\r\n"
			"						  \"\\t\\t\\tstrcat(p_s_text, p_text_array[i]);\\n\"\r\n"
			"						  \"\\t\\treturn p_s_text;\\n\";*/\r\n"
			"				// uses strcat; ugly, inefficient\r\n"
			"\r\n"
			"				/*std::string s_concat;\r\n"
			"				if(!stl_ut::Format(s_concat, \"\\t\\tchar *p_s_dest = p_s_text;\\n\"\r"
			"\n"
			"				   \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_"
			"array[0]); i < n; ++ i) {\\n\"\r\n"
			"				   \"\\t\\t\\tsize_t n_chunk = (i + 1 < n)? \" PRIsize \" : \" PRIsize"
			" \";\\n\"\r\n"
			"				   \"\\t\\t\\tmemcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char)"
			");\\n\" \"\\t\\t\\tp_s_dest += n_chunk;\\n\"\r\n"
			"				   \"\\t\\t}\\n\" \"\\t\\t*p_s_dest = 0;\\n\" \"\\t\\treturn p_s_text;"
			"\\n\", n_max_string_length,\r\n"
			"				   size_t(n_file_size % n_max_string_length)))\r\n"
			"					throw std::bad_alloc(); // retrhow\r\n"
			"				s_data += s_concat;*/ // can\'t use as we are deciding on n_print_size"
			" instead of n_file_size, it is hard to calculate what n_chunk should be\r\n"
			"				// better concat code, using memcpy()\r\n"
			"\r\n"
			"				std::string s_concat;\r\n"
			"				if(!stl_ut::Format(s_concat, \"\\t\\tchar *p_s_dest = p_s_text;\\n\"\r"
			"\n"
			"				   \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_"
			"array[0]); i < n; ++ i) {\\n\"\r\n"
			"				   \"\\t\\t\\tsize_t n_chunk = strlen(p_text_array[i]);\\n\"\r\n"
			"				   \"\\t\\t\\tmemcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char)"
			");\\n\" \"\\t\\t\\tp_s_dest += n_chunk;\\n\"\r\n"
			"				   \"\\t\\t}\\n\" \"\\t\\t*p_s_dest = 0;\\n\" \"\\t\\treturn p_s_text;"
			"\\n\", n_max_string_length,\r\n"
			"				   size_t(n_file_size % n_max_string_length)))\r\n"
			"					throw std::bad_alloc(); // retrhow\r\n"
			"				s_data += s_concat;\r\n"
			"				// better concat code, using memcpy() and strlen()\r\n"
			"\r\n"
			"				// need to provide code to concat it back\r\n"
			"\r\n"
			"				b_is_dynamic = true;\r\n"
			"				// the caller needs to dispose of the text\r\n"
			"			} else {\r\n"
			"				s_data = \"\\t\\tconst char *p_s_text =\\n\";\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\r\n"
			"					s_data += \"\\t\\t\\t\";\r\n"
			"					if(b_prefix_line_numbers) {\r\n"
			"						char p_s_line_no[64];\r\n"
			"						if(line_no[i] > 0) {\r\n"
			"							stl_ut::Format(p_s_line_no, sizeof(p_s_line_no),\r\n"
			"								p_s_line_no_format, line_no[i]);\r\n"
			"							s_data += p_s_line_no;\r\n"
			"						} else\r\n"
			"							s_data += p_s_hide_line_no;\r\n"
			"					}\r\n"
			"					s_data += \"\\\"\";\r\n"
			"					s_data += line_list[i];\r\n"
			"					if(!line_comment_list.empty() && !line_comment_list[i].empty()) {"
			"\r\n"
			"						s_data += (i + 1 == n)? \"\\\";\" : \"\\\"\";\r\n"
			"\r\n"
			"						for(size_t j = 0, m = line_comment_list[i].size(); j < m; ++ j"
			") {\r\n"
			"							s_data += \" /* \";\r\n"
			"							s_data += line_comment_list[i][j];\r\n"
			"							s_data += \" */\";\r\n"
			"						}\r\n"
			"						// insert comments\r\n"
			"\r\n"
			"						s_data += \"\\n\";\r\n"
			"					} else\r\n"
			"						s_data += (i + 1 == n)? \"\\\";\\n\\n\" : \"\\\"\\n\";\r\n"
			"				}\r\n"
			"				// just print them all\r\n"
			"\r\n"
			"				s_data += \"\\t\\treturn p_s_text;\\n\";\r\n"
			"\r\n"
			"				b_is_dynamic = false;\r\n"
			"				// the caller does not need to dispose of the text\r\n"
			"			}\r\n"
			"		} else {\r\n"
			"			TBuffer t_file;\r\n"
			"			if(!b_treat_binary_as_text) {\r\n"
			"				if(!ReadFile(t_file, p_s_infile)) {\r\n"
			"					fprintf(stderr, \"error: failed to load \\\'%s\\\'\\n\", p_s_infil"
			"e);\r\n"
			"					return -1;\r\n"
			"				}\r\n"
			"				n_file_size = t_file.n_Size();\r\n"
			"				n_orig_file_size = n_file_size;\r\n"
			"				n_crc32 = CCrc_32::n_Crc(t_file.n_Size(), t_file.p_Data());\r\n"
			"				n_orig_crc32 = n_crc32;\r\n"
			"				// calculate CRC\r\n"
			"			} else {\r\n"
			"				s_file.erase();\r\n"
			"				for(size_t i = 0, n = line_list.size(); i < n; ++ i)\r\n"
			"					s_file += line_list[i];\r\n"
			"				_ASSERTE(n_file_size == s_file.length() * sizeof(char));\r\n"
			"				n_file_size = s_file.length() * sizeof(char);\r\n"
			"				if(!t_file.Resize(s_file.length() * sizeof(char)))\r\n"
			"					throw std::bad_alloc(); // rehtrow\r\n"
			"				memcpy(t_file.p_Data(), s_file.data(), s_file.length() * sizeof(char))"
			";\r\n"
			"				// just concat; already have a CRC\r\n"
			"			}\r\n"
			"			// input data\r\n"
			"\r\n"
			"			if(b_verbose)\r\n"
			"				printf(\"compressing ... \");\r\n"
			"\r\n"
			"			TBuffer t_bwt_data;\r\n"
			"			uint32_t n_bwt_primary_index;\r\n"
			"			{\r\n"
			"				if(!CBurrowsWheelerTransform::Encode(t_file, t_bwt_data))\r\n"
			"					throw std::bad_alloc(); // rethrow\r\n"
			"				_ASSERTE(t_bwt_data.n_Size() == t_file.n_Size() + sizeof(uint32_t));\r"
			"\n"
			"				n_bwt_primary_index = *(uint32_t*)t_bwt_data.p_Data();\r\n"
			"				TBuffer t_tmp;\r\n"
			"				if(!t_tmp.Resize(t_file.n_Size()))\r\n"
			"					throw std::bad_alloc(); // rethrow\r\n"
			"				memcpy(t_tmp.p_Data(), t_bwt_data.p_Data() + sizeof(uint32_t), t_file."
			"n_Size());\r\n"
			"				t_tmp.Swap(t_bwt_data);\r\n"
			"			}\r\n"
			"			// compress the whole file with BWT (do not expect to have very big files "
			"in here)\r\n"
			"\r\n"
			"			CMoveToFrontTransform::Encode(t_bwt_data, CMoveToFrontTransform::algo_MTF)"
			"; // todo - enable this\r\n"
			"			// also MTF it, produces shorter files and is easy to decompress\r\n"
			"\r\n"
			"			TBuffer t_packed_data;\r\n"
			"			if(!CRunLengthCodec::Encode(t_bwt_data, t_packed_data))\r\n"
			"				throw std::bad_alloc(); // rethrow\r\n"
			"			// pack using simple RLE (easy to unpack)\r\n"
			"\r\n"
			"			size_t n_afterhuff = t_packed_data.n_Size();\r\n"
			"\r\n"
			"			{\r\n"
			"				TBuffer t_tmp;\r\n"
			"				if(!CHuffmanCodec::Encode(t_packed_data, t_tmp))\r\n"
			"					throw std::bad_alloc(); // rethrow\r\n"
			"				t_packed_data.Swap(t_tmp);\r\n"
			"			}\r\n"
			"			// huffman step\r\n"
			"\r\n"
			"			const char *p_s_base85_alphabet = \"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ\""
			"\r\n"
			"				\"abcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>.@^_,{|}~\"; // as RFC 1924,"
			" but \'?\' is \'.\' and \'`\' is \',\'\r\n"
			"			// modified alphabet for Base-85 that will not cause trigraphs\r\n"
			"\r\n"
			"			std::string s_base64;\r\n"
			"			if(b_use_base85) {\r\n"
			"				if(!CModifiedBase85::Encode(s_base64, t_packed_data.n_Size() - sizeof("
			"uint32_t),\r\n"
			"				   t_packed_data.p_Data() + sizeof(uint32_t), true, p_s_base85_alphabe"
			"t))\r\n"
			"					throw std::bad_alloc(); // rethrow\r\n"
			"				// encode as Base-85 with explicit null coding, skip huffman unpack le"
			"ngth, we save it otherwise\r\n"
			"			} else {\r\n"
			"				if(!CModifiedBase64::Encode(s_base64, t_packed_data.n_Size() - sizeof("
			"uint32_t),\r\n"
			"				   t_packed_data.p_Data() + sizeof(uint32_t)))\r\n"
			"					throw std::bad_alloc(); // rethrow\r\n"
			"				// encode as Base-64, skip huffman unpack length, we save it otherwise"
			"\r\n"
			"			}\r\n"
			"\r\n"
			"			{\r\n"
			"				if(b_verbose) {\r\n"
			"					printf(\"packed \" PRIu64 \" B to \" PRIsize \" B of Base-%d text"
			"\\n\",\r\n"
			"						n_orig_file_size, s_base64.length(), (b_use_base85)? 85 : 64);"
			"\r\n"
			"					printf(\"testing decompress ... \");\r\n"
			"				}\r\n"
			"\r\n"
			"				uint8_t *p_data;\r\n"
			"				if(b_use_base85) {\r\n"
			"					p_data = p_Decode_BWT_MTF_RLE_Huff_Base85(s_base64.c_str(),\r\n"
			"						size_t(n_file_size), n_afterhuff, n_bwt_primary_index);\r\n"
			"				} else {\r\n"
			"					p_data = p_Decode_BWT_MTF_RLE_Huff_Base64(s_base64.c_str(),\r\n"
			"						size_t(n_file_size), n_afterhuff, n_bwt_primary_index);\r\n"
			"				}\r\n"
			"				if(!p_data)\r\n"
			"					fprintf(stderr, \"error: decompress failed\\n\");\r\n"
			"				else if(memcmp(p_data, t_file.p_Data(), size_t(n_file_size)))\r\n"
			"					fprintf(stderr, \"error: decompress produces different results\\n"
			"\");\r\n"
			"				else if(b_verbose)\r\n"
			"					printf(\"decompress works\\n\");\r\n"
			"				if(p_data)\r\n"
			"					delete[] p_data;\r\n"
			"			}\r\n"
			"			// test decompress\r\n"
			"\r\n"
			"			if(b_use_base85) {\r\n"
			"				/*size_t n_pos = 0;\r\n"
			"				while((n_pos = s_base64.find(\"??\", n_pos)) != std::string::npos) {\r"
			"\n"
			"					const char *p_s_trigraph_list = \"=(</)>\x92!-\";\r\n"
			"					if(n_pos + 2 < s_base64.length() && strchr(p_s_trigraph_list, s_ba"
			"se64[n_pos + 2]))\r\n"
			"						s_base64.insert(n_pos + 1, 1, \'\\\\\');\r\n"
			"					else\r\n"
			"						++ n_pos; // false alarm, not a trigraph\r\n"
			"				}*/\r\n"
			"				_ASSERTE(s_base64.find(\"??\") == std::string::npos);\r\n"
			"				// using a modified alphabet that does not contain question marks\r\n"
			"			} else {\r\n"
			"				_ASSERTE(s_base64.find(\"??\") == std::string::npos);\r\n"
			"				// would not expect trigraphs here, except if using a modified alphabe"
			"t\r\n"
			"			}\r\n"
			"			// Base-85 may contain trigraphs, need to escape them properly\r\n"
			"\r\n"
			"			bool b_have_to_free = false;\r\n"
			"\r\n"
			"			size_t n_print_size = s_base64.length();\r\n"
			"			if(n_print_size > n_max_string_length) { // note that n_print_size could b"
			"e n_file_size as well, but some compilers might actually limit that instead\r\n"
			"				s_data = \"\\t\\tconst char *p_text_array[] = {\\n\";\r\n"
			"				size_t n_cur_size = 0;\r\n"
			"				for(size_t i = 0; i < n_print_size;) {\r\n"
			"					size_t n_space = min(size_t(n_max_line_length),\r\n"
			"						min(size_t(n_max_string_length) - n_cur_size, n_print_size - i"
			"));\r\n"
			"\r\n"
			"					if(n_space) {\r\n"
			"						if(i)\r\n"
			"							s_data += \"\\n\";\r\n"
			"						n_cur_size += n_space;\r\n"
			"					} else {\r\n"
			"						if(i)\r\n"
			"							s_data += \",\\n\";\r\n"
			"						n_cur_size = n_space = min(size_t(n_max_line_length), n_print_"
			"size - i);\r\n"
			"					}\r\n"
			"					s_data += \"\\t\\t\\t\\\"\";\r\n"
			"					s_data.insert(s_data.end(), s_base64.begin() + i,\r\n"
			"						s_base64.begin() + (i + n_space));\r\n"
			"					i += n_space;\r\n"
			"					s_data += \"\\\"\";\r\n"
			"				}\r\n"
			"				s_data += \"\\n\\t\\t};\\n\";\r\n"
			"				// need to split it\r\n"
			"\r\n"
			"				std::string s_size;\r\n"
			"				if(!stl_ut::Format(s_size, \"\\t\\tchar *p_s_base%d;\\n\\t\\tif(!(p_s_"
			"base%d = new(std::nothrow) char[\"\r\n"
			"				   PRIsize \"]))\\n\\t\\t\\treturn 0;\\n\", n_base, n_base, n_print_si"
			"ze + 1))\r\n"
			"					throw std::bad_alloc(); // retrhow\r\n"
			"				s_data += s_size;;\r\n"
			"				/*s_data += \"\\t\\t*p_s_base64 = 0;\\n\"\r\n"
			"						  \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof("
			"p_text_array[0]); i < n; ++ i)\\n\"\r\n"
			"						  \"\\t\\t\\tstrcat(p_s_base64, p_text_array[i]);\\n\";*/\r\n"
			"				// uses strcat; ugly, inefficient\r\n"
			"\r\n"
			"				std::string s_concat;\r\n"
			"				if(!stl_ut::Format(s_concat, \"\\t\\tchar *p_s_dest = p_s_base%d;\\n\""
			"\r\n"
			"				   \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_"
			"array[0]); i < n; ++ i) {\\n\"\r\n"
			"				   \"\\t\\t\\tsize_t n_chunk = (i + 1 < n)? \" PRIsize \" : \" PRIsize"
			" \";\\n\"\r\n"
			"				   \"\\t\\t\\tmemcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char)"
			");\\n\" \"\\t\\t\\tp_s_dest += n_chunk;\\n\"\r\n"
			"				   \"\\t\\t}\\n\" \"\\t\\t*p_s_dest = 0;\\n\", n_base, n_max_string_le"
			"ngth,\r\n"
			"				   size_t(n_print_size % n_max_string_length)))\r\n"
			"					throw std::bad_alloc(); // retrhow\r\n"
			"				s_data += s_concat;\r\n"
			"				// better concat code, using memcpy\r\n"
			"				// need to provide code to concat it back\r\n"
			"\r\n"
			"				b_have_to_free = true;\r\n"
			"				// the caller needs to dispose of the text\r\n"
			"			} else {\r\n"
			"				s_data = (b_use_base85)? \"\\t\\tconst char *p_s_base85 = \" : \"\\t"
			"\\tconst char *p_s_base64 = \";\r\n"
			"				for(size_t i = 0; i < n_print_size;) {\r\n"
			"					size_t n_line_length = (i)? n_max_line_length : n_max_line_length "
			"-\r\n"
			"						strlen(\"const char *p_s_baseXX = \") + n_tab_size; // n_max_l"
			"ine_length expects three tabs but there are only two\r\n"
			"					size_t n_space = min(n_line_length, n_print_size - i);\r\n"
			"					s_data += (i)? \"\\t\\t\\t\\\"\" : \"\\\"\";\r\n"
			"					s_data.insert(s_data.end(), s_base64.begin() + i,\r\n"
			"						s_base64.begin() + (i + n_space));\r\n"
			"					i += n_space;\r\n"
			"					s_data += (i == n_print_size)? \"\\\";\\n\" : \"\\\"\\n\";\r\n"
			"				}\r\n"
			"				// just print it all\r\n"
			"\r\n"
			"				b_have_to_free = false;\r\n"
			"				// the caller does not need to dispose of the text\r\n"
			"			}\r\n"
			"\r\n"
			"			std::string s_decompress;\r\n"
			"			if(b_have_to_free) {\r\n"
			"				s_data += \"\\t\\tchar *p_data = \";\r\n"
			"			} else\r\n"
			"				s_data += \"\\t\\treturn \";\r\n"
			"			if(b_shared_decompress) {\r\n"
			"				if(!stl_ut::Format(s_decompress, \"%s(p_s_base%d, \" PRIu64 \", \" PRI"
			"size \", \"\r\n"
			"				   PRIsize \");\\n\", \"p_Call_Decompress\", n_base, n_file_size, n_af"
			"terhuff,\r\n"
			"				   size_t(n_bwt_primary_index)))\r\n"
			"					throw std::bad_alloc(); // rethrow\r\n"
			"			} else {\r\n"
			"				if(!stl_ut::Format(s_decompress, \"%s%d(p_s_base%d, \" PRIu64 \", \" P"
			"RIsize \", \"\r\n"
			"				   PRIsize \");\\n\", \"(char*)p_Decode_BWT_MTF_RLE_Huff_Base\", n_bas"
			"e, n_base,\r\n"
			"				   n_file_size, n_afterhuff, size_t(n_bwt_primary_index)))\r\n"
			"					throw std::bad_alloc(); // rethrow\r\n"
			"			}\r\n"
			"			s_data += s_decompress;\r\n"
			"			// prepare the call to the decompress routine\r\n"
			"\r\n"
			"			if(b_have_to_free) {\r\n"
			"				if(b_use_base85)\r\n"
			"					s_data += \"\\t\\tdelete[] p_s_base85;\\n\";\r\n"
			"				else\r\n"
			"					s_data += \"\\t\\tdelete[] p_s_base64;\\n\";\r\n"
			"				s_data += \"\\t\\treturn p_data;\\n\";\r\n"
			"			}\r\n"
			"			// return the data\r\n"
			"\r\n"
			"			b_is_dynamic = true;\r\n"
			"			// the caller needs to dispose of the text\r\n"
			"		}\r\n"
			"	} catch(std::bad_alloc&) {\r\n"
			"		fprintf(stderr, \"error: not enough memory\\n\");\r\n"
			"		return -1;\r\n"
			"	}\r\n"
			"	// throws\r\n"
			"\r\n"
			"	{\r\n"
			"		std::string s_ident, s_header;\r\n"
			"		if(!stl_ut::AssignCStr(s_ident, p_s_name_file) ||\r\n"
			"		   !stl_ut::AssignCStr(s_header, p_s_name_file)) {\r\n"
			"			fprintf(stderr, \"error: not enough memory\\n\");\r\n"
			"			return -1;\r\n"
			"		}\r\n"
			"		for(size_t i = 0, n = s_ident.length(); i < n; ++ i) {\r\n"
			"			if(isalpha(uint8_t(s_ident[i])))\r\n"
			"				s_ident[i] = toupper(uint8_t(s_ident[i]));\r\n"
			"			else if(!isdigit(uint8_t(s_ident[i]))) {\r\n"
			"				s_ident[i] = \'_\';\r\n"
			"				s_header[i] = \'_\';\r\n"
			"			}\r\n"
			"		}\r\n"
			"		// create class name\r\n"
			"\r\n"
			"		FILE *p_fw;\r\n"
			"#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\r\n"
			"		if(fopen_s(&p_fw, p_s_outfile, \"w\")) {\r\n"
			"#else // _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\r\n"
			"		if(!(p_fw = fopen(p_s_outfile, \"w\"))) {\r\n"
			"#endif // _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\r\n"
			"			fprintf(stderr, \"error: failed to open \\\'%s\\\' for writing\\n\", p_s_o"
			"utfile);\r\n"
			"			return -1;\r\n"
			"		}\r\n"
			"\r\n"
			"		fprintf(p_fw, \"/**\\n\");\r\n"
			"		fprintf(p_fw, \" *\\t@file %s\\n\", p_s_outfile);\r\n"
			"		fprintf(p_fw, \" *\\t@brief file in header, generated from \\\'%s\\\'\\n\", p_"
			"s_name_file);\r\n"
			"		if(b_binary_mode)\r\n"
			"			fprintf(p_fw, \" *\\t\\tusing BWT / RLE / Huff / Base%d pipe\\n\", n_base)"
			";\r\n"
			"		else\r\n"
			"			fprintf(p_fw, \" *\\t\\tstored as plain text\\n\");\r\n"
			"		TFileInfo::TTime t_time = TFileInfo(p_s_name_file).p_time[TFileInfo::time_Last"
			"Write];\r\n"
			"		fprintf(p_fw, \" *\\t@date %4d-%02d-%02d %02d:%02d:%02d\\n\", t_time.n_year,\r"
			"\n"
			"			t_time.n_month, t_time.n_day, t_time.n_hour, t_time.n_minute, t_time.n_sec"
			"ond);\r\n"
			"		fprintf(p_fw, \" *\\t@author FileToHeader \" APP_VERSION \" (built \" __DATE__"
			" \")\\n\");\r\n"
			"		fprintf(p_fw, \" */\\n\\n\");\r\n"
			"		fprintf(p_fw, \"#pragma once\\n\");\r\n"
			"		fprintf(p_fw, \"#ifndef __%s_FILE_IN_HEADER_INCLUDED\\n\", s_ident.c_str());\r"
			"\n"
			"		fprintf(p_fw, \"#define __%s_FILE_IN_HEADER_INCLUDED\\n\\n\", s_ident.c_str())"
			";\r\n"
			"		// generate nice header // t_odo - do the same in ImageToHeader\r\n"
			"\r\n"
			"		fprintf(p_fw, \"/**\\n\");\r\n"
			"		fprintf(p_fw, \" *\\t@brief file in header, generated from \\\'%s\\\'\\n\", p_"
			"s_name_file);\r\n"
			"		fprintf(p_fw, \" */\\n\");\r\n"
			"		if(!p_s_classname)\r\n"
			"			fprintf(p_fw, \"class C%s {\\n\", s_header.c_str());\r\n"
			"		else\r\n"
			"			fprintf(p_fw, \"class %s {\\n\", p_s_classname); // class name override\r"
			"\n"
			"		fprintf(p_fw, \"public:\\n\");\r\n"
			"		fprintf(p_fw, \"\\t/**\\n\"\r\n"
			"					  \"\\t *\\t@brief gets size of the data\\n\"\r\n"
			"					  \"\\t *\\t@return Returns size of the data, in bytes, not includ"
			"ing the terminating zero.\\n\"\r\n"
			"					  \"\\t */\\n\");\r\n"
			"		if(n_orig_file_size == n_file_size) {\r\n"
			"			fprintf(p_fw, \"\\tstatic inline size_t n_Size()\\n\\t{\\n\\t\\treturn \" "
			"PRIu64\r\n"
			"				\"; // matches original file\\n\\t}\\n\\n\", n_file_size);\r\n"
			"		} else {\r\n"
			"			fprintf(p_fw, \"\\tstatic inline size_t n_Size()\\n\\t{\\n\\t\\treturn \" "
			"PRIu64\r\n"
			"				\"; // original file \" PRIu64 \" B\\n\\t}\\n\\n\", n_file_size, n_ori"
			"g_file_size);\r\n"
			"		}\r\n"
			"		fprintf(p_fw, \"\\t/**\\n\"\r\n"
			"					  \"\\t *\\t@brief determines whether the stored string is dynamic"
			"ally allocated\\n\"\r\n"
			"					  \"\\t *\\t@return Returns true if the caller of p_Data() needs t"
			"o free the memory.\\n\"\r\n"
			"					  \"\\t */\\n\");\r\n"
			"		fprintf(p_fw, \"\\tstatic inline bool b_Dynamic()\\n\\t{\\n\\t\\treturn %s;\\n"
			"\\t}\\n\\n\",\r\n"
			"			(b_is_dynamic)? \"true\" : \"false\");\r\n"
			"		fprintf(p_fw, \"\\t/**\\n\"\r\n"
			"					  \"\\t *\\t@brief gets CRC\\n\"\r\n"
			"					  \"\\t *\\t@return Returns CRC32 of the stored data.\\n\"\r\n"
			"					  \"\\t *\\t@note The stored CRC may differ from the original file"
			" if data processing was enabled.\\n\"\r\n"
			"					  \"\\t */\\n\");\r\n"
			"		if(n_orig_crc32 == n_crc32) {\r\n"
			"			fprintf(p_fw, \"\\tstatic inline uint32_t n_CRC32()\\n\\t{\\n\\t\\treturn "
			"0x%08x;\"\r\n"
			"				\" // matches original file\\n\\t}\\n\\n\", n_crc32);\r\n"
			"		} else {\r\n"
			"			fprintf(p_fw, \"\\tstatic inline uint32_t n_CRC32()\\n\\t{\\n\\t\\treturn "
			"0x%08x;\"\r\n"
			"				\" // original file 0x%08x\\n\\t}\\n\\n\", n_crc32, n_orig_crc32);\r\n"
			"		}\r\n"
			"		fprintf(p_fw, \"\\t/**\\n\"\r\n"
			"					  \"\\t *\\t@brief gets data\\n\"\r\n"
			"					  \"\\t *\\n\"\r\n"
			"					  \"\\t *\\t@return Returns data of the file on success, 0 on fail"
			"ure (not enough memory).\\n\"\r\n"
			"					  \"\\t *\\n\"\r\n"
			"					  \"\\t *\\t@note The data (despite it may be binary), is addition"
			"ally null terminated to make\\n\"\r\n"
			"					  \"\\t *\\t\\tit easier to use (the terminating null is not count"
			"ed in n_Size()).\\n\"\r\n"
			"					  \"\\t *\\t@note See also b_Dynamic().\\n\"\r\n"
			"					  \"\\t */\\n\");\r\n"
			"		if(b_is_dynamic)\r\n"
			"			fprintf(p_fw, \"\\tstatic inline char *p_Data()\\n\\t{\\n\");\r\n"
			"		else\r\n"
			"			fprintf(p_fw, \"\\tstatic inline const char *p_Data()\\n\\t{\\n\");\r\n"
			"		fprintf(p_fw, \"%s\", s_data.c_str());\r\n"
			"		fprintf(p_fw, \"\\t}\\n\");\r\n"
			"		\r\n"
			"		uint32_t n_decompressor_crc = 0;\r\n"
			"		std::string s_decompress_src;\r\n"
			"		if(b_binary_mode) {\r\n"
			"			if(b_binary_mode) {\r\n"
			"#if 1\r\n"
			"				char *p_s_deco;\r\n"
			"				if(b_use_base85)\r\n"
			"					p_s_deco = CDecompress85_h::p_Data(); // use itself to generate co"
			"mpressed decompressor\r\n"
			"				else\r\n"
			"					p_s_deco = CDecompress64_h::p_Data(); // use itself to generate co"
			"mpressed decompressor\r\n"
			"				if(!p_s_deco || !stl_ut::AssignCStr(s_decompress_src, p_s_deco)) {\r\n"
			"					if(p_s_deco)\r\n"
			"						delete[] p_s_deco;\r\n"
			"					fprintf(stderr, \"error: failed to decompress the decompress routi"
			"nes\\n\");\r\n"
			"#else\r\n"
			"				if(!ReadFile(s_decompress_src, (b_use_base85)? \"Decompress64.h\" : \""
			"Decompress85.h\")) { // uncool, hard to use from commandline\r\n"
			"					fprintf(stderr, \"error: failed to read \\\'Decompress.h\\\',\"\r"
			"\n"
			"						\" unable to include decompress routines\\n\");\r\n"
			"#endif\r\n"
			"					fclose(p_fw);\r\n"
			"					return -1;\r\n"
			"				} else {\r\n"
			"					size_t n_pos = 0;\r\n"
			"					while((n_pos = s_decompress_src.find(\"\\r\\n\", n_pos)) != std::s"
			"tring::npos)\r\n"
			"						s_decompress_src.erase(n_pos, 1);\r\n"
			"					// condense newlines\r\n"
			"\r\n"
			"					n_decompressor_crc = CCrc_32::n_Crc(s_decompress_src.length() *\r"
			"\n"
			"						sizeof(char), s_decompress_src.data());\r\n"
			"					// calculate CRC of it\r\n"
			"				}\r\n"
			"			}\r\n"
			"		}\r\n"
			"		// read the decompressor\r\n"
			"\r\n"
			"		if(b_binary_mode) {\r\n"
			"			if(b_shared_decompress) {\r\n"
			"				fprintf(p_fw, \"\\nprotected:\\n\"\r\n"
			"							  \"\\t/**\\n\"\r\n"
			"							  \"\\t *\\t@copydoc CFTHDecompressCode_%08x::p_Decode_BWT"
			"_MTF_RLE_Huff_Base%d\\n\"\r\n"
			"							  \"\\t */\\n\"\r\n"
			"							  \"\\tstatic inline char *p_Call_Decompress(const char *p"
			"_s_base%d,\\n\"\r\n"
			"							  \"\\t\\tint n_data_size, int n_huff_stage_size, uint32_t"
			" n_bwt_primary_index);\\n\",\r\n"
			"							  n_decompressor_crc, n_base, n_base);\r\n"
			"				// specify a small routine that will call decompressor once it\'s been"
			" declared\r\n"
			"\r\n"
			"				fprintf(p_fw, \"};\\n\");\r\n"
			"				// end the previos class\r\n"
			"\r\n"
			"				fprintf(p_fw, \"\\n#ifndef __FILE_TO_HEADER_DECOMPRESS_%08X_INCLUDED"
			"\\n\", n_decompressor_crc);\r\n"
			"				fprintf(p_fw, \"#define __FILE_TO_HEADER_DECOMPRESS_%08X_INCLUDED\\n"
			"\\n\", n_decompressor_crc);\r\n"
			"\r\n"
			"				fprintf(p_fw, \"/**\\n\"\r\n"
			"							  \" *\\t@brief decompression routine implementation\\n\""
			"\r\n"
			"				//			  \" *\\t@note While this allows all the compressed file"
			"s to share decompressor implementation,\\n\"\r\n"
			"				//			  \" *\\t\\tit restricts all the files to be included in"
			" a single .cpp file, otherwise linking\\n\"\r\n"
			"				//			  \" *\\t\\tfails because of duplicate symbols (remove b"
			"ody of decompress function in such case).\\n\"\r\n"
			"							  \" */\\n\"\r\n"
			"							  \"class CFTHDecompressCode_%08x {\\npublic:\\n\", n_deco"
			"mpressor_crc);\r\n"
			"				fprintf(p_fw, \"%s\", s_decompress_src.c_str());\r\n"
			"				// include decompress routines\r\n"
			"\r\n"
			"				fprintf(p_fw, \"};\\n\\n#endif // __FILE_TO_HEADER_DECOMPRESS_%08X_INC"
			"LUDED\\n\\n\", n_decompressor_crc);\r\n"
			"\r\n"
			"				fprintf(p_fw, \"inline char *%s%s::p_Call_Decompress(const char *p_s_b"
			"ase%d,\\n\"\r\n"
			"							  \"\\tint n_data_size, int n_huff_stage_size, uint32_t n_"
			"bwt_primary_index)\\n\"\r\n"
			"							  \"{\\n\"\r\n"
			"							  \"\\treturn (char*)CFTHDecompressCode_%08x::p_Decode_BWT"
			"_MTF_RLE_Huff_Base%d(p_s_base%d,\\n\"\r\n"
			"							  \"\\t\\tn_data_size, n_huff_stage_size, n_bwt_primary_in"
			"dex);\\n\"\r\n"
			"							  \"}\\n\"\r\n"
			"							  \"// a dummy function that calls the decompressor, which"
			" is now declared\\n\"\r\n"
			"							  \"// (allows us to keep it at the end of the file)\\n\","
			"\r\n"
			"							  (p_s_classname)? \"\" : \"C\", (p_s_classname)? p_s_clas"
			"sname : s_header.c_str(), // fix: use p_s_classname here as well\r\n"
			"							  n_base, n_decompressor_crc, n_base, n_base);\r\n"
			"				// implement the body of the dummy routine that calls the decompress a"
			"fter we declared it\r\n"
			"			} else {\r\n"
			"				fprintf(p_fw, \"\\nprotected:\\n%s};\\n\", s_decompress_src.c_str());"
			"\r\n"
			"				// otherwise make the decompressor a part of the file class\r\n"
			"			}\r\n"
			"		} else\r\n"
			"			fprintf(p_fw, \"};\\n\");\r\n"
			"		// include decompressor, make it so that the code can be shared if more than a"
			" single file is included\r\n"
			"\r\n"
			"		fprintf(p_fw, \"\\n#endif // !__%s_FILE_IN_HEADER_INCLUDED\\n\", s_ident.c_str"
			"());\r\n"
			"\r\n"
			"		if(ferror(p_fw)) {\r\n"
			"			fprintf(stderr, \"error: failed to write code to \\\'%s\\\'\\n\", p_s_outf"
			"ile);\r\n"
			"			return -1;\r\n"
			"		}\r\n"
			"\r\n"
			"		fclose(p_fw);\r\n"
			"	}\r\n"
			"	// write C++ header file\r\n"
			"\r\n"
			"	if(b_verbose)\r\n"
			"		printf(\"\\ndone\\n\");\r\n"
			"\r\n"
			"	return 0;\r\n"
			"}\r\n"
		};
		char *p_s_text;
		if(!(p_s_text = new(std::nothrow) char[53113]))
			return 0;
		char *p_s_dest = p_s_text;
		for(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_array[0]); i < n; ++ i) {
			size_t n_chunk = strlen(p_text_array[i]);
			memcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char));
			p_s_dest += n_chunk;
		}
		*p_s_dest = 0;
		return p_s_text;
	}
};

#endif // !__MAIN_CPP_FILE_IN_HEADER_INCLUDED
