/**
 *	@file Test_TextMode2.h
 *	@brief file in header, generated from 'Main.cpp'
 *		stored as plain text
 *	@date 2016-06-30 12:20:35
 *	@author FileToHeader v2.03 (built Jul 19 2016)
 */

#pragma once
#ifndef __MAIN_CPP_FILE_IN_HEADER_INCLUDED
#define __MAIN_CPP_FILE_IN_HEADER_INCLUDED

/**
 *	@brief file in header, generated from 'Main.cpp'
 */
class CMain_cpp {
public:
	/**
	 *	@brief gets size of the data
	 *	@return Returns size of the data, in bytes, not including the terminating zero.
	 */
	static inline size_t n_Size()
	{
		return 51728; // original file 53112 B
	}

	/**
	 *	@brief determines whether the stored string is dynamically allocated
	 *	@return Returns true if the caller of p_Data() needs to free the memory.
	 */
	static inline bool b_Dynamic()
	{
		return true;
	}

	/**
	 *	@brief gets CRC
	 *	@return Returns CRC32 of the stored data.
	 *	@note The stored CRC may differ from the original file if data processing was enabled.
	 */
	static inline uint32_t n_CRC32()
	{
		return 0x74b75d2b; // original file 0xf208554c
	}

	/**
	 *	@brief gets data
	 *
	 *	@return Returns data of the file on success, 0 on failure (not enough memory).
	 *
	 *	@note The data (despite it may be binary), is additionally null terminated to make
	 *		it easier to use (the terminating null is not counted in n_Size()).
	 *	@note See also b_Dynamic().
	 */
	static inline char *p_Data()
	{
		const char *p_text_array[] = {
			/*    1 */ "/*\n"
			/*    2 */ "								+----------------------------------+\n"
			/*    3 */ "								|                                  |\n"
			/*    4 */ "								|    ***   File to header   ***    |\n"
			/*    5 */ "								|                                  |\n"
			/*    6 */ "								|   Copyright \xa9 -tHE SWINe- 2009   |\n"
			/*    7 */ "								|                                  |\n"
			/*    8 */ "								|             Main.cpp             |\n"
			/*    9 */ "								|                                  |\n"
			/*   10 */ "								+----------------------------------+\n"
			/*   11 */ "*/\n"
			/*   12 */ "\n"
			/*   13 */ "#include \"../UberLame_src/NewFix.h\"\n"
			/*   14 */ "#include \"../UberLame_src/CallStack.h\"\n"
			/*   15 */ "#include <string.h>\n"
			/*   16 */ "#include <stdlib.h>\n"
			/*   17 */ "#include <stdio.h>\n"
			/*   18 */ "#include <vector>\n"
			/*   19 */ "#include <string>\n"
			/*   20 */ "#include <algorithm>\n"
			/*   21 */ "#include \"../UberLame_src/Integer.h\"\n"
			/*   22 */ "#include \"../UberLame_src/Tga.h\"\n"
			/*   23 */ "#include \"../UberLame_src/Jpeg.h\"\n"
			/*   24 */ "#include \"../UberLame_src/MinMax.h\"\n"
			/*   25 */ "#include \"../UberLame_src/StlUtils.h\"\n"
			/*   26 */ "#include \"../UberLame_src/Buffer.h\"\n"
			/*   27 */ "#include \"../UberLame_src/Compress.h\"\n"
			/*   28 */ "#include \"../UberLame_src/Base64.h\"\n"
			/*   29 */ "#include \"../UberLame_src/Base85.h\"\n"
			/*   30 */ "#include \"../UberLame_src/Crc.h\"\n"
			/*   31 */ "#include \"../UberLame_src/Dir.h\"\n"
			/*   32 */ "\n"
			/*   33 */ "#if defined(_MSC_VER) && !defined(__MWERKS__) && !defined(for) && _MSC_VER "
					   "<= 1200\n"
			/*   34 */ "#define for if(0) {} else for\n"
			/*   35 */ "#endif // _MSC_VER && !__MWERKS__ && !for && _MSC_VER <= 1200\n"
			/*   36 */ "// msvc \'for\' scoping hack\n"
			/*   37 */ "\n"
			/*   38 */ "#define APP_VERSION \"v2.03\"\n"
			/*   39 */ "\n"
			/*   40 */ "bool ReadFile(TBuffer &r_t_output, const char *p_s_filename)\n"
			/*   41 */ "{\n"
			/*   42 */ "	FILE *p_fr;\n"
			/*   43 */ "#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\n"
			/*   44 */ "	if(fopen_s(&p_fr, p_s_filename, \"rb\"))\n"
			/*   45 */ "#else //_MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\n"
			/*   46 */ "	if(!(p_fr = fopen(p_s_filename, \"rb\")))\n"
			/*   47 */ "#endif //_MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\n"
			/*   48 */ "		return false;\n"
			/*   49 */ "	int n_length;\n"
			/*   50 */ "	if(fseek(p_fr, 0, SEEK_END) ||\n"
			/*   51 */ "	   (n_length = ftell(p_fr)) < 0 ||\n"
			/*   52 */ "	   fseek(p_fr, 0, SEEK_SET)) {\n"
			/*   53 */ "		fclose(p_fr);\n"
			/*   54 */ "		return false;\n"
			/*   55 */ "	}\n"
			/*   56 */ "	if(!r_t_output.Resize(n_length, false)) {\n"
			/*   57 */ "		fclose(p_fr);\n"
			/*   58 */ "		return false;\n"
			/*   59 */ "	}\n"
			/*   60 */ "	if(fread(r_t_output.p_Data(), n_length, sizeof(uint8_t), p_fr) != 1) {"
					   "\n"
			/*   61 */ "		fclose(p_fr);\n"
			/*   62 */ "		return false;\n"
			/*   63 */ "	}\n"
			/*   64 */ "	fclose(p_fr);\n"
			/*   65 */ "	return true;\n"
			/*   66 */ "}\n"
			/*   67 */ "\n"
			/*   68 */ "bool ReadFile(std::string &r_s_output, const char *p_s_filename)\n"
			/*   69 */ "{\n"
			/*   70 */ "	FILE *p_fr;\n"
			/*   71 */ "#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\n"
			/*   72 */ "	if(fopen_s(&p_fr, p_s_filename, \"rb\"))\n"
			/*   73 */ "#else //_MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\n"
			/*   74 */ "	if(!(p_fr = fopen(p_s_filename, \"rb\")))\n"
			/*   75 */ "#endif //_MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\n"
			/*   76 */ "		return false;\n"
			/*   77 */ "	int n_length;\n"
			/*   78 */ "	if(fseek(p_fr, 0, SEEK_END) ||\n"
			/*   79 */ "	   (n_length = ftell(p_fr)) < 0 ||\n"
			/*   80 */ "	   fseek(p_fr, 0, SEEK_SET)) {\n"
			/*   81 */ "		fclose(p_fr);\n"
			/*   82 */ "		return false;\n"
			/*   83 */ "	}\n"
			/*   84 */ "	r_s_output.erase();\n"
			/*   85 */ "	if(!stl_ut::Resize_To_N(r_s_output, n_length)) {\n"
			/*   86 */ "		fclose(p_fr);\n"
			/*   87 */ "		return false;\n"
			/*   88 */ "	}\n"
			/*   89 */ "	if(fread(&r_s_output[0], n_length, sizeof(char), p_fr) != 1) {\n"
			/*   90 */ "		fclose(p_fr);\n"
			/*   91 */ "		return false;\n"
			/*   92 */ "	}\n"
			/*   93 */ "	fclose(p_fr);\n"
			/*   94 */ "	return true;\n"
			/*   95 */ "}\n"
			/*   96 */ "\n"
			/*   97 */ "void EscapeString(std::string &r_s_str) // throws\n"
			/*   98 */ "{\n"
			/*   99 */ "	for(size_t i = 0, n = r_s_str.length(); i < n; ++ i) {\n"
			/*  100 */ "		if((uint8_t(r_s_str[i]) < \' \' && r_s_str[i] != \'\\t\') || // kee"
					   "p tabs, we like it\n"
			/*  101 */ "		   r_s_str[i] == \'\\\'\' || r_s_str[i] == \'\\\"\' || r_s_str[i] ="
					   "= \'\\\\\') { // need to handle quotes\n"
			/*  102 */ "			char n_seq = 0;\n"
			/*  103 */ "			switch(r_s_str[i]) {\n"
			/*  104 */ "			case \'\\n\':\n"
			/*  105 */ "				n_seq = \'n\';\n"
			/*  106 */ "				break;\n"
			/*  107 */ "			case \'\\r\':\n"
			/*  108 */ "				n_seq = \'r\';\n"
			/*  109 */ "				break;\n"
			/*  110 */ "			case \'\\\\\':\n"
			/*  111 */ "				n_seq = \'\\\\\';\n"
			/*  112 */ "				break;\n"
			/*  113 */ "			case \'\\\'\':\n"
			/*  114 */ "				n_seq = \'\\\'\';\n"
			/*  115 */ "				break;\n"
			/*  116 */ "			case \'\\\"\':\n"
			/*  117 */ "				n_seq = \'\\\"\';\n"
			/*  118 */ "				break;\n"
			/*  119 */ "			/*case \'\\t\':\n"
			/*  120 */ "				n_seq = \'t\';\n"
			/*  121 */ "				break;*/ // keep tabs, we like it\n"
			/*  122 */ "			case \'\\f\':\n"
			/*  123 */ "				n_seq = \'f\';\n"
			/*  124 */ "				break;\n"
			/*  125 */ "			case \'\\a\':\n"
			/*  126 */ "				n_seq = \'a\';\n"
			/*  127 */ "				break;\n"
			/*  128 */ "			case \'\\b\':\n"
			/*  129 */ "				n_seq = \'b\';\n"
			/*  130 */ "				break;\n"
			/*  131 */ "			case \'\\v\':\n"
			/*  132 */ "				n_seq = \'v\';\n"
			/*  133 */ "				break;\n"
			/*  134 */ "			};\n"
			/*  135 */ "			// see if we can find escape sequence for this character\n"
			/*  136 */ "\n"
			/*  137 */ "			if(n_seq) {\n"
			/*  138 */ "				r_s_str[i] = n_seq;\n"
			/*  139 */ "				r_s_str.insert(i, 1, \'\\\\\');\n"
			/*  140 */ "				++ i;\n"
			/*  141 */ "				++ n; // !!\n"
			/*  142 */ "			} else {\n"
			/*  143 */ "				char p_s_xseq[64];\n"
			/*  144 */ "				stl_ut::Format(p_s_xseq, sizeof(p_s_xseq), \"x%02x\", int(r"
					   "_s_str[i]));\n"
			/*  145 */ "				r_s_str[i] = \'\\\\\';\n"
			/*  146 */ "				r_s_str.insert(i + 1, (const char*)p_s_xseq);\n"
			/*  147 */ "				size_t l = strlen(p_s_xseq);\n"
			/*  148 */ "				i += l;\n"
			/*  149 */ "				n += l; // !!\n"
			/*  150 */ "			}\n"
			/*  151 */ "			// escape low characters\n"
			/*  152 */ "		} else if(uint8_t(r_s_str[i]) >= 128) {\n"
			/*  153 */ "			char p_s_xseq[64];\n"
			/*  154 */ "			stl_ut::Format(p_s_xseq, sizeof(p_s_xseq), \"x%02x\", int(uint8"
					   "_t(r_s_str[i]))); // make sure it is not negative\n"
			/*  155 */ "			r_s_str[i] = \'\\\\\';\n"
			/*  156 */ "			r_s_str.insert(i + 1, (const char*)p_s_xseq);\n"
			/*  157 */ "			size_t l = strlen(p_s_xseq);\n"
			/*  158 */ "			i += l;\n"
			/*  159 */ "			n += l; // !!\n"
			/*  160 */ "			// escape big characters\n"
			/*  161 */ "		}\n"
			/*  162 */ "	}\n"
			/*  163 */ "	// todo - not sure what happens if \"\\x12\" escape sequence is followe"
					   "d by a [0-9a-f] letter?\n"
			/*  164 */ "	// maybe need to escape even simple letters until the next letter is an"
					   "other one\n"
			/*  165 */ "}\n"
			/*  166 */ "\n"
			/*  167 */ "// t_odo - skip mutliline comments, actually not that hard, first erase the"
					   " single line comment,\n"
			/*  168 */ "// then just make sure that there is no \"\\\"\" before the \"/*\" and then"
					   " erase everything up to the next \"*/\"\n"
			/*  169 */ "// not checking for the line comments\n"
			/*  170 */ "\n"
			/*  171 */ "// note that decoupling comments from printing would make it much easier\n"
			/*  172 */ "\n"
			/*  173 */ "/*void Strip_LineComment(std::string &r_s_comment, std::string &r_s_line,\n"
			/*  174 */ "	size_t n_line, size_t n_line_num, uint64_t &r_n_file_size)\n"
			/*  175 */ "{\n"
			/*  176 */ "	r_s_comment.clear();\n"
			/*  177 */ "	// !!\n"
			/*  178 */ "\n"
			/*  179 */ "	size_t n_pos;\n"
			/*  180 */ "	if((n_pos = r_s_line.find(\"//\")) != std::string::npos &&\n"
			/*  181 */ "	   (r_s_line.rfind(\'\\\"\', n_pos) == std::string::npos ||\n"
			/*  182 */ "	   r_s_line.find(\'\\\"\', n_pos) == std::string::npos) && // not arrou"
					   "nd strings, seems dangerous (can have strings before or in, but not on both"
					   " sides)\n"
			/*  183 */ "	   (r_s_line[r_s_line.length() - 1] == \'\\n\' || (r_s_line[r_s_line.le"
					   "ngth() - 2] == \'\\\\\' &&\n"
			/*  184 */ "	   r_s_line[r_s_line.length() - 1] == \'n\') || n_line + 1 == n_line_nu"
					   "m)) { // must be the whole line here (so that the comment also ends)\n"
			/*  185 */ "		if(r_s_line[r_s_line.length() - 1] == \'n\') {\n"
			/*  186 */ "			size_t e = r_s_line.length() - 1, n_slash_num = 0;\n"
			/*  187 */ "			while(e > 0 && r_s_line[e - 1] == \'\\\\\') {\n"
			/*  188 */ "				-- e;\n"
			/*  189 */ "				++ n_slash_num;\n"
			/*  190 */ "			}\n"
			/*  191 */ "			_ASSERTE(n_slash_num > 0);\n"
			/*  192 */ "			if(!(n_slash_num & 1))\n"
			/*  193 */ "				return;\n"
			/*  194 */ "		}\n"
			/*  195 */ "		// this can still turn out bad, the end \"\\n\" might be something "
					   "like \"\\\\n\" and\n"
			/*  196 */ "		// the backslash does not belong to the \"n\" and hence the line do"
					   "es not in fact end in a newline\n"
			/*  197 */ "		// or it can be \"\\\\\\n\" and then it is ok \"\\\\a\\\\n\" does n"
					   "ot get confused - so only need to count\n"
			/*  198 */ "		// the consecutive backslashes and if even, it is not a newline\n"
			/*  199 */ "\n"
			/*  200 */ "		size_t n_end = r_s_line.length();\n"
			/*  201 */ "		if(n_end > 1 && r_s_line[n_end - 2] == \'\\\\\' && r_s_line[n_end -"
					   " 1] == \'n\')\n"
			/*  202 */ "			n_end -= 2;\n"
			/*  203 */ "		else if(n_end > 1 && r_s_line[n_end - 1] == \'\\n\')\n"
			/*  204 */ "			-- n_end;\n"
			/*  205 */ "		// skip the newline at the end\n"
			/*  206 */ "\n"
			/*  207 */ "		r_s_comment.insert(r_s_comment.end(),\n"
			/*  208 */ "			r_s_line.begin() + n_pos,\n"
			/*  209 */ "			r_s_line.begin() + n_end);\n"
			/*  210 */ "		// extract the comment\n"
			/*  211 */ "\n"
			/*  212 */ "		while(n_pos > 0 && isspace(uint8_t(r_s_line[n_pos - 1])))\n"
			/*  213 */ "			-- n_pos;\n"
			/*  214 */ "		// skip whitespace before the comment\n"
			/*  215 */ "\n"
			/*  216 */ "		size_t n_comment_escape_num = 0;\n"
			/*  217 */ "		for(size_t i = 0, n = r_s_comment.length(); i < n; ++ i) {\n"
			/*  218 */ "			if(r_s_comment[i] == \'\\\\\') {\n"
			/*  219 */ "				if(i + 1 < n && r_s_comment[i + 1] == \'x\')\n"
			/*  220 */ "					n_comment_escape_num += 3; // e.g. \\x01\n"
			/*  221 */ "				else\n"
			/*  222 */ "					++ n_comment_escape_num;\n"
			/*  223 */ "				++ i; // to avoid counting backslash escape seq. twice\n"
			/*  224 */ "			}\n"
			/*  225 */ "		}\n"
			/*  226 */ "		// counts escape sequences in strings (!!)\n"
			/*  227 */ "\n"
			/*  228 */ "		r_n_file_size -= n_end - n_pos; // account for it in the file size"
					   "\n"
			/*  229 */ "		r_n_file_size += n_comment_escape_num; // these were accounted for "
					   "twice\n"
			/*  230 */ "		r_s_line.erase(r_s_line.begin() + n_pos,\n"
			/*  231 */ "			r_s_line.begin() + n_end);\n"
			/*  232 */ "		// erase the comment from the original string\n"
			/*  233 */ "	}\n"
			/*  234 */ "}*/\n"
			/*  235 */ "\n"
			/*  236 */ "#if 0\n"
			/*  237 */ "void Base64_Evolution()\n"
			/*  238 */ "{\n"
			/*  239 */ "	int p_ic_tab[128] = {0};\n"
			/*  240 */ "	/*for(unsigned int i = 0; i < 128; ++ i) {\n"
			/*  241 */ "		p_ic_tab[i] = (isalpha(i))? (i | 32) - \'a\' + ((i < \'a\')? 0 : 26"
					   ") :\n"
			/*  242 */ "			(isdigit(i))? i - \'0\' + 52 : (i == \'+\')? 62 : 63;\n"
			/*  243 */ "	}*/\n"
			/*  244 */ "	for(int i = 0; i < 64; ++ i)\n"
			/*  245 */ "		p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : \""
					   "+/\"[i - 62]] = i;\n"
			/*  246 */ "		//p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : "
					   "(i - 51) * 4 - 1] = i;\n"
			/*  247 */ "		//p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : "
					   "(i > 62)? \'/\' : \'+\'] = i;\n"
			/*  248 */ "		//p_ic_tab[(i < 26)? \'A\' + i : (i < 52)? \'a\' - 26 + i : (i < 62"
					   ")? \'0\' - 52 + i : (i == 62)? \'+\' : \'/\'] = i;\n"
			/*  249 */ "		//p_ic_tab[\"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz01"
					   "23456789+/\"[i]] = i;\n"
			/*  250 */ "}\n"
			/*  251 */ "#endif // 0\n"
			/*  252 */ "\n"
			/*  253 */ "void PrintHelp()\n"
			/*  254 */ "{\n"
			/*  255 */ "	fprintf(stderr, \"error: missing program arguments.\\n\"\n"
			/*  256 */ "		\"usage:\\n\"\n"
			/*  257 */ "		\"FileToHeader <input-file> <header-file> [options]\\n\"\n"
			/*  258 */ "		\"where input-file is source file, containing data in text or binar"
					   "y format,\\n\"\n"
			/*  259 */ "		\"and header-file is output file to contain this data.\\n\"\n"
			/*  260 */ "		\"\\nOptions may be the following:\\n\"\n"
			/*  261 */ "		\"--verbose parameter turns on verbose output (default off)\\n\"\n"
			/*  262 */ "		\"--name-after overrides input file name for naming the class (in c"
					   "ase the input file\\n\"\n"
			/*  263 */ "		\"             is an intermediate of a longer processing chain and "
					   "does not have a name)\\n\"\n"
			/*  264 */ "		\"--class-name overrides the default class name (not checked for sy"
					   "ntax errors)\\n\"\n"
			/*  265 */ "		\"--binary forces binary encoding with compression (binary data / o"
					   "bfuscation)\\n\"\n"
			/*  266 */ "		\"--text saves the input file as transparent text (default)\\n\"\n"
			/*  267 */ "		\"--max-cstr-len sets maximum \\\"C\\\"-string length (default 3276"
					   "7)\\n\"\n"
			/*  268 */ "		\"--max-line-len sets maximum line length in the generated header"
					   "\\n\"\n"
			/*  269 */ "		\"               (only applies to the lines with data; default 100)"
					   "\\n\"\n"
			/*  270 */ "		\"\\nThe following options only apply in text mode:\\n\"\n"
			/*  271 */ "		\"--keep-newlines transcripts newlines as they are found in the fil"
					   "e\\n\"\n"
			/*  272 */ "		\"--unix-newlines forces single \\\'\\\\n\\\' newlines (default)\\n"
					   "\"\n"
			/*  273 */ "		\"--strip-comments enables processing of C++ line comments (the com"
					   "ents are present\\n\"\n"
			/*  274 */ "		\"                 in the header, but are not part of the string)"
					   "\\n\"\n"
			/*  275 */ "		\"--line-numbers enables putting line numbers as comments in the ou"
					   "tput file\\n\"\n"
			/*  276 */ "		\"                 for example to aid debugging without the origina"
					   "l file, etc.\\n\"\n"
			/*  277 */ "		\"--trim-line-whitespace enables throwing away line whitespace\\n\""
					   "\n"
			/*  278 */ "		\"--discard-empty-lines enables throwing away lines with nothing bu"
					   "t whitespace\\n\"\n"
			/*  279 */ "		\"\\nThe following options only apply in binary mode:\\n\"\n"
			/*  280 */ "		\"--shared-decompress enables shared decompressor class (disabled b"
					   "y default)\\n\"\n"
			/*  281 */ "		\"--force-text-ops enables text processing operations (disabled by "
					   "default)\\n\"\n"
			/*  282 */ "		\"--base-64 forces the use of Base-64 instead of the default Base-8"
					   "5\\n\");\n"
			/*  283 */ "}\n"
			/*  284 */ "\n"
			/*  285 */ "#include \"Decompress64.h\"\n"
			/*  286 */ "#include \"Decompress64Src.h\"\n"
			/*  287 */ "#include \"Decompress85.h\"\n"
			/*  288 */ "#include \"Decompress85Src.h\"\n"
			/*  289 */ "\n"
			/*  290 */ "//#include \"Test_TextMode3.h\" // simple test\n"
			/*  291 */ "\n"
			/*  292 */ "void TrimSpace_but_EndLine(std::string &r_s_line)\n"
			/*  293 */ "{\n"
			/*  294 */ "	size_t b = 0, e = r_s_line.length();\n"
			/*  295 */ "\n"
			/*  296 */ "	while(e > b && (r_s_line[e - 1] == \'\\r\' || r_s_line[e - 1] == \'\\n"
					   "\'))\n"
			/*  297 */ "		-- e;\n"
			/*  298 */ "	// keep newline\n"
			/*  299 */ "\n"
			/*  300 */ "	size_t e2 = e;\n"
			/*  301 */ "	while(b < e2 && isspace(uint8_t(r_s_line[b])))\n"
			/*  302 */ "		++ b;\n"
			/*  303 */ "	while(b < e2 && isspace(uint8_t(r_s_line[e2 - 1])))\n"
			/*  304 */ "		-- e2;\n"
			/*  305 */ "	// find whitespace\n"
			/*  306 */ "\n"
			/*  307 */ "	r_s_line.erase(e2, e - e2);\n"
			/*  308 */ "	r_s_line.erase(0, b);\n"
			/*  309 */ "}\n"
			/*  310 */ "\n"
			/*  311 */ "int main(int n_arg_num, const char **p_arg_list)\n"
			/*  312 */ "{\n"
			/*  313 */ "	if(n_arg_num < 3) {\n"
			/*  314 */ "		PrintHelp();\n"
			/*  315 */ "		return 0;\n"
			/*  316 */ "	}\n"
			/*  317 */ "\n"
			/*  318 */ "	/*{\n"
			/*  319 */ "		int m = CMain_cpp::n_Size();\n"
			/*  320 */ "		const char *p_s_text = (const char*)CMain_cpp::p_Data();\n"
			/*  321 */ "		int n = strlen(p_s_text);\n"
			/*  322 */ "		if(m == n)\n"
			/*  323 */ "			printf(\"recorded and actual length (%d) matches\\n\", m);\n"
			/*  324 */ "		else\n"
			/*  325 */ "			printf(\"recorded (%d) and actual (%d) length do not match\\n\""
					   ", m, n);\n"
			/*  326 */ "		uint32_t n_crc = CCrc_32::n_Crc(n, p_s_text);\n"
			/*  327 */ "		if(n_crc == CMain_cpp::n_CRC32())\n"
			/*  328 */ "			printf(\"recorded and actual CRC (0x%08x) matches\\n\", n_crc);"
					   "\n"
			/*  329 */ "		else\n"
			/*  330 */ "			printf(\"recorded (0x%08x) and actual (0x%08x) CRC do not match"
					   "\\n\", CMain_cpp::n_CRC32(), n_crc);\n"
			/*  331 */ "		FILE *p_fw = fopen(\"test_writeback.h\", \"wb\");\n"
			/*  332 */ "		fprintf(p_fw, \"%s\", p_s_text);\n"
			/*  333 */ "		fclose(p_fw);\n"
			/*  334 */ "		if(CMain_cpp::b_Dynamic())\n"
			/*  335 */ "			free((char*)p_s_text);\n"
			/*  336 */ "	}*/ // simple test\n"
			/*  337 */ "\n"
			/*  338 */ "	unsigned int n_max_string_length = 32767; // to avoid c++ compilers com"
					   "plaining\n"
			/*  339 */ "	unsigned int n_max_line_length = 100;\n"
			/*  340 */ "	bool b_verbose = false;\n"
			/*  341 */ "	bool b_binary_mode = false;\n"
			/*  342 */ "	bool b_prefix_line_numbers = false; // in text mode, add /* 123 */ line"
					   " numbers in front of the strings with the lines\n"
			/*  343 */ "	bool b_overriden_newline_mode = false; // if --keep-newlines or --unix-"
					   "newlines was specified\n"
			/*  344 */ "	bool b_unix_newlines = true; // in text mode, replaces \"\\r\\n\" seque"
					   "nces for only \"\\n\"\n"
			/*  345 */ "	bool b_strip_line_comments = false; // in text mode, get \"// line comm"
					   "ents\" and put them outside of the text, effectively reducing the payload\n"
			/*  346 */ "	bool b_shared_decompress = false; // whether to make the decompression "
					   "routine shared (potentially leads to link conflicts)\n"
			/*  347 */ "	bool b_treat_binary_as_text = false; // force text processing in binary"
					   " mode as well\n"
			/*  348 */ "	bool b_trim_line_whitespace = false; // throw away leading and trailing"
					   " whitespace (except the newline) on each line\n"
			/*  349 */ "	bool b_discard_empty_lines = false; // throw away lines that only conta"
					   "in whitespace (including a newline)\n"
			/*  350 */ "	bool b_use_base85 = true; // use Base-85 instead of Base-64 (default)\n"
			/*  351 */ "	const int n_tab_size = 4;\n"
			/*  352 */ "	// config\n"
			/*  353 */ "\n"
			/*  354 */ "	const char *p_s_infile = p_arg_list[1];\n"
			/*  355 */ "	const char *p_s_name_file = p_s_infile;\n"
			/*  356 */ "	const char *p_s_outfile = p_arg_list[2];\n"
			/*  357 */ "	const char *p_s_classname = 0;\n"
			/*  358 */ "\n"
			/*  359 */ "	for(int i = 3; i < n_arg_num; ++ i) {\n"
			/*  360 */ "		if(!strcmp(p_arg_list[i], \"--verbose\") || !strcmp(p_arg_list[i], "
					   "\"-v\"))\n"
			/*  361 */ "			b_verbose = true;\n"
			/*  362 */ "		else if(!strcmp(p_arg_list[i], \"--keep-newlines\") || !strcmp(p_ar"
					   "g_list[i], \"-kn\")) {\n"
			/*  363 */ "			b_unix_newlines = false;\n"
			/*  364 */ "			b_overriden_newline_mode = true;\n"
			/*  365 */ "		} else if(!strcmp(p_arg_list[i], \"-h\") || !strcmp(p_arg_list[i], "
					   "\"--help\")) {\n"
			/*  366 */ "			PrintHelp();\n"
			/*  367 */ "			return 0;\n"
			/*  368 */ "		} else if(!strcmp(p_arg_list[i], \"--unix-newlines\") || !strcmp(p_"
					   "arg_list[i], \"-un\")) {\n"
			/*  369 */ "			b_unix_newlines = true;\n"
			/*  370 */ "			b_overriden_newline_mode = true;\n"
			/*  371 */ "		} else if(!strcmp(p_arg_list[i], \"--shared-decompress\") || !strcm"
					   "p(p_arg_list[i], \"-sd\"))\n"
			/*  372 */ "			b_shared_decompress = true;\n"
			/*  373 */ "		else if(!strcmp(p_arg_list[i], \"--line-numbers\") || !strcmp(p_arg"
					   "_list[i], \"-ln\"))\n"
			/*  374 */ "			b_prefix_line_numbers = true;\n"
			/*  375 */ "		else if(!strcmp(p_arg_list[i], \"--strip-comments\") || !strcmp(p_a"
					   "rg_list[i], \"-sc\"))\n"
			/*  376 */ "			b_strip_line_comments = true;\n"
			/*  377 */ "		else if(!strcmp(p_arg_list[i], \"--trim-line-whitespace\") || !strc"
					   "mp(p_arg_list[i], \"-tlw\"))\n"
			/*  378 */ "			b_trim_line_whitespace = true;\n"
			/*  379 */ "		else if(!strcmp(p_arg_list[i], \"--discard-empty-lines\") || !strcm"
					   "p(p_arg_list[i], \"-del\"))\n"
			/*  380 */ "			b_discard_empty_lines = true;\n"
			/*  381 */ "		else if(!strcmp(p_arg_list[i], \"--binary\") || !strcmp(p_arg_list["
					   "i], \"-b\"))\n"
			/*  382 */ "			b_binary_mode = true;\n"
			/*  383 */ "		else if(!strcmp(p_arg_list[i], \"--text\") || !strcmp(p_arg_list[i]"
					   ", \"-t\"))\n"
			/*  384 */ "			b_binary_mode = false;\n"
			/*  385 */ "		else if(!strcmp(p_arg_list[i], \"--force-text-ops\") || !strcmp(p_a"
					   "rg_list[i], \"-fto\"))\n"
			/*  386 */ "			b_treat_binary_as_text = true;\n"
			/*  387 */ "		else if(!strcmp(p_arg_list[i], \"--base-64\") || !strcmp(p_arg_list"
					   "[i], \"-b64\"))\n"
			/*  388 */ "			b_use_base85 = false;\n"
			/*  389 */ "		else if(i + 1 == n_arg_num) {\n"
			/*  390 */ "			fprintf(stderr, \"warning: parameter: \\\'%s\\\': \"\n"
			/*  391 */ "				\"unknown parameter or needs a value (skipping)\\n\", p_arg"
					   "_list[i]);\n"
			/*  392 */ "		} else if(!strcmp(p_arg_list[i], \"--max-line-len\") || !strcmp(p_a"
					   "rg_list[i], \"-mll\"))\n"
			/*  393 */ "			n_max_line_length = atol(p_arg_list[++ i]);\n"
			/*  394 */ "		else if(!strcmp(p_arg_list[i], \"--max-cstr-len\") || !strcmp(p_arg"
					   "_list[i], \"-mcsl\"))\n"
			/*  395 */ "			n_max_string_length = atol(p_arg_list[++ i]);\n"
			/*  396 */ "		else if(!strcmp(p_arg_list[i], \"--class-name\") || !strcmp(p_arg_l"
					   "ist[i], \"-cn\"))\n"
			/*  397 */ "			p_s_classname = p_arg_list[++ i];\n"
			/*  398 */ "		else if(!strcmp(p_arg_list[i], \"--name-after\") || !strcmp(p_arg_l"
					   "ist[i], \"-na\"))\n"
			/*  399 */ "			p_s_name_file = p_arg_list[++ i];\n"
			/*  400 */ "		else\n"
			/*  401 */ "			fprintf(stderr, \"warning: unknown parameter: \\\'%s\\\' (skipp"
					   "ing)\\n\", p_arg_list[i]);\n"
			/*  402 */ "	}\n"
			/*  403 */ "	// parse command-line\n"
			/*  404 */ "\n"
			/*  405 */ "	if(b_binary_mode) {\n"
			/*  406 */ "		if(!b_treat_binary_as_text) {\n"
			/*  407 */ "			if(b_prefix_line_numbers || b_overriden_newline_mode || b_strip"
					   "_line_comments ||\n"
			/*  408 */ "			   b_trim_line_whitespace || b_discard_empty_lines) {\n"
			/*  409 */ "				fprintf(stderr, \"warning: --force-text-ops not specified, "
					   "all\"\n"
			/*  410 */ "					\" text operations ignored in binary mode\\n\");\n"
			/*  411 */ "			}\n"
			/*  412 */ "		} else {\n"
			/*  413 */ "			if(b_prefix_line_numbers)\n"
			/*  414 */ "				fprintf(stderr, \"warning: --line-numbers ignored in binary"
					   " mode\\n\");\n"
			/*  415 */ "		}\n"
			/*  416 */ "	} else {\n"
			/*  417 */ "		if(b_treat_binary_as_text)\n"
			/*  418 */ "			fprintf(stderr, \"warning: --force-text-ops ignored in text mod"
					   "e\\n\");\n"
			/*  419 */ "		if(!b_use_base85)\n"
			/*  420 */ "			fprintf(stderr, \"warning: --base-64 ignored in text mode\\n\")"
					   ";\n"
			/*  421 */ "	}\n"
			/*  422 */ "	// check command-line\n"
			/*  423 */ "\n"
			/*  424 */ "	if(b_verbose)\n"
			/*  425 */ "		printf(\"FileToHeader \" APP_VERSION \" (built \" __DATE__ \")\\n"
					   "\\n\");\n"
			/*  426 */ "	// print version\n"
			/*  427 */ "\n"
			/*  428 */ "	n_max_string_length = max(n_max_string_length, n_max_line_length);\n"
			/*  429 */ "	// must be at least the same\n"
			/*  430 */ "\n"
			/*  431 */ "	n_max_line_length -= 2; // the quotes\n"
			/*  432 */ "	n_max_line_length -= 3 * n_tab_size; // the tabs\n"
			/*  433 */ "\n"
			/*  434 */ "	if(b_verbose)\n"
			/*  435 */ "		printf(\"loading input file ...\\n\");\n"
			/*  436 */ "\n"
			/*  437 */ "	uint64_t n_file_size = -1, n_orig_file_size = -1;\n"
			/*  438 */ "	bool b_is_dynamic = false;\n"
			/*  439 */ "	uint32_t n_crc32 = 0, n_orig_crc32 = 0;\n"
			/*  440 */ "	std::string s_data;\n"
			/*  441 */ "	int n_base = (b_use_base85)? 85 : 64; // if compressed\n"
			/*  442 */ "	try {\n"
			/*  443 */ "		std::string s_file;\n"
			/*  444 */ "		std::vector<int> line_no;\n"
			/*  445 */ "		char p_s_line_no_format[64];\n"
			/*  446 */ "		char p_s_hide_line_no[64];\n"
			/*  447 */ "		std::vector<std::string> line_list;\n"
			/*  448 */ "		std::vector<std::vector<std::string> > line_comment_list;\n"
			/*  449 */ "		// text processing data (shared now)\n"
			/*  450 */ "\n"
			/*  451 */ "		if(!b_binary_mode || b_treat_binary_as_text) {\n"
			/*  452 */ "			if(!ReadFile(s_file, p_s_infile)) {\n"
			/*  453 */ "				fprintf(stderr, \"error: failed to load \\\'%s\\\'\\n\", p_"
					   "s_infile);\n"
			/*  454 */ "				return -1;\n"
			/*  455 */ "			}\n"
			/*  456 */ "			// read\n"
			/*  457 */ "\n"
			/*  458 */ "			if(s_file.find(\'\\0\') != std::string::npos) {\n"
			/*  459 */ "				fprintf(stderr, \"error: file \\\'%s\\\' contains null char"
					   "acters;\"\n"
			/*  460 */ "					\" must be saved as binary\\n\", p_s_infile);\n"
			/*  461 */ "				return -1;\n"
			/*  462 */ "			}\n"
			/*  463 */ "\n"
			/*  464 */ "			n_orig_crc32 = CCrc_32::n_Crc(s_file.length() * sizeof(char), s"
					   "_file.data());\n"
			/*  465 */ "			// calculate the original CRC32\n"
			/*  466 */ "\n"
			/*  467 */ "			n_file_size = s_file.size();\n"
			/*  468 */ "			n_orig_file_size = n_file_size;\n"
			/*  469 */ "			// take size now\n"
			/*  470 */ "\n"
			/*  471 */ "			if(b_unix_newlines) {\n"
			/*  472 */ "				size_t n_pos = 0;\n"
			/*  473 */ "				while((n_pos = s_file.find(\"\\r\\n\", n_pos)) != std::stri"
					   "ng::npos) {\n"
			/*  474 */ "					s_file.erase(n_pos, 1);\n"
			/*  475 */ "					++ n_pos;\n"
			/*  476 */ "				}\n"
			/*  477 */ "			}\n"
			/*  478 */ "			// take binary newlines \'\\r\\n\' and make them only \'\\n\'\n"
			/*  479 */ "\n"
			/*  480 */ "			stl_ut::Split(line_list, s_file, \"\\n\");\n"
			/*  481 */ "			for(size_t i = 0, n = line_list.size(); i + 1 < n; ++ i)\n"
			/*  482 */ "				line_list[i] += \'\\n\'; // keep newlines\n"
			/*  483 */ "			// split to lines\n"
			/*  484 */ "\n"
			/*  485 */ "			if(b_trim_line_whitespace) {\n"
			/*  486 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i)\n"
			/*  487 */ "					TrimSpace_but_EndLine(line_list[i]); // trim space\n"
			/*  488 */ "			}\n"
			/*  489 */ "			// trim line whitespace\n"
			/*  490 */ "\n"
			/*  491 */ "			if(b_verbose && b_binary_mode)\n"
			/*  492 */ "				printf(\"forced text processing | \");\n"
			/*  493 */ "			if(b_verbose)\n"
			/*  494 */ "				printf(\"have %d lines\\n\", line_list.size());\n"
			/*  495 */ "			// verbose\n"
			/*  496 */ "\n"
			/*  497 */ "			if(line_list.back().empty())\n"
			/*  498 */ "				line_list.erase(line_list.end() - 1);\n"
			/*  499 */ "			// erase the last empty line (without even newline on it), it l"
					   "ooks weird\n"
			/*  500 */ "\n"
			/*  501 */ "			if(b_prefix_line_numbers) {\n"
			/*  502 */ "				stl_ut::Format(p_s_line_no_format, sizeof(p_s_line_no_forma"
					   "t),\n"
			/*  503 */ "					PRIsize, line_list.size());\n"
			/*  504 */ "				size_t n_line_num_log10 = strlen(p_s_line_no_format);\n"
			/*  505 */ "				stl_ut::Format(p_s_line_no_format, sizeof(p_s_line_no_forma"
					   "t),\n"
			/*  506 */ "					\"/* %%%dd */ \", n_line_num_log10);\n"
			/*  507 */ "				// make format string for line numbers\n"
			/*  508 */ "\n"
			/*  509 */ "				char p_s_hide_line_no_format[64];\n"
			/*  510 */ "				stl_ut::Format(p_s_hide_line_no_format, sizeof(p_s_hide_lin"
					   "e_no_format),\n"
			/*  511 */ "					\"   %%%ds    \", n_line_num_log10); // just spaces\n"
			/*  512 */ "				stl_ut::Format(p_s_hide_line_no, sizeof(p_s_hide_line_no), "
					   "p_s_hide_line_no_format, \"\");\n"
			/*  513 */ "				for(int b = 0, e = strlen(p_s_hide_line_no); b < e; ++ b) {"
					   "\n"
			/*  514 */ "					if(b + n_tab_size < e) {\n"
			/*  515 */ "						p_s_hide_line_no[b] = \'\\t\';\n"
			/*  516 */ "						e -= n_tab_size - 1;\n"
			/*  517 */ "						p_s_hide_line_no[e] = 0;\n"
			/*  518 */ "					}\n"
			/*  519 */ "				}\n"
			/*  520 */ "				// make string for hidden line numbers (retarded but workin"
					   "g)\n"
			/*  521 */ "\n"
			/*  522 */ "				n_line_num_log10 += 7; // 7 = strlen(\"/* \") + strlen(\" *"
					   "/ \")\n"
			/*  523 */ "				if(n_max_line_length > n_line_num_log10)\n"
			/*  524 */ "					n_max_line_length -= n_line_num_log10;\n"
			/*  525 */ "				// include the line numbers in line length calculation\n"
			/*  526 */ "\n"
			/*  527 */ "				line_no.resize(line_list.size());\n"
			/*  528 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i)\n"
			/*  529 */ "					line_no[i] = i + 1;\n"
			/*  530 */ "				_ASSERTE(line_no.size() == line_list.size());\n"
			/*  531 */ "				// make a list of line numbers (a stupid approach, but easy"
					   " to get right)\n"
			/*  532 */ "			}\n"
			/*  533 */ "\n"
			/*  534 */ "			if(b_strip_line_comments) {\n"
			/*  535 */ "				line_comment_list.resize(line_list.size());\n"
			/*  536 */ "				bool b_in_multiline_comment = false;\n"
			/*  537 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  538 */ "					std::string &r_s_line = line_list[i];\n"
			/*  539 */ "					// get a line\n"
			/*  540 */ "\n"
			/*  541 */ "					_ASSERTE(!r_s_line.empty() && (i + 1 == n || r_s_line[r"
					   "_s_line.length() - 1] == \'\\n\'));\n"
			/*  542 */ "					// make sure each line ends in newline at this stage\n"
			/*  543 */ "\n"
			/*  544 */ "					size_t b = 0, e = r_s_line.length();\n"
			/*  545 */ "					if(b_in_multiline_comment) {\n"
			/*  546 */ "						if((b = r_s_line.find(\"*/\")) != std::string::npos"
					   ") {\n"
			/*  547 */ "							++ b;\n"
			/*  548 */ "							_ASSERTE(r_s_line[b - 1] == \'*\' && r_s_line[b"
					   "] == \'/\');\n"
			/*  549 */ "							// ignore everything else, just look for the en"
					   "d of the comment\n"
			/*  550 */ "\n"
			/*  551 */ "							size_t b2 = 0;\n"
			/*  552 */ "							while(isspace(uint8_t(r_s_line[b2])))\n"
			/*  553 */ "								++ b2;\n"
			/*  554 */ "							// find the beginning of the comment text\n"
			/*  555 */ "\n"
			/*  556 */ "							_ASSERTE(b > 0);\n"
			/*  557 */ "							size_t e4 = b - 1;\n"
			/*  558 */ "							while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - "
					   "1])))\n"
			/*  559 */ "								-- e4;\n"
			/*  560 */ "							// find the end of the comment text\n"
			/*  561 */ "\n"
			/*  562 */ "							std::string s_comment;\n"
			/*  563 */ "							s_comment.insert(s_comment.begin(), r_s_line.be"
					   "gin() + b2, r_s_line.begin() + e4);\n"
			/*  564 */ "							if(!s_comment.empty())\n"
			/*  565 */ "								line_comment_list[i].push_back(s_comment);"
					   "\n"
			/*  566 */ "							r_s_line.erase(r_s_line.begin(), r_s_line.begin"
					   "() + (b + 1));\n"
			/*  567 */ "							// process the comment\n"
			/*  568 */ "\n"
			/*  569 */ "							b = 0; // !!\n"
			/*  570 */ "							e = r_s_line.length(); // this changed\n"
			/*  571 */ "							b_in_multiline_comment = false; // !!\n"
			/*  572 */ "						} else { // the comment is this whole line\n"
			/*  573 */ "							b = 0;\n"
			/*  574 */ "							size_t e2 = e;\n"
			/*  575 */ "							while(e2 > b && (r_s_line[e2 - 1] == \'\\n\' ||"
					   " r_s_line[e2 - 1] == \'\\r\'))\n"
			/*  576 */ "								-- e2;\n"
			/*  577 */ "							// find end of line\n"
			/*  578 */ "\n"
			/*  579 */ "							size_t b2 = 0;\n"
			/*  580 */ "							while(b2 < e2 && isspace(uint8_t(r_s_line[b2]))"
					   ")\n"
			/*  581 */ "								++ b2;\n"
			/*  582 */ "							// find the beginning of the comment text\n"
			/*  583 */ "\n"
			/*  584 */ "							size_t e4 = e2;\n"
			/*  585 */ "							while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - "
					   "1])))\n"
			/*  586 */ "								-- e4;\n"
			/*  587 */ "							// find end of the comment text\n"
			/*  588 */ "\n"
			/*  589 */ "							std::string s_comment;\n"
			/*  590 */ "							s_comment.insert(s_comment.begin(), r_s_line.be"
					   "gin() + b2, r_s_line.begin() + e4);\n"
			/*  591 */ "							if(!s_comment.empty())\n"
			/*  592 */ "								line_comment_list[i].push_back(s_comment);"
					   "\n"
			/*  593 */ "							r_s_line.erase(r_s_line.begin(), r_s_line.begin"
					   "() + e2);\n"
			/*  594 */ "							// process the comment\n"
			/*  595 */ "\n"
			/*  596 */ "							e = b;\n"
			/*  597 */ "							// nothing else to do on this line\n"
			/*  598 */ "						}\n"
			/*  599 */ "					}\n"
			/*  600 */ "					// parse continuing comment\n"
			/*  601 */ "\n"
			/*  602 */ "					for(; b < e; ++ b) {\n"
			/*  603 */ "						if(r_s_line[b] == \'\\\'\') {\n"
			/*  604 */ "							++ b;\n"
			/*  605 */ "							for(; b < e; ++ b) {\n"
			/*  606 */ "								if(r_s_line[b] == \'\\\\\') {\n"
			/*  607 */ "									++ b;\n"
			/*  608 */ "									// can be whatever after it (mostly a s"
					   "ingle character,\n"
			/*  609 */ "									// sometimes hexadecimal number), but w"
					   "ill correctly skip \"\\\'\"\n"
			/*  610 */ "								} else if(r_s_line[b] == \'\\\'\')\n"
			/*  611 */ "									break;\n"
			/*  612 */ "								// found the other (unescaped) apostrophe\n"
			/*  613 */ "							}\n"
			/*  614 */ "							if(b == e || r_s_line[b] == \'\\\'\')\n"
			/*  615 */ "								continue;\n"
			/*  616 */ "						}\n"
			/*  617 */ "						// eat \"C\" character literals\n"
			/*  618 */ "\n"
			/*  619 */ "						if(r_s_line[b] == \'\\\"\') {\n"
			/*  620 */ "							++ b;\n"
			/*  621 */ "							for(; b < e; ++ b) {\n"
			/*  622 */ "								if(r_s_line[b] == \'\\\\\') {\n"
			/*  623 */ "									++ b;\n"
			/*  624 */ "									// can be whatever after it (mostly a s"
					   "ingle character,\n"
			/*  625 */ "									// sometimes a hexadecimal number), but"
					   " will correctly skip \"\\\"\"\n"
			/*  626 */ "								} else if(r_s_line[b] == \'\\\"\')\n"
			/*  627 */ "									break;\n"
			/*  628 */ "								// found the other (unescaped) quote\n"
			/*  629 */ "							}\n"
			/*  630 */ "							if(b == e || r_s_line[b] == \'\\\"\')\n"
			/*  631 */ "								continue;\n"
			/*  632 */ "						}\n"
			/*  633 */ "						// eat \"C\" string literals\n"
			/*  634 */ "\n"
			/*  635 */ "						if(r_s_line[b] == \'/\' && b + 1 < e) {\n"
			/*  636 */ "							if(r_s_line[b + 1] == \'/\') {\n"
			/*  637 */ "								size_t e2 = e;\n"
			/*  638 */ "								while(e2 > b && (r_s_line[e2 - 1] == \'\\n"
					   "\' || r_s_line[e2 - 1] == \'\\r\'))\n"
			/*  639 */ "									-- e2;\n"
			/*  640 */ "								// find end of line\n"
			/*  641 */ "\n"
			/*  642 */ "								size_t b2 = b + 2;\n"
			/*  643 */ "								while(b2 < e2 && isspace(uint8_t(r_s_line[b"
					   "2])))\n"
			/*  644 */ "									++ b2;\n"
			/*  645 */ "								// find the beginning of the comment text\n"
			/*  646 */ "\n"
			/*  647 */ "								while(b > 0 && isspace(uint8_t(r_s_line[b -"
					   " 1])))\n"
			/*  648 */ "									-- b;\n"
			/*  649 */ "								// will erase the preceding whitespace as w"
					   "ell\n"
			/*  650 */ "\n"
			/*  651 */ "								std::string s_comment;\n"
			/*  652 */ "								s_comment.insert(s_comment.begin(), r_s_lin"
					   "e.begin() + b2, r_s_line.begin() + e2);\n"
			/*  653 */ "								if(!s_comment.empty())\n"
			/*  654 */ "									line_comment_list[i].push_back(s_commen"
					   "t);\n"
			/*  655 */ "								r_s_line.erase(r_s_line.begin() + b, r_s_li"
					   "ne.begin() + e2);\n"
			/*  656 */ "								break;\n"
			/*  657 */ "							}\n"
			/*  658 */ "							// found a line comment\n"
			/*  659 */ "\n"
			/*  660 */ "							if(r_s_line[b + 1] == \'*\') {\n"
			/*  661 */ "								size_t e2 = e;\n"
			/*  662 */ "								while(e2 > b && (r_s_line[e2 - 1] == \'\\n"
					   "\' || r_s_line[e2 - 1] == \'\\r\'))\n"
			/*  663 */ "									-- e2;\n"
			/*  664 */ "								// find end of line\n"
			/*  665 */ "\n"
			/*  666 */ "								size_t b2 = b + 2;\n"
			/*  667 */ "								while(b2 < e2 && isspace(uint8_t(r_s_line[b"
					   "2])))\n"
			/*  668 */ "									++ b2;\n"
			/*  669 */ "								// find the beginning of the comment text\n"
			/*  670 */ "\n"
			/*  671 */ "								size_t e3 = b2 + 1;\n"
			/*  672 */ "								while(e3 < e2 && (r_s_line[e3 - 1] != \'*\'"
					   " || r_s_line[e3] != \'/\'))\n"
			/*  673 */ "									++ e3;\n"
			/*  674 */ "								// find the end of the comment text\n"
			/*  675 */ "\n"
			/*  676 */ "								while(b > 0 && isspace(uint8_t(r_s_line[b -"
					   " 1])))\n"
			/*  677 */ "									-- b;\n"
			/*  678 */ "								// will erase the preceding whitespace as w"
					   "ell\n"
			/*  679 */ "\n"
			/*  680 */ "								std::string s_comment;\n"
			/*  681 */ "								if(e3 < e2 && r_s_line[e3 - 1] == \'*\' && "
					   "r_s_line[e3] == \'/\') {\n"
			/*  682 */ "									// the comment ends on this line\n"
			/*  683 */ "\n"
			/*  684 */ "									_ASSERTE(e3 > 0);\n"
			/*  685 */ "									size_t e4 = e3 - 1;\n"
			/*  686 */ "									while(e4 > b2 && isspace(uint8_t(r_s_li"
					   "ne[e4 - 1])))\n"
			/*  687 */ "										-- e4;\n"
			/*  688 */ "									// find end of the comment text\n"
			/*  689 */ "\n"
			/*  690 */ "									s_comment.insert(s_comment.begin(), r_s"
					   "_line.begin() + b2, r_s_line.begin() + e4);\n"
			/*  691 */ "									r_s_line.erase(r_s_line.begin() + b, r_"
					   "s_line.begin() + e3 + 1);\n"
			/*  692 */ "									// get the comment\n"
			/*  693 */ "\n"
			/*  694 */ "									e = r_s_line.length(); // this changed"
					   "\n"
			/*  695 */ "									-- b; // compensate for ++ b in the out"
					   "er loop\n"
			/*  696 */ "									// (there can be more separate comments"
					   " on a single line!)\n"
			/*  697 */ "								} else {\n"
			/*  698 */ "									b_in_multiline_comment = true; // the c"
					   "omment carries to the next line\n"
			/*  699 */ "\n"
			/*  700 */ "									size_t e4 = e2;\n"
			/*  701 */ "									while(e4 > b2 && isspace(uint8_t(r_s_li"
					   "ne[e4 - 1])))\n"
			/*  702 */ "										-- e4;\n"
			/*  703 */ "									// find end of the comment text\n"
			/*  704 */ "\n"
			/*  705 */ "									s_comment.insert(s_comment.begin(), r_s"
					   "_line.begin() + b2, r_s_line.begin() + e4);\n"
			/*  706 */ "									r_s_line.erase(r_s_line.begin() + b, r_"
					   "s_line.begin() + e2);\n"
			/*  707 */ "									e = b; // we are finished with this lin"
					   "e\n"
			/*  708 */ "								}\n"
			/*  709 */ "								// extract the comment\n"
			/*  710 */ "\n"
			/*  711 */ "								if(!s_comment.empty())\n"
			/*  712 */ "									line_comment_list[i].push_back(s_commen"
					   "t);\n"
			/*  713 */ "							}\n"
			/*  714 */ "							// found a multiline comment\n"
			/*  715 */ "						}\n"
			/*  716 */ "						// eat comments\n"
			/*  717 */ "					}\n"
			/*  718 */ "					// parse \"C\" strings, characters and comments / C++ c"
					   "omments\n"
			/*  719 */ "				}\n"
			/*  720 */ "				// for each line\n"
			/*  721 */ "\n"
			/*  722 */ "				for(size_t i = 0, n = line_comment_list.size(); i < n; ++ i"
					   ") {\n"
			/*  723 */ "					std::vector<std::string> &r_comments = line_comment_lis"
					   "t[i];\n"
			/*  724 */ "					for(size_t j = 0, m = r_comments.size(); j < m; ++ j) {"
					   "\n"
			/*  725 */ "						std::string &r_comment = r_comments[j];\n"
			/*  726 */ "						size_t n_pos = 0;\n"
			/*  727 */ "						while((n_pos = r_comment.find(\"/*\")) != std::stri"
					   "ng::npos)\n"
			/*  728 */ "							r_comment[++ n_pos] = \'+\';\n"
			/*  729 */ "						n_pos = 0;\n"
			/*  730 */ "						while((n_pos = r_comment.find(\"*/\")) != std::stri"
					   "ng::npos)\n"
			/*  731 */ "							r_comment[n_pos] = \'+\';\n"
			/*  732 */ "						++ n_pos;\n"
			/*  733 */ "					}\n"
			/*  734 */ "				}\n"
			/*  735 */ "				// replace comments inside comments to avoid warnings when "
					   "building the header\n"
			/*  736 */ "			}\n"
			/*  737 */ "			// extract comments from the text\n"
			/*  738 */ "\n"
			/*  739 */ "			if(b_discard_empty_lines) {\n"
			/*  740 */ "				_ASSERTE(line_no.empty() || line_no.size() == line_list.siz"
					   "e());\n"
			/*  741 */ "				std::string s_line, s_dummy;\n"
			/*  742 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  743 */ "					s_line = line_list[i];\n"
			/*  744 */ "					// get a copy of the line\n"
			/*  745 */ "\n"
			/*  746 */ "					stl_ut::TrimSpace(s_line);\n"
			/*  747 */ "					// trim space\n"
			/*  748 */ "\n"
			/*  749 */ "					if(s_line.empty()) {\n"
			/*  750 */ "						if(line_comment_list[i].empty()) {\n"
			/*  751 */ "							line_list.erase(line_list.begin() + i);\n"
			/*  752 */ "							if(!line_no.empty())\n"
			/*  753 */ "								line_no.erase(line_no.begin() + i);\n"
			/*  754 */ "							if(!line_comment_list.empty())\n"
			/*  755 */ "								line_comment_list.erase(line_comment_list.b"
					   "egin() + i);\n"
			/*  756 */ "							-- i;\n"
			/*  757 */ "							-- n;\n"
			/*  758 */ "							// no comments, just delete the line\n"
			/*  759 */ "						} else {\n"
			/*  760 */ "							line_list[i].clear();\n"
			/*  761 */ "							// there is a comment, just keep the empty line"
					   " as a placeholder\n"
			/*  762 */ "						}\n"
			/*  763 */ "					}\n"
			/*  764 */ "					// discard empty ones\n"
			/*  765 */ "				}\n"
			/*  766 */ "				_ASSERTE(line_no.empty() || line_no.size() == line_list.siz"
					   "e());\n"
			/*  767 */ "			}\n"
			/*  768 */ "			// discard empty lines\n"
			/*  769 */ "\n"
			/*  770 */ "			{\n"
			/*  771 */ "				n_crc32 = CCrc_32::n_Start();\n"
			/*  772 */ "				n_file_size = 0;\n"
			/*  773 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  774 */ "					n_crc32 = CCrc_32::n_Crc(line_list[i].length() * sizeof"
					   "(char), line_list[i].data(), n_crc32);\n"
			/*  775 */ "					n_file_size += line_list[i].length();\n"
			/*  776 */ "				}\n"
			/*  777 */ "				n_crc32 = CCrc_32::n_Finalize(n_crc32);\n"
			/*  778 */ "				// calculate CRC\n"
			/*  779 */ "			}\n"
			/*  780 */ "			// count file size after all the changes\n"
			/*  781 */ "\n"
			/*  782 */ "			if(b_verbose && b_binary_mode) {\n"
			/*  783 */ "				printf(\"saved \" PRIsizeB \"B in text processing\\n\",\n"
			/*  784 */ "					PRIsizeBparams(n_orig_file_size - n_file_size));\n"
			/*  785 */ "			}\n"
			/*  786 */ "		}\n"
			/*  787 */ "		if(!b_binary_mode) {\n"
			/*  788 */ "			std::for_each(line_list.begin(), line_list.end(), EscapeString)"
					   ";\n"
			/*  789 */ "			// escape strange characters\n"
			/*  790 */ "\n"
			/*  791 */ "			uint64_t n_print_size = 0;\n"
			/*  792 */ "			for(size_t i = 0, n = line_list.size(); i < n; ++ i)\n"
			/*  793 */ "				n_print_size += line_list[i].length();\n"
			/*  794 */ "			// count length\n"
			/*  795 */ "\n"
			/*  796 */ "			if(n_max_line_length > 0) {\n"
			/*  797 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  798 */ "					size_t n_tab_num = std::count(line_list[i].begin(), lin"
					   "e_list[i].end(), \'\\t\'); // may not compile in msvc60\n"
			/*  799 */ "					if(line_list[i].length() + n_tab_num * (n_tab_size - 1)"
					   " > n_max_line_length) { // * (n_tab_size - 1) because one character is coun"
					   "ted already\n"
			/*  800 */ "						std::string &r_s_line_i = line_list[i];\n"
			/*  801 */ "						int n_cut;\n"
			/*  802 */ "						unsigned int l = r_s_line_i.length(), chars = 0;;\n"
			/*  803 */ "						for(n_cut = 0; unsigned(n_cut) < l; ++ n_cut) {\n"
			/*  804 */ "							unsigned int chars2 = chars + ((r_s_line_i[n_cu"
					   "t] == \'\\t\')? n_tab_size : 1);\n"
			/*  805 */ "							if(chars2 > n_max_line_length && (chars > n_max"
					   "_line_length ||\n"
			/*  806 */ "							   (n_max_line_length - chars) < (chars2 - n_ma"
					   "x_line_length + 1)))\n"
			/*  807 */ "								break; // find the precise position of the "
					   "cut, minimizing the distance from the cut line\n"
			/*  808 */ "							chars = chars2;\n"
			/*  809 */ "						}\n"
			/*  810 */ "						/*int n_cut = n_max_line_length - n_tab_num * (n_ta"
					   "b_size - 1); // try to fixup (not precise)*/\n"
			/*  811 */ "						if(n_cut <= 0)\n"
			/*  812 */ "							n_cut = n_max_line_length; // ...\n"
			/*  813 */ "						if(n_cut >= r_s_line_i.length())\n"
			/*  814 */ "							n_cut = r_s_line_i.length(); // 2016-06-16 - fi"
					   "xed a bug with out of bounds access triggered by lines with many tabs on th"
					   "em where the imprecise estimate overshoots past the length of the line\n"
			/*  815 */ "						_ASSERTE(n_cut > 0);\n"
			/*  816 */ "						// decide where to cut to have no more than n_max_l"
					   "ine_length characters in the header\n"
			/*  817 */ "\n"
			/*  818 */ "						while((n_cut > 0 && r_s_line_i[n_cut - 1] == \'"
					   "\\\\\') ||\n"
			/*  819 */ "						   (n_cut > 1 && r_s_line_i[n_cut - 2] == \'\\\\\' "
					   "&& r_s_line_i[n_cut - 1] == \'x\') ||\n"
			/*  820 */ "						   (n_cut > 2 && r_s_line_i[n_cut - 3] == \'\\\\\' "
					   "&& r_s_line_i[n_cut - 2] == \'x\'))\n"
			/*  821 */ "						   n_cut -= (r_s_line_i[n_cut - 1] == \'\\\\\')? 1 "
					   ": (r_s_line_i[n_cut - 1] == \'x\')? 2 : 3;\n"
			/*  822 */ "						// can\'t leave \'\\\\\' at the end of the line (sh"
					   "ouldn\'t cut escape sequences in two parts)\n"
			/*  823 */ "						// note that \'\\\\x12\' will still be cut by this "
					   "(the compilers do not like that) // t_odo - test it\n"
			/*  824 */ "\n"
			/*  825 */ "						if(n_cut <= 0 || n_cut == r_s_line_i.length())\n"
			/*  826 */ "							continue;\n"
			/*  827 */ "						// leave long line, couldn\'t cut because of abuse "
					   "of escape sequences\n"
			/*  828 */ "\n"
			/*  829 */ "						std::string s_second_line;\n"
			/*  830 */ "						s_second_line.insert(s_second_line.end(),\n"
			/*  831 */ "							line_list[i].begin() + n_cut, line_list[i].end("
					   "));\n"
			/*  832 */ "						line_list[i].erase(line_list[i].begin() + n_cut, li"
					   "ne_list[i].end());\n"
			/*  833 */ "						line_list.insert(line_list.begin() + (i + 1), s_sec"
					   "ond_line);\n"
			/*  834 */ "						++ n; // !!\n"
			/*  835 */ "\n"
			/*  836 */ "						if(!line_no.empty())\n"
			/*  837 */ "							line_no.insert(line_no.begin() + i + 1, -1); //"
					   " insert -1 *after* so the lines do not repeat\n"
			/*  838 */ "						if(!line_comment_list.empty())\n"
			/*  839 */ "							line_comment_list.insert(line_comment_list.begi"
					   "n() + i, std::vector<std::string>()); // insert empty comment *before* as t"
					   "here will likely be more space on the subsequent lines\n"
			/*  840 */ "						// duplicate line numbers and comments as well, if "
					   "we need them\n"
			/*  841 */ "					}\n"
			/*  842 */ "				}\n"
			/*  843 */ "				_ASSERTE(line_no.empty() || line_no.size() == line_list.siz"
					   "e());\n"
			/*  844 */ "				_ASSERTE(line_comment_list.empty() || line_comment_list.siz"
					   "e() == line_comment_list.size());\n"
			/*  845 */ "			}\n"
			/*  846 */ "			// break long lines to multiple ones (but without introducing n"
					   "ew line breaks)\n"
			/*  847 */ "\n"
			/*  848 */ "			if(n_print_size > n_max_string_length) { // note that n_print_s"
					   "ize could be n_file_size as well, but some compilers might actually limit t"
					   "hat instead\n"
			/*  849 */ "				s_data = \"\\t\\tconst char *p_text_array[] = {\\n\";\n"
			/*  850 */ "				size_t n_cur_size = 0;\n"
			/*  851 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  852 */ "					size_t n_last_line = line_list[i].length();\n"
			/*  853 */ "					if(n_cur_size + n_last_line <= n_max_string_length) {\n"
			/*  854 */ "						if(i)\n"
			/*  855 */ "							s_data += \"\\n\";\n"
			/*  856 */ "						n_cur_size += n_last_line;\n",
			/*  857 */ "					} else {\n"
			/*  858 */ "						if(i)\n"
			/*  859 */ "							s_data += \",\\n\";\n"
			/*  860 */ "						n_cur_size = n_last_line;\n"
			/*  861 */ "					}\n"
			/*  862 */ "					s_data += \"\\t\\t\\t\";\n"
			/*  863 */ "					if(b_prefix_line_numbers) {\n"
			/*  864 */ "						char p_s_line_no[64];\n"
			/*  865 */ "						if(line_no[i] > 0) {\n"
			/*  866 */ "							stl_ut::Format(p_s_line_no, sizeof(p_s_line_no)"
					   ",\n"
			/*  867 */ "								p_s_line_no_format, line_no[i]);\n"
			/*  868 */ "							s_data += p_s_line_no;\n"
			/*  869 */ "						} else\n"
			/*  870 */ "							s_data += p_s_hide_line_no;\n"
			/*  871 */ "					}\n"
			/*  872 */ "					s_data += \"\\\"\";\n"
			/*  873 */ "					s_data += line_list[i];\n"
			/*  874 */ "					s_data += \"\\\"\";\n"
			/*  875 */ "					if(!line_comment_list.empty() && !line_comment_list[i]."
					   "empty()) {\n"
			/*  876 */ "						for(size_t j = 0, m = line_comment_list[i].size(); "
					   "j < m; ++ j) {\n"
			/*  877 */ "							s_data += \" /* \";\n"
			/*  878 */ "							s_data += line_comment_list[i][j];\n"
			/*  879 */ "							s_data += \" */\";\n"
			/*  880 */ "						}\n"
			/*  881 */ "						// insert comments\n"
			/*  882 */ "					}\n"
			/*  883 */ "				}\n"
			/*  884 */ "				s_data += \"\\n\\t\\t};\\n\";\n"
			/*  885 */ "				// need to split it\n"
			/*  886 */ "\n"
			/*  887 */ "				std::string s_size;\n"
			/*  888 */ "				if(!stl_ut::Format(s_size, \"\\t\\tchar *p_s_text;\\n\\t\\t"
					   "if(!(p_s_text = new(std::nothrow) char[\"\n"
			/*  889 */ "				   PRIu64 \"]))\\n\\t\\t\\treturn 0;\\n\", n_file_size + 1)"
					   ")\n"
			/*  890 */ "					throw std::bad_alloc(); // retrhow\n"
			/*  891 */ "				s_data += s_size;\n"
			/*  892 */ "\n"
			/*  893 */ "				/*s_data += \"\\t\\t*p_s_text = 0;\\n\"\n"
			/*  894 */ "						  \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array"
					   ") / sizeof(p_text_array[0]); i < n; ++ i)\\n\"\n"
			/*  895 */ "						  \"\\t\\t\\tstrcat(p_s_text, p_text_array[i]);\\n"
					   "\"\n"
			/*  896 */ "						  \"\\t\\treturn p_s_text;\\n\";*/\n"
			/*  897 */ "				// uses strcat; ugly, inefficient\n"
			/*  898 */ "\n"
			/*  899 */ "				/*std::string s_concat;\n"
			/*  900 */ "				if(!stl_ut::Format(s_concat, \"\\t\\tchar *p_s_dest = p_s_t"
					   "ext;\\n\"\n"
			/*  901 */ "				   \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / siz"
					   "eof(p_text_array[0]); i < n; ++ i) {\\n\"\n"
			/*  902 */ "				   \"\\t\\t\\tsize_t n_chunk = (i + 1 < n)? \" PRIsize \" :"
					   " \" PRIsize \";\\n\"\n"
			/*  903 */ "				   \"\\t\\t\\tmemcpy(p_s_dest, p_text_array[i], n_chunk * s"
					   "izeof(char));\\n\" \"\\t\\t\\tp_s_dest += n_chunk;\\n\"\n"
			/*  904 */ "				   \"\\t\\t}\\n\" \"\\t\\t*p_s_dest = 0;\\n\" \"\\t\\tretur"
					   "n p_s_text;\\n\", n_max_string_length,\n"
			/*  905 */ "				   size_t(n_file_size % n_max_string_length)))\n"
			/*  906 */ "					throw std::bad_alloc(); // retrhow\n"
			/*  907 */ "				s_data += s_concat;*/ // can\'t use as we are deciding on n"
					   "_print_size instead of n_file_size, it is hard to calculate what n_chunk sh"
					   "ould be\n"
			/*  908 */ "				// better concat code, using memcpy()\n"
			/*  909 */ "\n"
			/*  910 */ "				std::string s_concat;\n"
			/*  911 */ "				if(!stl_ut::Format(s_concat, \"\\t\\tchar *p_s_dest = p_s_t"
					   "ext;\\n\"\n"
			/*  912 */ "				   \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / siz"
					   "eof(p_text_array[0]); i < n; ++ i) {\\n\"\n"
			/*  913 */ "				   \"\\t\\t\\tsize_t n_chunk = strlen(p_text_array[i]);\\n"
					   "\"\n"
			/*  914 */ "				   \"\\t\\t\\tmemcpy(p_s_dest, p_text_array[i], n_chunk * s"
					   "izeof(char));\\n\" \"\\t\\t\\tp_s_dest += n_chunk;\\n\"\n"
			/*  915 */ "				   \"\\t\\t}\\n\" \"\\t\\t*p_s_dest = 0;\\n\" \"\\t\\tretur"
					   "n p_s_text;\\n\", n_max_string_length,\n"
			/*  916 */ "				   size_t(n_file_size % n_max_string_length)))\n"
			/*  917 */ "					throw std::bad_alloc(); // retrhow\n"
			/*  918 */ "				s_data += s_concat;\n"
			/*  919 */ "				// better concat code, using memcpy() and strlen()\n"
			/*  920 */ "\n"
			/*  921 */ "				// need to provide code to concat it back\n"
			/*  922 */ "\n"
			/*  923 */ "				b_is_dynamic = true;\n"
			/*  924 */ "				// the caller needs to dispose of the text\n"
			/*  925 */ "			} else {\n"
			/*  926 */ "				s_data = \"\\t\\tconst char *p_s_text =\\n\";\n"
			/*  927 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  928 */ "					s_data += \"\\t\\t\\t\";\n"
			/*  929 */ "					if(b_prefix_line_numbers) {\n"
			/*  930 */ "						char p_s_line_no[64];\n"
			/*  931 */ "						if(line_no[i] > 0) {\n"
			/*  932 */ "							stl_ut::Format(p_s_line_no, sizeof(p_s_line_no)"
					   ",\n"
			/*  933 */ "								p_s_line_no_format, line_no[i]);\n"
			/*  934 */ "							s_data += p_s_line_no;\n"
			/*  935 */ "						} else\n"
			/*  936 */ "							s_data += p_s_hide_line_no;\n"
			/*  937 */ "					}\n"
			/*  938 */ "					s_data += \"\\\"\";\n"
			/*  939 */ "					s_data += line_list[i];\n"
			/*  940 */ "					if(!line_comment_list.empty() && !line_comment_list[i]."
					   "empty()) {\n"
			/*  941 */ "						s_data += (i + 1 == n)? \"\\\";\" : \"\\\"\";\n"
			/*  942 */ "\n"
			/*  943 */ "						for(size_t j = 0, m = line_comment_list[i].size(); "
					   "j < m; ++ j) {\n"
			/*  944 */ "							s_data += \" /* \";\n"
			/*  945 */ "							s_data += line_comment_list[i][j];\n"
			/*  946 */ "							s_data += \" */\";\n"
			/*  947 */ "						}\n"
			/*  948 */ "						// insert comments\n"
			/*  949 */ "\n"
			/*  950 */ "						s_data += \"\\n\";\n"
			/*  951 */ "					} else\n"
			/*  952 */ "						s_data += (i + 1 == n)? \"\\\";\\n\\n\" : \"\\\"\\n"
					   "\";\n"
			/*  953 */ "				}\n"
			/*  954 */ "				// just print them all\n"
			/*  955 */ "\n"
			/*  956 */ "				s_data += \"\\t\\treturn p_s_text;\\n\";\n"
			/*  957 */ "\n"
			/*  958 */ "				b_is_dynamic = false;\n"
			/*  959 */ "				// the caller does not need to dispose of the text\n"
			/*  960 */ "			}\n"
			/*  961 */ "		} else {\n"
			/*  962 */ "			TBuffer t_file;\n"
			/*  963 */ "			if(!b_treat_binary_as_text) {\n"
			/*  964 */ "				if(!ReadFile(t_file, p_s_infile)) {\n"
			/*  965 */ "					fprintf(stderr, \"error: failed to load \\\'%s\\\'\\n\""
					   ", p_s_infile);\n"
			/*  966 */ "					return -1;\n"
			/*  967 */ "				}\n"
			/*  968 */ "				n_file_size = t_file.n_Size();\n"
			/*  969 */ "				n_orig_file_size = n_file_size;\n"
			/*  970 */ "				n_crc32 = CCrc_32::n_Crc(t_file.n_Size(), t_file.p_Data());"
					   "\n"
			/*  971 */ "				n_orig_crc32 = n_crc32;\n"
			/*  972 */ "				// calculate CRC\n"
			/*  973 */ "			} else {\n"
			/*  974 */ "				s_file.erase();\n"
			/*  975 */ "				for(size_t i = 0, n = line_list.size(); i < n; ++ i)\n"
			/*  976 */ "					s_file += line_list[i];\n"
			/*  977 */ "				_ASSERTE(n_file_size == s_file.length() * sizeof(char));\n"
			/*  978 */ "				n_file_size = s_file.length() * sizeof(char);\n"
			/*  979 */ "				if(!t_file.Resize(s_file.length() * sizeof(char)))\n"
			/*  980 */ "					throw std::bad_alloc(); // rehtrow\n"
			/*  981 */ "				memcpy(t_file.p_Data(), s_file.data(), s_file.length() * si"
					   "zeof(char));\n"
			/*  982 */ "				// just concat; already have a CRC\n"
			/*  983 */ "			}\n"
			/*  984 */ "			// input data\n"
			/*  985 */ "\n"
			/*  986 */ "			if(b_verbose)\n"
			/*  987 */ "				printf(\"compressing ... \");\n"
			/*  988 */ "\n"
			/*  989 */ "			TBuffer t_bwt_data;\n"
			/*  990 */ "			uint32_t n_bwt_primary_index;\n"
			/*  991 */ "			{\n"
			/*  992 */ "				if(!CBurrowsWheelerTransform::Encode(t_file, t_bwt_data))\n"
			/*  993 */ "					throw std::bad_alloc(); // rethrow\n"
			/*  994 */ "				_ASSERTE(t_bwt_data.n_Size() == t_file.n_Size() + sizeof(ui"
					   "nt32_t));\n"
			/*  995 */ "				n_bwt_primary_index = *(uint32_t*)t_bwt_data.p_Data();\n"
			/*  996 */ "				TBuffer t_tmp;\n"
			/*  997 */ "				if(!t_tmp.Resize(t_file.n_Size()))\n"
			/*  998 */ "					throw std::bad_alloc(); // rethrow\n"
			/*  999 */ "				memcpy(t_tmp.p_Data(), t_bwt_data.p_Data() + sizeof(uint32_"
					   "t), t_file.n_Size());\n"
			/* 1000 */ "				t_tmp.Swap(t_bwt_data);\n"
			/* 1001 */ "			}\n"
			/* 1002 */ "			// compress the whole file with BWT (do not expect to have very"
					   " big files in here)\n"
			/* 1003 */ "\n"
			/* 1004 */ "			CMoveToFrontTransform::Encode(t_bwt_data, CMoveToFrontTransform"
					   "::algo_MTF); // todo - enable this\n"
			/* 1005 */ "			// also MTF it, produces shorter files and is easy to decompres"
					   "s\n"
			/* 1006 */ "\n"
			/* 1007 */ "			TBuffer t_packed_data;\n"
			/* 1008 */ "			if(!CRunLengthCodec::Encode(t_bwt_data, t_packed_data))\n"
			/* 1009 */ "				throw std::bad_alloc(); // rethrow\n"
			/* 1010 */ "			// pack using simple RLE (easy to unpack)\n"
			/* 1011 */ "\n"
			/* 1012 */ "			size_t n_afterhuff = t_packed_data.n_Size();\n"
			/* 1013 */ "\n"
			/* 1014 */ "			{\n"
			/* 1015 */ "				TBuffer t_tmp;\n"
			/* 1016 */ "				if(!CHuffmanCodec::Encode(t_packed_data, t_tmp))\n"
			/* 1017 */ "					throw std::bad_alloc(); // rethrow\n"
			/* 1018 */ "				t_packed_data.Swap(t_tmp);\n"
			/* 1019 */ "			}\n"
			/* 1020 */ "			// huffman step\n"
			/* 1021 */ "\n"
			/* 1022 */ "			const char *p_s_base85_alphabet = \"0123456789ABCDEFGHIJKLMNOPQ"
					   "RSTUVWXYZ\"\n"
			/* 1023 */ "				\"abcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>.@^_,{|}~\"; // a"
					   "s RFC 1924, but \'?\' is \'.\' and \'`\' is \',\'\n"
			/* 1024 */ "			// modified alphabet for Base-85 that will not cause trigraphs"
					   "\n"
			/* 1025 */ "\n"
			/* 1026 */ "			std::string s_base64;\n"
			/* 1027 */ "			if(b_use_base85) {\n"
			/* 1028 */ "				if(!CModifiedBase85::Encode(s_base64, t_packed_data.n_Size("
					   ") - sizeof(uint32_t),\n"
			/* 1029 */ "				   t_packed_data.p_Data() + sizeof(uint32_t), true, p_s_bas"
					   "e85_alphabet))\n"
			/* 1030 */ "					throw std::bad_alloc(); // rethrow\n"
			/* 1031 */ "				// encode as Base-85 with explicit null coding, skip huffma"
					   "n unpack length, we save it otherwise\n"
			/* 1032 */ "			} else {\n"
			/* 1033 */ "				if(!CModifiedBase64::Encode(s_base64, t_packed_data.n_Size("
					   ") - sizeof(uint32_t),\n"
			/* 1034 */ "				   t_packed_data.p_Data() + sizeof(uint32_t)))\n"
			/* 1035 */ "					throw std::bad_alloc(); // rethrow\n"
			/* 1036 */ "				// encode as Base-64, skip huffman unpack length, we save i"
					   "t otherwise\n"
			/* 1037 */ "			}\n"
			/* 1038 */ "\n"
			/* 1039 */ "			{\n"
			/* 1040 */ "				if(b_verbose) {\n"
			/* 1041 */ "					printf(\"packed \" PRIu64 \" B to \" PRIsize \" B of Ba"
					   "se-%d text\\n\",\n"
			/* 1042 */ "						n_orig_file_size, s_base64.length(), (b_use_base85)"
					   "? 85 : 64);\n"
			/* 1043 */ "					printf(\"testing decompress ... \");\n"
			/* 1044 */ "				}\n"
			/* 1045 */ "\n"
			/* 1046 */ "				uint8_t *p_data;\n"
			/* 1047 */ "				if(b_use_base85) {\n"
			/* 1048 */ "					p_data = p_Decode_BWT_MTF_RLE_Huff_Base85(s_base64.c_st"
					   "r(),\n"
			/* 1049 */ "						size_t(n_file_size), n_afterhuff, n_bwt_primary_ind"
					   "ex);\n"
			/* 1050 */ "				} else {\n"
			/* 1051 */ "					p_data = p_Decode_BWT_MTF_RLE_Huff_Base64(s_base64.c_st"
					   "r(),\n"
			/* 1052 */ "						size_t(n_file_size), n_afterhuff, n_bwt_primary_ind"
					   "ex);\n"
			/* 1053 */ "				}\n"
			/* 1054 */ "				if(!p_data)\n"
			/* 1055 */ "					fprintf(stderr, \"error: decompress failed\\n\");\n"
			/* 1056 */ "				else if(memcmp(p_data, t_file.p_Data(), size_t(n_file_size)"
					   "))\n"
			/* 1057 */ "					fprintf(stderr, \"error: decompress produces different "
					   "results\\n\");\n"
			/* 1058 */ "				else if(b_verbose)\n"
			/* 1059 */ "					printf(\"decompress works\\n\");\n"
			/* 1060 */ "				if(p_data)\n"
			/* 1061 */ "					delete[] p_data;\n"
			/* 1062 */ "			}\n"
			/* 1063 */ "			// test decompress\n"
			/* 1064 */ "\n"
			/* 1065 */ "			if(b_use_base85) {\n"
			/* 1066 */ "				/*size_t n_pos = 0;\n"
			/* 1067 */ "				while((n_pos = s_base64.find(\"??\", n_pos)) != std::string"
					   "::npos) {\n"
			/* 1068 */ "					const char *p_s_trigraph_list = \"=(</)>\x92!-\";\n"
			/* 1069 */ "					if(n_pos + 2 < s_base64.length() && strchr(p_s_trigraph"
					   "_list, s_base64[n_pos + 2]))\n"
			/* 1070 */ "						s_base64.insert(n_pos + 1, 1, \'\\\\\');\n"
			/* 1071 */ "					else\n"
			/* 1072 */ "						++ n_pos; // false alarm, not a trigraph\n"
			/* 1073 */ "				}*/\n"
			/* 1074 */ "				_ASSERTE(s_base64.find(\"??\") == std::string::npos);\n"
			/* 1075 */ "				// using a modified alphabet that does not contain question"
					   " marks\n"
			/* 1076 */ "			} else {\n"
			/* 1077 */ "				_ASSERTE(s_base64.find(\"??\") == std::string::npos);\n"
			/* 1078 */ "				// would not expect trigraphs here, except if using a modif"
					   "ied alphabet\n"
			/* 1079 */ "			}\n"
			/* 1080 */ "			// Base-85 may contain trigraphs, need to escape them properly"
					   "\n"
			/* 1081 */ "\n"
			/* 1082 */ "			bool b_have_to_free = false;\n"
			/* 1083 */ "\n"
			/* 1084 */ "			size_t n_print_size = s_base64.length();\n"
			/* 1085 */ "			if(n_print_size > n_max_string_length) { // note that n_print_s"
					   "ize could be n_file_size as well, but some compilers might actually limit t"
					   "hat instead\n"
			/* 1086 */ "				s_data = \"\\t\\tconst char *p_text_array[] = {\\n\";\n"
			/* 1087 */ "				size_t n_cur_size = 0;\n"
			/* 1088 */ "				for(size_t i = 0; i < n_print_size;) {\n"
			/* 1089 */ "					size_t n_space = min(size_t(n_max_line_length),\n"
			/* 1090 */ "						min(size_t(n_max_string_length) - n_cur_size, n_pri"
					   "nt_size - i));\n"
			/* 1091 */ "\n"
			/* 1092 */ "					if(n_space) {\n"
			/* 1093 */ "						if(i)\n"
			/* 1094 */ "							s_data += \"\\n\";\n"
			/* 1095 */ "						n_cur_size += n_space;\n"
			/* 1096 */ "					} else {\n"
			/* 1097 */ "						if(i)\n"
			/* 1098 */ "							s_data += \",\\n\";\n"
			/* 1099 */ "						n_cur_size = n_space = min(size_t(n_max_line_length"
					   "), n_print_size - i);\n"
			/* 1100 */ "					}\n"
			/* 1101 */ "					s_data += \"\\t\\t\\t\\\"\";\n"
			/* 1102 */ "					s_data.insert(s_data.end(), s_base64.begin() + i,\n"
			/* 1103 */ "						s_base64.begin() + (i + n_space));\n"
			/* 1104 */ "					i += n_space;\n"
			/* 1105 */ "					s_data += \"\\\"\";\n"
			/* 1106 */ "				}\n"
			/* 1107 */ "				s_data += \"\\n\\t\\t};\\n\";\n"
			/* 1108 */ "				// need to split it\n"
			/* 1109 */ "\n"
			/* 1110 */ "				std::string s_size;\n"
			/* 1111 */ "				if(!stl_ut::Format(s_size, \"\\t\\tchar *p_s_base%d;\\n\\t"
					   "\\tif(!(p_s_base%d = new(std::nothrow) char[\"\n"
			/* 1112 */ "				   PRIsize \"]))\\n\\t\\t\\treturn 0;\\n\", n_base, n_base,"
					   " n_print_size + 1))\n"
			/* 1113 */ "					throw std::bad_alloc(); // retrhow\n"
			/* 1114 */ "				s_data += s_size;;\n"
			/* 1115 */ "				/*s_data += \"\\t\\t*p_s_base64 = 0;\\n\"\n"
			/* 1116 */ "						  \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array"
					   ") / sizeof(p_text_array[0]); i < n; ++ i)\\n\"\n"
			/* 1117 */ "						  \"\\t\\t\\tstrcat(p_s_base64, p_text_array[i]);"
					   "\\n\";*/\n"
			/* 1118 */ "				// uses strcat; ugly, inefficient\n"
			/* 1119 */ "\n"
			/* 1120 */ "				std::string s_concat;\n"
			/* 1121 */ "				if(!stl_ut::Format(s_concat, \"\\t\\tchar *p_s_dest = p_s_b"
					   "ase%d;\\n\"\n"
			/* 1122 */ "				   \"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / siz"
					   "eof(p_text_array[0]); i < n; ++ i) {\\n\"\n"
			/* 1123 */ "				   \"\\t\\t\\tsize_t n_chunk = (i + 1 < n)? \" PRIsize \" :"
					   " \" PRIsize \";\\n\"\n"
			/* 1124 */ "				   \"\\t\\t\\tmemcpy(p_s_dest, p_text_array[i], n_chunk * s"
					   "izeof(char));\\n\" \"\\t\\t\\tp_s_dest += n_chunk;\\n\"\n"
			/* 1125 */ "				   \"\\t\\t}\\n\" \"\\t\\t*p_s_dest = 0;\\n\", n_base, n_ma"
					   "x_string_length,\n"
			/* 1126 */ "				   size_t(n_print_size % n_max_string_length)))\n"
			/* 1127 */ "					throw std::bad_alloc(); // retrhow\n"
			/* 1128 */ "				s_data += s_concat;\n"
			/* 1129 */ "				// better concat code, using memcpy\n"
			/* 1130 */ "				// need to provide code to concat it back\n"
			/* 1131 */ "\n"
			/* 1132 */ "				b_have_to_free = true;\n"
			/* 1133 */ "				// the caller needs to dispose of the text\n"
			/* 1134 */ "			} else {\n"
			/* 1135 */ "				s_data = (b_use_base85)? \"\\t\\tconst char *p_s_base85 = "
					   "\" : \"\\t\\tconst char *p_s_base64 = \";\n"
			/* 1136 */ "				for(size_t i = 0; i < n_print_size;) {\n"
			/* 1137 */ "					size_t n_line_length = (i)? n_max_line_length : n_max_l"
					   "ine_length -\n"
			/* 1138 */ "						strlen(\"const char *p_s_baseXX = \") + n_tab_size;"
					   " // n_max_line_length expects three tabs but there are only two\n"
			/* 1139 */ "					size_t n_space = min(n_line_length, n_print_size - i);"
					   "\n"
			/* 1140 */ "					s_data += (i)? \"\\t\\t\\t\\\"\" : \"\\\"\";\n"
			/* 1141 */ "					s_data.insert(s_data.end(), s_base64.begin() + i,\n"
			/* 1142 */ "						s_base64.begin() + (i + n_space));\n"
			/* 1143 */ "					i += n_space;\n"
			/* 1144 */ "					s_data += (i == n_print_size)? \"\\\";\\n\" : \"\\\"\\n"
					   "\";\n"
			/* 1145 */ "				}\n"
			/* 1146 */ "				// just print it all\n"
			/* 1147 */ "\n"
			/* 1148 */ "				b_have_to_free = false;\n"
			/* 1149 */ "				// the caller does not need to dispose of the text\n"
			/* 1150 */ "			}\n"
			/* 1151 */ "\n"
			/* 1152 */ "			std::string s_decompress;\n"
			/* 1153 */ "			if(b_have_to_free) {\n"
			/* 1154 */ "				s_data += \"\\t\\tchar *p_data = \";\n"
			/* 1155 */ "			} else\n"
			/* 1156 */ "				s_data += \"\\t\\treturn \";\n"
			/* 1157 */ "			if(b_shared_decompress) {\n"
			/* 1158 */ "				if(!stl_ut::Format(s_decompress, \"%s(p_s_base%d, \" PRIu64"
					   " \", \" PRIsize \", \"\n"
			/* 1159 */ "				   PRIsize \");\\n\", \"p_Call_Decompress\", n_base, n_file"
					   "_size, n_afterhuff,\n"
			/* 1160 */ "				   size_t(n_bwt_primary_index)))\n"
			/* 1161 */ "					throw std::bad_alloc(); // rethrow\n"
			/* 1162 */ "			} else {\n"
			/* 1163 */ "				if(!stl_ut::Format(s_decompress, \"%s%d(p_s_base%d, \" PRIu"
					   "64 \", \" PRIsize \", \"\n"
			/* 1164 */ "				   PRIsize \");\\n\", \"(char*)p_Decode_BWT_MTF_RLE_Huff_Ba"
					   "se\", n_base, n_base,\n"
			/* 1165 */ "				   n_file_size, n_afterhuff, size_t(n_bwt_primary_index)))"
					   "\n"
			/* 1166 */ "					throw std::bad_alloc(); // rethrow\n"
			/* 1167 */ "			}\n"
			/* 1168 */ "			s_data += s_decompress;\n"
			/* 1169 */ "			// prepare the call to the decompress routine\n"
			/* 1170 */ "\n"
			/* 1171 */ "			if(b_have_to_free) {\n"
			/* 1172 */ "				if(b_use_base85)\n"
			/* 1173 */ "					s_data += \"\\t\\tdelete[] p_s_base85;\\n\";\n"
			/* 1174 */ "				else\n"
			/* 1175 */ "					s_data += \"\\t\\tdelete[] p_s_base64;\\n\";\n"
			/* 1176 */ "				s_data += \"\\t\\treturn p_data;\\n\";\n"
			/* 1177 */ "			}\n"
			/* 1178 */ "			// return the data\n"
			/* 1179 */ "\n"
			/* 1180 */ "			b_is_dynamic = true;\n"
			/* 1181 */ "			// the caller needs to dispose of the text\n"
			/* 1182 */ "		}\n"
			/* 1183 */ "	} catch(std::bad_alloc&) {\n"
			/* 1184 */ "		fprintf(stderr, \"error: not enough memory\\n\");\n"
			/* 1185 */ "		return -1;\n"
			/* 1186 */ "	}\n"
			/* 1187 */ "	// throws\n"
			/* 1188 */ "\n"
			/* 1189 */ "	{\n"
			/* 1190 */ "		std::string s_ident, s_header;\n"
			/* 1191 */ "		if(!stl_ut::AssignCStr(s_ident, p_s_name_file) ||\n"
			/* 1192 */ "		   !stl_ut::AssignCStr(s_header, p_s_name_file)) {\n"
			/* 1193 */ "			fprintf(stderr, \"error: not enough memory\\n\");\n"
			/* 1194 */ "			return -1;\n"
			/* 1195 */ "		}\n"
			/* 1196 */ "		for(size_t i = 0, n = s_ident.length(); i < n; ++ i) {\n"
			/* 1197 */ "			if(isalpha(uint8_t(s_ident[i])))\n"
			/* 1198 */ "				s_ident[i] = toupper(uint8_t(s_ident[i]));\n"
			/* 1199 */ "			else if(!isdigit(uint8_t(s_ident[i]))) {\n"
			/* 1200 */ "				s_ident[i] = \'_\';\n"
			/* 1201 */ "				s_header[i] = \'_\';\n"
			/* 1202 */ "			}\n"
			/* 1203 */ "		}\n"
			/* 1204 */ "		// create class name\n"
			/* 1205 */ "\n"
			/* 1206 */ "		FILE *p_fw;\n"
			/* 1207 */ "#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\n"
			/* 1208 */ "		if(fopen_s(&p_fw, p_s_outfile, \"w\")) {\n"
			/* 1209 */ "#else // _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\n"
			/* 1210 */ "		if(!(p_fw = fopen(p_s_outfile, \"w\"))) {\n"
			/* 1211 */ "#endif // _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400\n"
			/* 1212 */ "			fprintf(stderr, \"error: failed to open \\\'%s\\\' for writing"
					   "\\n\", p_s_outfile);\n"
			/* 1213 */ "			return -1;\n"
			/* 1214 */ "		}\n"
			/* 1215 */ "\n"
			/* 1216 */ "		fprintf(p_fw, \"/**\\n\");\n"
			/* 1217 */ "		fprintf(p_fw, \" *\\t@file %s\\n\", p_s_outfile);\n"
			/* 1218 */ "		fprintf(p_fw, \" *\\t@brief file in header, generated from \\\'%s"
					   "\\\'\\n\", p_s_name_file);\n"
			/* 1219 */ "		if(b_binary_mode)\n"
			/* 1220 */ "			fprintf(p_fw, \" *\\t\\tusing BWT / RLE / Huff / Base%d pipe\\n"
					   "\", n_base);\n"
			/* 1221 */ "		else\n"
			/* 1222 */ "			fprintf(p_fw, \" *\\t\\tstored as plain text\\n\");\n"
			/* 1223 */ "		TFileInfo::TTime t_time = TFileInfo(p_s_name_file).p_time[TFileInfo"
					   "::time_LastWrite];\n"
			/* 1224 */ "		fprintf(p_fw, \" *\\t@date %4d-%02d-%02d %02d:%02d:%02d\\n\", t_tim"
					   "e.n_year,\n"
			/* 1225 */ "			t_time.n_month, t_time.n_day, t_time.n_hour, t_time.n_minute, t"
					   "_time.n_second);\n"
			/* 1226 */ "		fprintf(p_fw, \" *\\t@author FileToHeader \" APP_VERSION \" (built "
					   "\" __DATE__ \")\\n\");\n"
			/* 1227 */ "		fprintf(p_fw, \" */\\n\\n\");\n"
			/* 1228 */ "		fprintf(p_fw, \"#pragma once\\n\");\n"
			/* 1229 */ "		fprintf(p_fw, \"#ifndef __%s_FILE_IN_HEADER_INCLUDED\\n\", s_ident."
					   "c_str());\n"
			/* 1230 */ "		fprintf(p_fw, \"#define __%s_FILE_IN_HEADER_INCLUDED\\n\\n\", s_ide"
					   "nt.c_str());\n"
			/* 1231 */ "		// generate nice header // t_odo - do the same in ImageToHeader\n"
			/* 1232 */ "\n"
			/* 1233 */ "		fprintf(p_fw, \"/**\\n\");\n"
			/* 1234 */ "		fprintf(p_fw, \" *\\t@brief file in header, generated from \\\'%s"
					   "\\\'\\n\", p_s_name_file);\n"
			/* 1235 */ "		fprintf(p_fw, \" */\\n\");\n"
			/* 1236 */ "		if(!p_s_classname)\n"
			/* 1237 */ "			fprintf(p_fw, \"class C%s {\\n\", s_header.c_str());\n"
			/* 1238 */ "		else\n"
			/* 1239 */ "			fprintf(p_fw, \"class %s {\\n\", p_s_classname); // class name "
					   "override\n"
			/* 1240 */ "		fprintf(p_fw, \"public:\\n\");\n"
			/* 1241 */ "		fprintf(p_fw, \"\\t/**\\n\"\n"
			/* 1242 */ "					  \"\\t *\\t@brief gets size of the data\\n\"\n"
			/* 1243 */ "					  \"\\t *\\t@return Returns size of the data, in bytes,"
					   " not including the terminating zero.\\n\"\n"
			/* 1244 */ "					  \"\\t */\\n\");\n"
			/* 1245 */ "		if(n_orig_file_size == n_file_size) {\n"
			/* 1246 */ "			fprintf(p_fw, \"\\tstatic inline size_t n_Size()\\n\\t{\\n\\t"
					   "\\treturn \" PRIu64\n"
			/* 1247 */ "				\"; // matches original file\\n\\t}\\n\\n\", n_file_size);"
					   "\n"
			/* 1248 */ "		} else {\n"
			/* 1249 */ "			fprintf(p_fw, \"\\tstatic inline size_t n_Size()\\n\\t{\\n\\t"
					   "\\treturn \" PRIu64\n"
			/* 1250 */ "				\"; // original file \" PRIu64 \" B\\n\\t}\\n\\n\", n_file_"
					   "size, n_orig_file_size);\n"
			/* 1251 */ "		}\n"
			/* 1252 */ "		fprintf(p_fw, \"\\t/**\\n\"\n"
			/* 1253 */ "					  \"\\t *\\t@brief determines whether the stored string"
					   " is dynamically allocated\\n\"\n"
			/* 1254 */ "					  \"\\t *\\t@return Returns true if the caller of p_Dat"
					   "a() needs to free the memory.\\n\"\n"
			/* 1255 */ "					  \"\\t */\\n\");\n"
			/* 1256 */ "		fprintf(p_fw, \"\\tstatic inline bool b_Dynamic()\\n\\t{\\n\\t\\tre"
					   "turn %s;\\n\\t}\\n\\n\",\n"
			/* 1257 */ "			(b_is_dynamic)? \"true\" : \"false\");\n"
			/* 1258 */ "		fprintf(p_fw, \"\\t/**\\n\"\n"
			/* 1259 */ "					  \"\\t *\\t@brief gets CRC\\n\"\n"
			/* 1260 */ "					  \"\\t *\\t@return Returns CRC32 of the stored data."
					   "\\n\"\n"
			/* 1261 */ "					  \"\\t *\\t@note The stored CRC may differ from the or"
					   "iginal file if data processing was enabled.\\n\"\n"
			/* 1262 */ "					  \"\\t */\\n\");\n"
			/* 1263 */ "		if(n_orig_crc32 == n_crc32) {\n"
			/* 1264 */ "			fprintf(p_fw, \"\\tstatic inline uint32_t n_CRC32()\\n\\t{\\n"
					   "\\t\\treturn 0x%08x;\"\n"
			/* 1265 */ "				\" // matches original file\\n\\t}\\n\\n\", n_crc32);\n"
			/* 1266 */ "		} else {\n"
			/* 1267 */ "			fprintf(p_fw, \"\\tstatic inline uint32_t n_CRC32()\\n\\t{\\n"
					   "\\t\\treturn 0x%08x;\"\n"
			/* 1268 */ "				\" // original file 0x%08x\\n\\t}\\n\\n\", n_crc32, n_orig_"
					   "crc32);\n"
			/* 1269 */ "		}\n"
			/* 1270 */ "		fprintf(p_fw, \"\\t/**\\n\"\n"
			/* 1271 */ "					  \"\\t *\\t@brief gets data\\n\"\n"
			/* 1272 */ "					  \"\\t *\\n\"\n"
			/* 1273 */ "					  \"\\t *\\t@return Returns data of the file on success"
					   ", 0 on failure (not enough memory).\\n\"\n"
			/* 1274 */ "					  \"\\t *\\n\"\n"
			/* 1275 */ "					  \"\\t *\\t@note The data (despite it may be binary), "
					   "is additionally null terminated to make\\n\"\n"
			/* 1276 */ "					  \"\\t *\\t\\tit easier to use (the terminating null i"
					   "s not counted in n_Size()).\\n\"\n"
			/* 1277 */ "					  \"\\t *\\t@note See also b_Dynamic().\\n\"\n"
			/* 1278 */ "					  \"\\t */\\n\");\n"
			/* 1279 */ "		if(b_is_dynamic)\n"
			/* 1280 */ "			fprintf(p_fw, \"\\tstatic inline char *p_Data()\\n\\t{\\n\");\n"
			/* 1281 */ "		else\n"
			/* 1282 */ "			fprintf(p_fw, \"\\tstatic inline const char *p_Data()\\n\\t{\\n"
					   "\");\n"
			/* 1283 */ "		fprintf(p_fw, \"%s\", s_data.c_str());\n"
			/* 1284 */ "		fprintf(p_fw, \"\\t}\\n\");\n"
			/* 1285 */ "		\n"
			/* 1286 */ "		uint32_t n_decompressor_crc = 0;\n"
			/* 1287 */ "		std::string s_decompress_src;\n"
			/* 1288 */ "		if(b_binary_mode) {\n"
			/* 1289 */ "			if(b_binary_mode) {\n"
			/* 1290 */ "#if 1\n"
			/* 1291 */ "				char *p_s_deco;\n"
			/* 1292 */ "				if(b_use_base85)\n"
			/* 1293 */ "					p_s_deco = CDecompress85_h::p_Data(); // use itself to "
					   "generate compressed decompressor\n"
			/* 1294 */ "				else\n"
			/* 1295 */ "					p_s_deco = CDecompress64_h::p_Data(); // use itself to "
					   "generate compressed decompressor\n"
			/* 1296 */ "				if(!p_s_deco || !stl_ut::AssignCStr(s_decompress_src, p_s_d"
					   "eco)) {\n"
			/* 1297 */ "					if(p_s_deco)\n"
			/* 1298 */ "						delete[] p_s_deco;\n"
			/* 1299 */ "					fprintf(stderr, \"error: failed to decompress the decom"
					   "press routines\\n\");\n"
			/* 1300 */ "#else\n"
			/* 1301 */ "				if(!ReadFile(s_decompress_src, (b_use_base85)? \"Decompress"
					   "64.h\" : \"Decompress85.h\")) { // uncool, hard to use from commandline\n"
			/* 1302 */ "					fprintf(stderr, \"error: failed to read \\\'Decompress."
					   "h\\\',\"\n"
			/* 1303 */ "						\" unable to include decompress routines\\n\");\n"
			/* 1304 */ "#endif\n"
			/* 1305 */ "					fclose(p_fw);\n"
			/* 1306 */ "					return -1;\n"
			/* 1307 */ "				} else {\n"
			/* 1308 */ "					size_t n_pos = 0;\n"
			/* 1309 */ "					while((n_pos = s_decompress_src.find(\"\\r\\n\", n_pos)"
					   ") != std::string::npos)\n"
			/* 1310 */ "						s_decompress_src.erase(n_pos, 1);\n"
			/* 1311 */ "					// condense newlines\n"
			/* 1312 */ "\n"
			/* 1313 */ "					n_decompressor_crc = CCrc_32::n_Crc(s_decompress_src.le"
					   "ngth() *\n"
			/* 1314 */ "						sizeof(char), s_decompress_src.data());\n"
			/* 1315 */ "					// calculate CRC of it\n"
			/* 1316 */ "				}\n"
			/* 1317 */ "			}\n"
			/* 1318 */ "		}\n"
			/* 1319 */ "		// read the decompressor\n"
			/* 1320 */ "\n"
			/* 1321 */ "		if(b_binary_mode) {\n"
			/* 1322 */ "			if(b_shared_decompress) {\n"
			/* 1323 */ "				fprintf(p_fw, \"\\nprotected:\\n\"\n"
			/* 1324 */ "							  \"\\t/**\\n\"\n"
			/* 1325 */ "							  \"\\t *\\t@copydoc CFTHDecompressCode_%08x::p"
					   "_Decode_BWT_MTF_RLE_Huff_Base%d\\n\"\n"
			/* 1326 */ "							  \"\\t */\\n\"\n"
			/* 1327 */ "							  \"\\tstatic inline char *p_Call_Decompress(co"
					   "nst char *p_s_base%d,\\n\"\n"
			/* 1328 */ "							  \"\\t\\tint n_data_size, int n_huff_stage_siz"
					   "e, uint32_t n_bwt_primary_index);\\n\",\n"
			/* 1329 */ "							  n_decompressor_crc, n_base, n_base);\n"
			/* 1330 */ "				// specify a small routine that will call decompressor once"
					   " it\'s been declared\n"
			/* 1331 */ "\n"
			/* 1332 */ "				fprintf(p_fw, \"};\\n\");\n"
			/* 1333 */ "				// end the previos class\n"
			/* 1334 */ "\n"
			/* 1335 */ "				fprintf(p_fw, \"\\n#ifndef __FILE_TO_HEADER_DECOMPRESS_%08X"
					   "_INCLUDED\\n\", n_decompressor_crc);\n"
			/* 1336 */ "				fprintf(p_fw, \"#define __FILE_TO_HEADER_DECOMPRESS_%08X_IN"
					   "CLUDED\\n\\n\", n_decompressor_crc);\n"
			/* 1337 */ "\n"
			/* 1338 */ "				fprintf(p_fw, \"/**\\n\"\n"
			/* 1339 */ "							  \" *\\t@brief decompression routine implement"
					   "ation\\n\"\n"
			/* 1340 */ "				//			  \" *\\t@note While this allows all the comp"
					   "ressed files to share decompressor implementation,\\n\"\n"
			/* 1341 */ "				//			  \" *\\t\\tit restricts all the files to be "
					   "included in a single .cpp file, otherwise linking\\n\"\n"
			/* 1342 */ "				//			  \" *\\t\\tfails because of duplicate symbol"
					   "s (remove body of decompress function in such case).\\n\"\n"
			/* 1343 */ "							  \" */\\n\"\n"
			/* 1344 */ "							  \"class CFTHDecompressCode_%08x {\\npublic:"
					   "\\n\", n_decompressor_crc);\n"
			/* 1345 */ "				fprintf(p_fw, \"%s\", s_decompress_src.c_str());\n"
			/* 1346 */ "				// include decompress routines\n"
			/* 1347 */ "\n"
			/* 1348 */ "				fprintf(p_fw, \"};\\n\\n#endif // __FILE_TO_HEADER_DECOMPRE"
					   "SS_%08X_INCLUDED\\n\\n\", n_decompressor_crc);\n"
			/* 1349 */ "\n"
			/* 1350 */ "				fprintf(p_fw, \"inline char *%s%s::p_Call_Decompress(const "
					   "char *p_s_base%d,\\n\"\n"
			/* 1351 */ "							  \"\\tint n_data_size, int n_huff_stage_size, "
					   "uint32_t n_bwt_primary_index)\\n\"\n"
			/* 1352 */ "							  \"{\\n\"\n"
			/* 1353 */ "							  \"\\treturn (char*)CFTHDecompressCode_%08x::p"
					   "_Decode_BWT_MTF_RLE_Huff_Base%d(p_s_base%d,\\n\"\n"
			/* 1354 */ "							  \"\\t\\tn_data_size, n_huff_stage_size, n_bwt"
					   "_primary_index);\\n\"\n"
			/* 1355 */ "							  \"}\\n\"\n"
			/* 1356 */ "							  \"// a dummy function that calls the decompre"
					   "ssor, which is now declared\\n\"\n"
			/* 1357 */ "							  \"// (allows us to keep it at the end of the "
					   "file)\\n\",\n"
			/* 1358 */ "							  (p_s_classname)? \"\" : \"C\", (p_s_classname"
					   ")? p_s_classname : s_header.c_str(), // fix: use p_s_classname here as well"
					   "\n"
			/* 1359 */ "							  n_base, n_decompressor_crc, n_base, n_base);"
					   "\n"
			/* 1360 */ "				// implement the body of the dummy routine that calls the d"
					   "ecompress after we declared it\n"
			/* 1361 */ "			} else {\n"
			/* 1362 */ "				fprintf(p_fw, \"\\nprotected:\\n%s};\\n\", s_decompress_src"
					   ".c_str());\n"
			/* 1363 */ "				// otherwise make the decompressor a part of the file class"
					   "\n"
			/* 1364 */ "			}\n"
			/* 1365 */ "		} else\n"
			/* 1366 */ "			fprintf(p_fw, \"};\\n\");\n"
			/* 1367 */ "		// include decompressor, make it so that the code can be shared if "
					   "more than a single file is included\n"
			/* 1368 */ "\n"
			/* 1369 */ "		fprintf(p_fw, \"\\n#endif // !__%s_FILE_IN_HEADER_INCLUDED\\n\", s_"
					   "ident.c_str());\n"
			/* 1370 */ "\n"
			/* 1371 */ "		if(ferror(p_fw)) {\n"
			/* 1372 */ "			fprintf(stderr, \"error: failed to write code to \\\'%s\\\'\\n"
					   "\", p_s_outfile);\n"
			/* 1373 */ "			return -1;\n"
			/* 1374 */ "		}\n"
			/* 1375 */ "\n"
			/* 1376 */ "		fclose(p_fw);\n"
			/* 1377 */ "	}\n"
			/* 1378 */ "	// write C++ header file\n"
			/* 1379 */ "\n"
			/* 1380 */ "	if(b_verbose)\n"
			/* 1381 */ "		printf(\"\\ndone\\n\");\n"
			/* 1382 */ "\n"
			/* 1383 */ "	return 0;\n"
			/* 1384 */ "}\n"
		};
		char *p_s_text;
		if(!(p_s_text = new(std::nothrow) char[51729]))
			return 0;
		char *p_s_dest = p_s_text;
		for(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_array[0]); i < n; ++ i) {
			size_t n_chunk = strlen(p_text_array[i]);
			memcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char));
			p_s_dest += n_chunk;
		}
		*p_s_dest = 0;
		return p_s_text;
	}
};

#endif // !__MAIN_CPP_FILE_IN_HEADER_INCLUDED
