/**
 *	@file Test_TextMode3.h
 *	@brief file in header, generated from 'Main.cpp'
 *		stored as plain text
 *	@date 2016-06-30 12:20:35
 *	@author FileToHeader v2.03 (built Jul 19 2016)
 */

#pragma once
#ifndef __MAIN_CPP_FILE_IN_HEADER_INCLUDED
#define __MAIN_CPP_FILE_IN_HEADER_INCLUDED

/**
 *	@brief file in header, generated from 'Main.cpp'
 */
class CMain_cpp {
public:
	/**
	 *	@brief gets size of the data
	 *	@return Returns size of the data, in bytes, not including the terminating zero.
	 */
	static inline size_t n_Size()
	{
		return 32769; // original file 53112 B
	}

	/**
	 *	@brief determines whether the stored string is dynamically allocated
	 *	@return Returns true if the caller of p_Data() needs to free the memory.
	 */
	static inline bool b_Dynamic()
	{
		return true;
	}

	/**
	 *	@brief gets CRC
	 *	@return Returns CRC32 of the stored data.
	 *	@note The stored CRC may differ from the original file if data processing was enabled.
	 */
	static inline uint32_t n_CRC32()
	{
		return 0xe5977d32; // original file 0xf208554c
	}

	/**
	 *	@brief gets data
	 *
	 *	@return Returns data of the file on success, 0 on failure (not enough memory).
	 *
	 *	@note The data (despite it may be binary), is additionally null terminated to make
	 *		it easier to use (the terminating null is not counted in n_Size()).
	 *	@note See also b_Dynamic().
	 */
	static inline char *p_Data()
	{
		const char *p_text_array[] = {
			/*    2 */ "" /* +----------------------------------+ */
			/*    3 */ "" /* |                                  | */
			/*    4 */ "" /* |    ***   File to header   ***    | */
			/*    5 */ "" /* |                                  | */
			/*    6 */ "" /* |   Copyright  -tHE SWINe- 2009   | */
			/*    7 */ "" /* |                                  | */
			/*    8 */ "" /* |             Main.cpp             | */
			/*    9 */ "" /* |                                  | */
			/*   10 */ "" /* +----------------------------------+ */
			/*   13 */ "#include \"../UberLame_src/NewFix.h\"\n"
			/*   14 */ "#include \"../UberLame_src/CallStack.h\"\n"
			/*   15 */ "#include <string.h>\n"
			/*   16 */ "#include <stdlib.h>\n"
			/*   17 */ "#include <stdio.h>\n"
			/*   18 */ "#include <vector>\n"
			/*   19 */ "#include <string>\n"
			/*   20 */ "#include <algorithm>\n"
			/*   21 */ "#include \"../UberLame_src/Integer.h\"\n"
			/*   22 */ "#include \"../UberLame_src/Tga.h\"\n"
			/*   23 */ "#include \"../UberLame_src/Jpeg.h\"\n"
			/*   24 */ "#include \"../UberLame_src/MinMax.h\"\n"
			/*   25 */ "#include \"../UberLame_src/StlUtils.h\"\n"
			/*   26 */ "#include \"../UberLame_src/Buffer.h\"\n"
			/*   27 */ "#include \"../UberLame_src/Compress.h\"\n"
			/*   28 */ "#include \"../UberLame_src/Base64.h\"\n"
			/*   29 */ "#include \"../UberLame_src/Base85.h\"\n"
			/*   30 */ "#include \"../UberLame_src/Crc.h\"\n"
			/*   31 */ "#include \"../UberLame_src/Dir.h\"\n"
			/*   33 */ "#if defined(_MSC_VER) && !defined(__MWERKS__) && !defined(for) && _MSC_VER "
					   "<= 1200\n"
			/*   34 */ "#define for if(0) {} else for\n"
			/*   35 */ "#endif\n" /* _MSC_VER && !__MWERKS__ && !for && _MSC_VER <= 1200 */
			/*   36 */ "" /* msvc 'for' scoping hack */
			/*   38 */ "#define APP_VERSION \"v2.03\"\n"
			/*   40 */ "bool ReadFile(TBuffer &r_t_output, const char *p_s_filename)\n"
			/*   41 */ "{\n"
			/*   42 */ "FILE *p_fr;\n"
			/*   43 */ "#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\n"
			/*   44 */ "if(fopen_s(&p_fr, p_s_filename, \"rb\"))\n"
			/*   45 */ "#else\n" /* _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400 */
			/*   46 */ "if(!(p_fr = fopen(p_s_filename, \"rb\")))\n"
			/*   47 */ "#endif\n" /* _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400 */
			/*   48 */ "return false;\n"
			/*   49 */ "int n_length;\n"
			/*   50 */ "if(fseek(p_fr, 0, SEEK_END) ||\n"
			/*   51 */ "(n_length = ftell(p_fr)) < 0 ||\n"
			/*   52 */ "fseek(p_fr, 0, SEEK_SET)) {\n"
			/*   53 */ "fclose(p_fr);\n"
			/*   54 */ "return false;\n"
			/*   55 */ "}\n"
			/*   56 */ "if(!r_t_output.Resize(n_length, false)) {\n"
			/*   57 */ "fclose(p_fr);\n"
			/*   58 */ "return false;\n"
			/*   59 */ "}\n"
			/*   60 */ "if(fread(r_t_output.p_Data(), n_length, sizeof(uint8_t), p_fr) != 1) {\n"
			/*   61 */ "fclose(p_fr);\n"
			/*   62 */ "return false;\n"
			/*   63 */ "}\n"
			/*   64 */ "fclose(p_fr);\n"
			/*   65 */ "return true;\n"
			/*   66 */ "}\n"
			/*   68 */ "bool ReadFile(std::string &r_s_output, const char *p_s_filename)\n"
			/*   69 */ "{\n"
			/*   70 */ "FILE *p_fr;\n"
			/*   71 */ "#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\n"
			/*   72 */ "if(fopen_s(&p_fr, p_s_filename, \"rb\"))\n"
			/*   73 */ "#else\n" /* _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400 */
			/*   74 */ "if(!(p_fr = fopen(p_s_filename, \"rb\")))\n"
			/*   75 */ "#endif\n" /* _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400 */
			/*   76 */ "return false;\n"
			/*   77 */ "int n_length;\n"
			/*   78 */ "if(fseek(p_fr, 0, SEEK_END) ||\n"
			/*   79 */ "(n_length = ftell(p_fr)) < 0 ||\n"
			/*   80 */ "fseek(p_fr, 0, SEEK_SET)) {\n"
			/*   81 */ "fclose(p_fr);\n"
			/*   82 */ "return false;\n"
			/*   83 */ "}\n"
			/*   84 */ "r_s_output.erase();\n"
			/*   85 */ "if(!stl_ut::Resize_To_N(r_s_output, n_length)) {\n"
			/*   86 */ "fclose(p_fr);\n"
			/*   87 */ "return false;\n"
			/*   88 */ "}\n"
			/*   89 */ "if(fread(&r_s_output[0], n_length, sizeof(char), p_fr) != 1) {\n"
			/*   90 */ "fclose(p_fr);\n"
			/*   91 */ "return false;\n"
			/*   92 */ "}\n"
			/*   93 */ "fclose(p_fr);\n"
			/*   94 */ "return true;\n"
			/*   95 */ "}\n"
			/*   97 */ "void EscapeString(std::string &r_s_str)\n" /* throws */
			/*   98 */ "{\n"
			/*   99 */ "for(size_t i = 0, n = r_s_str.length(); i < n; ++ i) {\n"
			/*  100 */ "if((uint8_t(r_s_str[i]) < \' \' && r_s_str[i] != \'\\t\') ||\n" /* keep tabs, we like it */
			/*  101 */ "r_s_str[i] == \'\\\'\' || r_s_str[i] == \'\\\"\' || r_s_str[i] == \'\\\\\')"
					   " {\n" /* need to handle quotes */
			/*  102 */ "char n_seq = 0;\n"
			/*  103 */ "switch(r_s_str[i]) {\n"
			/*  104 */ "case \'\\n\':\n"
			/*  105 */ "n_seq = \'n\';\n"
			/*  106 */ "break;\n"
			/*  107 */ "case \'\\r\':\n"
			/*  108 */ "n_seq = \'r\';\n"
			/*  109 */ "break;\n"
			/*  110 */ "case \'\\\\\':\n"
			/*  111 */ "n_seq = \'\\\\\';\n"
			/*  112 */ "break;\n"
			/*  113 */ "case \'\\\'\':\n"
			/*  114 */ "n_seq = \'\\\'\';\n"
			/*  115 */ "break;\n"
			/*  116 */ "case \'\\\"\':\n"
			/*  117 */ "n_seq = \'\\\"\';\n"
			/*  118 */ "break;\n"
			/*  119 */ "" /* case '\t': */
			/*  120 */ "" /* n_seq = 't'; */
			/*  121 */ "" /* break; */ /* keep tabs, we like it */
			/*  122 */ "case \'\\f\':\n"
			/*  123 */ "n_seq = \'f\';\n"
			/*  124 */ "break;\n"
			/*  125 */ "case \'\\a\':\n"
			/*  126 */ "n_seq = \'a\';\n"
			/*  127 */ "break;\n"
			/*  128 */ "case \'\\b\':\n"
			/*  129 */ "n_seq = \'b\';\n"
			/*  130 */ "break;\n"
			/*  131 */ "case \'\\v\':\n"
			/*  132 */ "n_seq = \'v\';\n"
			/*  133 */ "break;\n"
			/*  134 */ "};\n"
			/*  135 */ "" /* see if we can find escape sequence for this character */
			/*  137 */ "if(n_seq) {\n"
			/*  138 */ "r_s_str[i] = n_seq;\n"
			/*  139 */ "r_s_str.insert(i, 1, \'\\\\\');\n"
			/*  140 */ "++ i;\n"
			/*  141 */ "++ n;\n" /* !! */
			/*  142 */ "} else {\n"
			/*  143 */ "char p_s_xseq[64];\n"
			/*  144 */ "stl_ut::Format(p_s_xseq, sizeof(p_s_xseq), \"x%02x\", int(r_s_str[i]));\n"
			/*  145 */ "r_s_str[i] = \'\\\\\';\n"
			/*  146 */ "r_s_str.insert(i + 1, (const char*)p_s_xseq);\n"
			/*  147 */ "size_t l = strlen(p_s_xseq);\n"
			/*  148 */ "i += l;\n"
			/*  149 */ "n += l;\n" /* !! */
			/*  150 */ "}\n"
			/*  151 */ "" /* escape low characters */
			/*  152 */ "} else if(uint8_t(r_s_str[i]) >= 128) {\n"
			/*  153 */ "char p_s_xseq[64];\n"
			/*  154 */ "stl_ut::Format(p_s_xseq, sizeof(p_s_xseq), \"x%02x\", int(uint8_t(r_s_str[i"
					   "])));\n" /* make sure it is not negative */
			/*  155 */ "r_s_str[i] = \'\\\\\';\n"
			/*  156 */ "r_s_str.insert(i + 1, (const char*)p_s_xseq);\n"
			/*  157 */ "size_t l = strlen(p_s_xseq);\n"
			/*  158 */ "i += l;\n"
			/*  159 */ "n += l;\n" /* !! */
			/*  160 */ "" /* escape big characters */
			/*  161 */ "}\n"
			/*  162 */ "}\n"
			/*  163 */ "" /* todo - not sure what happens if "\x12" escape sequence is followed by a [0-9a-f] letter? */
			/*  164 */ "" /* maybe need to escape even simple letters until the next letter is another one */
			/*  165 */ "}\n"
			/*  167 */ "" /* t_odo - skip mutliline comments, actually not that hard, first erase the single line comment, */
			/*  168 */ "" /* then just make sure that there is no "\"" before the "/+" and then erase everything up to the next "+/" */
			/*  169 */ "" /* not checking for the line comments */
			/*  171 */ "" /* note that decoupling comments from printing would make it much easier */
			/*  173 */ "" /* void Strip_LineComment(std::string &r_s_comment, std::string &r_s_line, */
			/*  174 */ "" /* size_t n_line, size_t n_line_num, uint64_t &r_n_file_size) */
			/*  175 */ "" /* { */
			/*  176 */ "" /* r_s_comment.clear(); */
			/*  177 */ "" /* // !! */
			/*  179 */ "" /* size_t n_pos; */
			/*  180 */ "" /* if((n_pos = r_s_line.find("//")) != std::string::npos && */
			/*  181 */ "" /* (r_s_line.rfind('\"', n_pos) == std::string::npos || */
			/*  182 */ "" /* r_s_line.find('\"', n_pos) == std::string::npos) && // not arround strings, seems dangerous (can have strings before or in, but not on both sides) */
			/*  183 */ "" /* (r_s_line[r_s_line.length() - 1] == '\n' || (r_s_line[r_s_line.length() - 2] == '\\' && */
			/*  184 */ "" /* r_s_line[r_s_line.length() - 1] == 'n') || n_line + 1 == n_line_num)) { // must be the whole line here (so that the comment also ends) */
			/*  185 */ "" /* if(r_s_line[r_s_line.length() - 1] == 'n') { */
			/*  186 */ "" /* size_t e = r_s_line.length() - 1, n_slash_num = 0; */
			/*  187 */ "" /* while(e > 0 && r_s_line[e - 1] == '\\') { */
			/*  188 */ "" /* -- e; */
			/*  189 */ "" /* ++ n_slash_num; */
			/*  190 */ "" /* } */
			/*  191 */ "" /* _ASSERTE(n_slash_num > 0); */
			/*  192 */ "" /* if(!(n_slash_num & 1)) */
			/*  193 */ "" /* return; */
			/*  194 */ "" /* } */
			/*  195 */ "" /* // this can still turn out bad, the end "\n" might be something like "\\n" and */
			/*  196 */ "" /* // the backslash does not belong to the "n" and hence the line does not in fact end in a newline */
			/*  197 */ "" /* // or it can be "\\\n" and then it is ok "\\a\\n" does not get confused - so only need to count */
			/*  198 */ "" /* // the consecutive backslashes and if even, it is not a newline */
			/*  200 */ "" /* size_t n_end = r_s_line.length(); */
			/*  201 */ "" /* if(n_end > 1 && r_s_line[n_end - 2] == '\\' && r_s_line[n_end - 1] == 'n') */
			/*  202 */ "" /* n_end -= 2; */
			/*  203 */ "" /* else if(n_end > 1 && r_s_line[n_end - 1] == '\n') */
			/*  204 */ "" /* -- n_end; */
			/*  205 */ "" /* // skip the newline at the end */
			/*  207 */ "" /* r_s_comment.insert(r_s_comment.end(), */
			/*  208 */ "" /* r_s_line.begin() + n_pos, */
			/*  209 */ "" /* r_s_line.begin() + n_end); */
			/*  210 */ "" /* // extract the comment */
			/*  212 */ "" /* while(n_pos > 0 && isspace(uint8_t(r_s_line[n_pos - 1]))) */
			/*  213 */ "" /* -- n_pos; */
			/*  214 */ "" /* // skip whitespace before the comment */
			/*  216 */ "" /* size_t n_comment_escape_num = 0; */
			/*  217 */ "" /* for(size_t i = 0, n = r_s_comment.length(); i < n; ++ i) { */
			/*  218 */ "" /* if(r_s_comment[i] == '\\') { */
			/*  219 */ "" /* if(i + 1 < n && r_s_comment[i + 1] == 'x') */
			/*  220 */ "" /* n_comment_escape_num += 3; // e.g. \x01 */
			/*  221 */ "" /* else */
			/*  222 */ "" /* ++ n_comment_escape_num; */
			/*  223 */ "" /* ++ i; // to avoid counting backslash escape seq. twice */
			/*  224 */ "" /* } */
			/*  225 */ "" /* } */
			/*  226 */ "" /* // counts escape sequences in strings (!!) */
			/*  228 */ "" /* r_n_file_size -= n_end - n_pos; // account for it in the file size */
			/*  229 */ "" /* r_n_file_size += n_comment_escape_num; // these were accounted for twice */
			/*  230 */ "" /* r_s_line.erase(r_s_line.begin() + n_pos, */
			/*  231 */ "" /* r_s_line.begin() + n_end); */
			/*  232 */ "" /* // erase the comment from the original string */
			/*  233 */ "" /* } */
			/*  234 */ "" /* } */
			/*  236 */ "#if 0\n"
			/*  237 */ "void Base64_Evolution()\n"
			/*  238 */ "{\n"
			/*  239 */ "int p_ic_tab[128] = {0};\n"
			/*  240 */ "" /* for(unsigned int i = 0; i < 128; ++ i) { */
			/*  241 */ "" /* p_ic_tab[i] = (isalpha(i))? (i | 32) - 'a' + ((i < 'a')? 0 : 26) : */
			/*  242 */ "" /* (isdigit(i))? i - '0' + 52 : (i == '+')? 62 : 63; */
			/*  243 */ "" /* } */
			/*  244 */ "for(int i = 0; i < 64; ++ i)\n"
			/*  245 */ "p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : \"+/\"[i -"
					   " 62]] = i;\n"
			/*  246 */ "" /* p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : (i - 51) * 4 - 1] = i; */
			/*  247 */ "" /* p_ic_tab[(i < 26)? 65 + i : (i < 52)? 71 + i : (i < 62)? i - 4 : (i > 62)? '/' : '+'] = i; */
			/*  248 */ "" /* p_ic_tab[(i < 26)? 'A' + i : (i < 52)? 'a' - 26 + i : (i < 62)? '0' - 52 + i : (i == 62)? '+' : '/'] = i; */
			/*  249 */ "" /* p_ic_tab["ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[i]] = i; */
			/*  250 */ "}\n"
			/*  251 */ "#endif\n" /* 0 */
			/*  253 */ "void PrintHelp()\n"
			/*  254 */ "{\n"
			/*  255 */ "fprintf(stderr, \"error: missing program arguments.\\n\"\n"
			/*  256 */ "\"usage:\\n\"\n"
			/*  257 */ "\"FileToHeader <input-file> <header-file> [options]\\n\"\n"
			/*  258 */ "\"where input-file is source file, containing data in text or binary format"
					   ",\\n\"\n"
			/*  259 */ "\"and header-file is output file to contain this data.\\n\"\n"
			/*  260 */ "\"\\nOptions may be the following:\\n\"\n"
			/*  261 */ "\"--verbose parameter turns on verbose output (default off)\\n\"\n"
			/*  262 */ "\"--name-after overrides input file name for naming the class (in case the "
					   "input file\\n\"\n"
			/*  263 */ "\"             is an intermediate of a longer processing chain and does not"
					   " have a name)\\n\"\n"
			/*  264 */ "\"--class-name overrides the default class name (not checked for syntax err"
					   "ors)\\n\"\n"
			/*  265 */ "\"--binary forces binary encoding with compression (binary data / obfuscati"
					   "on)\\n\"\n"
			/*  266 */ "\"--text saves the input file as transparent text (default)\\n\"\n"
			/*  267 */ "\"--max-cstr-len sets maximum \\\"C\\\"-string length (default 32767)\\n\""
					   "\n"
			/*  268 */ "\"--max-line-len sets maximum line length in the generated header\\n\"\n"
			/*  269 */ "\"               (only applies to the lines with data; default 100)\\n\"\n"
			/*  270 */ "\"\\nThe following options only apply in text mode:\\n\"\n"
			/*  271 */ "\"--keep-newlines transcripts newlines as they are found in the file\\n\"\n"
			/*  272 */ "\"--unix-newlines forces single \\\'\\\\n\\\' newlines (default)\\n\"\n"
			/*  273 */ "\"--strip-comments enables processing of C++ line comments (the coments are"
					   " present\\n\"\n"
			/*  274 */ "\"                 in the header, but are not part of the string)\\n\"\n"
			/*  275 */ "\"--line-numbers enables putting line numbers as comments in the output fil"
					   "e\\n\"\n"
			/*  276 */ "\"                 for example to aid debugging without the original file, "
					   "etc.\\n\"\n"
			/*  277 */ "\"--trim-line-whitespace enables throwing away line whitespace\\n\"\n"
			/*  278 */ "\"--discard-empty-lines enables throwing away lines with nothing but whites"
					   "pace\\n\"\n"
			/*  279 */ "\"\\nThe following options only apply in binary mode:\\n\"\n"
			/*  280 */ "\"--shared-decompress enables shared decompressor class (disabled by defaul"
					   "t)\\n\"\n"
			/*  281 */ "\"--force-text-ops enables text processing operations (disabled by default)"
					   "\\n\"\n"
			/*  282 */ "\"--base-64 forces the use of Base-64 instead of the default Base-85\\n\");"
					   "\n"
			/*  283 */ "}\n"
			/*  285 */ "#include \"Decompress64.h\"\n"
			/*  286 */ "#include \"Decompress64Src.h\"\n"
			/*  287 */ "#include \"Decompress85.h\"\n"
			/*  288 */ "#include \"Decompress85Src.h\"\n"
			/*  290 */ "" /* #include "Test_TextMode3.h" // simple test */
			/*  292 */ "void TrimSpace_but_EndLine(std::string &r_s_line)\n"
			/*  293 */ "{\n"
			/*  294 */ "size_t b = 0, e = r_s_line.length();\n"
			/*  296 */ "while(e > b && (r_s_line[e - 1] == \'\\r\' || r_s_line[e - 1] == \'\\n\'))"
					   "\n"
			/*  297 */ "-- e;\n"
			/*  298 */ "" /* keep newline */
			/*  300 */ "size_t e2 = e;\n"
			/*  301 */ "while(b < e2 && isspace(uint8_t(r_s_line[b])))\n"
			/*  302 */ "++ b;\n"
			/*  303 */ "while(b < e2 && isspace(uint8_t(r_s_line[e2 - 1])))\n"
			/*  304 */ "-- e2;\n"
			/*  305 */ "" /* find whitespace */
			/*  307 */ "r_s_line.erase(e2, e - e2);\n"
			/*  308 */ "r_s_line.erase(0, b);\n"
			/*  309 */ "}\n"
			/*  311 */ "int main(int n_arg_num, const char **p_arg_list)\n"
			/*  312 */ "{\n"
			/*  313 */ "if(n_arg_num < 3) {\n"
			/*  314 */ "PrintHelp();\n"
			/*  315 */ "return 0;\n"
			/*  316 */ "}\n"
			/*  318 */ "" /* { */
			/*  319 */ "" /* int m = CMain_cpp::n_Size(); */
			/*  320 */ "" /* const char *p_s_text = (const char*)CMain_cpp::p_Data(); */
			/*  321 */ "" /* int n = strlen(p_s_text); */
			/*  322 */ "" /* if(m == n) */
			/*  323 */ "" /* printf("recorded and actual length (%d) matches\n", m); */
			/*  324 */ "" /* else */
			/*  325 */ "" /* printf("recorded (%d) and actual (%d) length do not match\n", m, n); */
			/*  326 */ "" /* uint32_t n_crc = CCrc_32::n_Crc(n, p_s_text); */
			/*  327 */ "" /* if(n_crc == CMain_cpp::n_CRC32()) */
			/*  328 */ "" /* printf("recorded and actual CRC (0x%08x) matches\n", n_crc); */
			/*  329 */ "" /* else */
			/*  330 */ "" /* printf("recorded (0x%08x) and actual (0x%08x) CRC do not match\n", CMain_cpp::n_CRC32(), n_crc); */
			/*  331 */ "" /* FILE *p_fw = fopen("test_writeback.h", "wb"); */
			/*  332 */ "" /* fprintf(p_fw, "%s", p_s_text); */
			/*  333 */ "" /* fclose(p_fw); */
			/*  334 */ "" /* if(CMain_cpp::b_Dynamic()) */
			/*  335 */ "" /* free((char*)p_s_text); */
			/*  336 */ "" /* } */ /* simple test */
			/*  338 */ "unsigned int n_max_string_length = 32767;\n" /* to avoid c++ compilers complaining */
			/*  339 */ "unsigned int n_max_line_length = 100;\n"
			/*  340 */ "bool b_verbose = false;\n"
			/*  341 */ "bool b_binary_mode = false;\n"
			/*  342 */ "bool b_prefix_line_numbers = false;\n" /* in text mode, add /+ 123 +/ line numbers in front of the strings with the lines */
			/*  343 */ "bool b_overriden_newline_mode = false;\n" /* if --keep-newlines or --unix-newlines was specified */
			/*  344 */ "bool b_unix_newlines = true;\n" /* in text mode, replaces "\r\n" sequences for only "\n" */
			/*  345 */ "bool b_strip_line_comments = false;\n" /* in text mode, get "// line comments" and put them outside of the text, effectively reducing the payload */
			/*  346 */ "bool b_shared_decompress = false;\n" /* whether to make the decompression routine shared (potentially leads to link conflicts) */
			/*  347 */ "bool b_treat_binary_as_text = false;\n" /* force text processing in binary mode as well */
			/*  348 */ "bool b_trim_line_whitespace = false;\n" /* throw away leading and trailing whitespace (except the newline) on each line */
			/*  349 */ "bool b_discard_empty_lines = false;\n" /* throw away lines that only contain whitespace (including a newline) */
			/*  350 */ "bool b_use_base85 = true;\n" /* use Base-85 instead of Base-64 (default) */
			/*  351 */ "const int n_tab_size = 4;\n"
			/*  352 */ "" /* config */
			/*  354 */ "const char *p_s_infile = p_arg_list[1];\n"
			/*  355 */ "const char *p_s_name_file = p_s_infile;\n"
			/*  356 */ "const char *p_s_outfile = p_arg_list[2];\n"
			/*  357 */ "const char *p_s_classname = 0;\n"
			/*  359 */ "for(int i = 3; i < n_arg_num; ++ i) {\n"
			/*  360 */ "if(!strcmp(p_arg_list[i], \"--verbose\") || !strcmp(p_arg_list[i], \"-v\"))"
					   "\n"
			/*  361 */ "b_verbose = true;\n"
			/*  362 */ "else if(!strcmp(p_arg_list[i], \"--keep-newlines\") || !strcmp(p_arg_list[i"
					   "], \"-kn\")) {\n"
			/*  363 */ "b_unix_newlines = false;\n"
			/*  364 */ "b_overriden_newline_mode = true;\n"
			/*  365 */ "} else if(!strcmp(p_arg_list[i], \"-h\") || !strcmp(p_arg_list[i], \"--help"
					   "\")) {\n"
			/*  366 */ "PrintHelp();\n"
			/*  367 */ "return 0;\n"
			/*  368 */ "} else if(!strcmp(p_arg_list[i], \"--unix-newlines\") || !strcmp(p_arg_list"
					   "[i], \"-un\")) {\n"
			/*  369 */ "b_unix_newlines = true;\n"
			/*  370 */ "b_overriden_newline_mode = true;\n"
			/*  371 */ "} else if(!strcmp(p_arg_list[i], \"--shared-decompress\") || !strcmp(p_arg_"
					   "list[i], \"-sd\"))\n"
			/*  372 */ "b_shared_decompress = true;\n"
			/*  373 */ "else if(!strcmp(p_arg_list[i], \"--line-numbers\") || !strcmp(p_arg_list[i]"
					   ", \"-ln\"))\n"
			/*  374 */ "b_prefix_line_numbers = true;\n"
			/*  375 */ "else if(!strcmp(p_arg_list[i], \"--strip-comments\") || !strcmp(p_arg_list["
					   "i], \"-sc\"))\n"
			/*  376 */ "b_strip_line_comments = true;\n"
			/*  377 */ "else if(!strcmp(p_arg_list[i], \"--trim-line-whitespace\") || !strcmp(p_arg"
					   "_list[i], \"-tlw\"))\n"
			/*  378 */ "b_trim_line_whitespace = true;\n"
			/*  379 */ "else if(!strcmp(p_arg_list[i], \"--discard-empty-lines\") || !strcmp(p_arg_"
					   "list[i], \"-del\"))\n"
			/*  380 */ "b_discard_empty_lines = true;\n"
			/*  381 */ "else if(!strcmp(p_arg_list[i], \"--binary\") || !strcmp(p_arg_list[i], \"-b"
					   "\"))\n"
			/*  382 */ "b_binary_mode = true;\n"
			/*  383 */ "else if(!strcmp(p_arg_list[i], \"--text\") || !strcmp(p_arg_list[i], \"-t\""
					   "))\n"
			/*  384 */ "b_binary_mode = false;\n"
			/*  385 */ "else if(!strcmp(p_arg_list[i], \"--force-text-ops\") || !strcmp(p_arg_list["
					   "i], \"-fto\"))\n"
			/*  386 */ "b_treat_binary_as_text = true;\n"
			/*  387 */ "else if(!strcmp(p_arg_list[i], \"--base-64\") || !strcmp(p_arg_list[i], \"-"
					   "b64\"))\n"
			/*  388 */ "b_use_base85 = false;\n"
			/*  389 */ "else if(i + 1 == n_arg_num) {\n"
			/*  390 */ "fprintf(stderr, \"warning: parameter: \\\'%s\\\': \"\n"
			/*  391 */ "\"unknown parameter or needs a value (skipping)\\n\", p_arg_list[i]);\n"
			/*  392 */ "} else if(!strcmp(p_arg_list[i], \"--max-line-len\") || !strcmp(p_arg_list["
					   "i], \"-mll\"))\n"
			/*  393 */ "n_max_line_length = atol(p_arg_list[++ i]);\n"
			/*  394 */ "else if(!strcmp(p_arg_list[i], \"--max-cstr-len\") || !strcmp(p_arg_list[i]"
					   ", \"-mcsl\"))\n"
			/*  395 */ "n_max_string_length = atol(p_arg_list[++ i]);\n"
			/*  396 */ "else if(!strcmp(p_arg_list[i], \"--class-name\") || !strcmp(p_arg_list[i], "
					   "\"-cn\"))\n"
			/*  397 */ "p_s_classname = p_arg_list[++ i];\n"
			/*  398 */ "else if(!strcmp(p_arg_list[i], \"--name-after\") || !strcmp(p_arg_list[i], "
					   "\"-na\"))\n"
			/*  399 */ "p_s_name_file = p_arg_list[++ i];\n"
			/*  400 */ "else\n"
			/*  401 */ "fprintf(stderr, \"warning: unknown parameter: \\\'%s\\\' (skipping)\\n\", p"
					   "_arg_list[i]);\n"
			/*  402 */ "}\n"
			/*  403 */ "" /* parse command-line */
			/*  405 */ "if(b_binary_mode) {\n"
			/*  406 */ "if(!b_treat_binary_as_text) {\n"
			/*  407 */ "if(b_prefix_line_numbers || b_overriden_newline_mode || b_strip_line_commen"
					   "ts ||\n"
			/*  408 */ "b_trim_line_whitespace || b_discard_empty_lines) {\n"
			/*  409 */ "fprintf(stderr, \"warning: --force-text-ops not specified, all\"\n"
			/*  410 */ "\" text operations ignored in binary mode\\n\");\n"
			/*  411 */ "}\n"
			/*  412 */ "} else {\n"
			/*  413 */ "if(b_prefix_line_numbers)\n"
			/*  414 */ "fprintf(stderr, \"warning: --line-numbers ignored in binary mode\\n\");\n"
			/*  415 */ "}\n"
			/*  416 */ "} else {\n"
			/*  417 */ "if(b_treat_binary_as_text)\n"
			/*  418 */ "fprintf(stderr, \"warning: --force-text-ops ignored in text mode\\n\");\n"
			/*  419 */ "if(!b_use_base85)\n"
			/*  420 */ "fprintf(stderr, \"warning: --base-64 ignored in text mode\\n\");\n"
			/*  421 */ "}\n"
			/*  422 */ "" /* check command-line */
			/*  424 */ "if(b_verbose)\n"
			/*  425 */ "printf(\"FileToHeader \" APP_VERSION \" (built \" __DATE__ \")\\n\\n\");\n"
			/*  426 */ "" /* print version */
			/*  428 */ "n_max_string_length = max(n_max_string_length, n_max_line_length);\n"
			/*  429 */ "" /* must be at least the same */
			/*  431 */ "n_max_line_length -= 2;\n" /* the quotes */
			/*  432 */ "n_max_line_length -= 3 * n_tab_size;\n" /* the tabs */
			/*  434 */ "if(b_verbose)\n"
			/*  435 */ "printf(\"loading input file ...\\n\");\n"
			/*  437 */ "uint64_t n_file_size = -1, n_orig_file_size = -1;\n"
			/*  438 */ "bool b_is_dynamic = false;\n"
			/*  439 */ "uint32_t n_crc32 = 0, n_orig_crc32 = 0;\n"
			/*  440 */ "std::string s_data;\n"
			/*  441 */ "int n_base = (b_use_base85)? 85 : 64;\n" /* if compressed */
			/*  442 */ "try {\n"
			/*  443 */ "std::string s_file;\n"
			/*  444 */ "std::vector<int> line_no;\n"
			/*  445 */ "char p_s_line_no_format[64];\n"
			/*  446 */ "char p_s_hide_line_no[64];\n"
			/*  447 */ "std::vector<std::string> line_list;\n"
			/*  448 */ "std::vector<std::vector<std::string> > line_comment_list;\n"
			/*  449 */ "" /* text processing data (shared now) */
			/*  451 */ "if(!b_binary_mode || b_treat_binary_as_text) {\n"
			/*  452 */ "if(!ReadFile(s_file, p_s_infile)) {\n"
			/*  453 */ "fprintf(stderr, \"error: failed to load \\\'%s\\\'\\n\", p_s_infile);\n"
			/*  454 */ "return -1;\n"
			/*  455 */ "}\n"
			/*  456 */ "" /* read */
			/*  458 */ "if(s_file.find(\'\\0\') != std::string::npos) {\n"
			/*  459 */ "fprintf(stderr, \"error: file \\\'%s\\\' contains null characters;\"\n"
			/*  460 */ "\" must be saved as binary\\n\", p_s_infile);\n"
			/*  461 */ "return -1;\n"
			/*  462 */ "}\n"
			/*  464 */ "n_orig_crc32 = CCrc_32::n_Crc(s_file.length() * sizeof(char), s_file.data()"
					   ");\n"
			/*  465 */ "" /* calculate the original CRC32 */
			/*  467 */ "n_file_size = s_file.size();\n"
			/*  468 */ "n_orig_file_size = n_file_size;\n"
			/*  469 */ "" /* take size now */
			/*  471 */ "if(b_unix_newlines) {\n"
			/*  472 */ "size_t n_pos = 0;\n"
			/*  473 */ "while((n_pos = s_file.find(\"\\r\\n\", n_pos)) != std::string::npos) {\n"
			/*  474 */ "s_file.erase(n_pos, 1);\n"
			/*  475 */ "++ n_pos;\n"
			/*  476 */ "}\n"
			/*  477 */ "}\n"
			/*  478 */ "" /* take binary newlines '\r\n' and make them only '\n' */
			/*  480 */ "stl_ut::Split(line_list, s_file, \"\\n\");\n"
			/*  481 */ "for(size_t i = 0, n = line_list.size(); i + 1 < n; ++ i)\n"
			/*  482 */ "line_list[i] += \'\\n\';\n" /* keep newlines */
			/*  483 */ "" /* split to lines */
			/*  485 */ "if(b_trim_line_whitespace) {\n"
			/*  486 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i)\n"
			/*  487 */ "TrimSpace_but_EndLine(line_list[i]);\n" /* trim space */
			/*  488 */ "}\n"
			/*  489 */ "" /* trim line whitespace */
			/*  491 */ "if(b_verbose && b_binary_mode)\n"
			/*  492 */ "printf(\"forced text processing | \");\n"
			/*  493 */ "if(b_verbose)\n"
			/*  494 */ "printf(\"have %d lines\\n\", line_list.size());\n"
			/*  495 */ "" /* verbose */
			/*  497 */ "if(line_list.back().empty())\n"
			/*  498 */ "line_list.erase(line_list.end() - 1);\n"
			/*  499 */ "" /* erase the last empty line (without even newline on it), it looks weird */
			/*  501 */ "if(b_prefix_line_numbers) {\n"
			/*  502 */ "stl_ut::Format(p_s_line_no_format, sizeof(p_s_line_no_format),\n"
			/*  503 */ "PRIsize, line_list.size());\n"
			/*  504 */ "size_t n_line_num_log10 = strlen(p_s_line_no_format);\n"
			/*  505 */ "stl_ut::Format(p_s_line_no_format, sizeof(p_s_line_no_format),\n"
			/*  506 */ "\"/* %%%dd */ \", n_line_num_log10);\n"
			/*  507 */ "" /* make format string for line numbers */
			/*  509 */ "char p_s_hide_line_no_format[64];\n"
			/*  510 */ "stl_ut::Format(p_s_hide_line_no_format, sizeof(p_s_hide_line_no_format),\n"
			/*  511 */ "\"   %%%ds    \", n_line_num_log10);\n" /* just spaces */
			/*  512 */ "stl_ut::Format(p_s_hide_line_no, sizeof(p_s_hide_line_no), p_s_hide_line_no"
					   "_format, \"\");\n"
			/*  513 */ "for(int b = 0, e = strlen(p_s_hide_line_no); b < e; ++ b) {\n"
			/*  514 */ "if(b + n_tab_size < e) {\n"
			/*  515 */ "p_s_hide_line_no[b] = \'\\t\';\n"
			/*  516 */ "e -= n_tab_size - 1;\n"
			/*  517 */ "p_s_hide_line_no[e] = 0;\n"
			/*  518 */ "}\n"
			/*  519 */ "}\n"
			/*  520 */ "" /* make string for hidden line numbers (retarded but working) */
			/*  522 */ "n_line_num_log10 += 7;\n" /* 7 = strlen("/+ ") + strlen(" +/ ") */
			/*  523 */ "if(n_max_line_length > n_line_num_log10)\n"
			/*  524 */ "n_max_line_length -= n_line_num_log10;\n"
			/*  525 */ "" /* include the line numbers in line length calculation */
			/*  527 */ "line_no.resize(line_list.size());\n"
			/*  528 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i)\n"
			/*  529 */ "line_no[i] = i + 1;\n"
			/*  530 */ "_ASSERTE(line_no.size() == line_list.size());\n"
			/*  531 */ "" /* make a list of line numbers (a stupid approach, but easy to get right) */
			/*  532 */ "}\n"
			/*  534 */ "if(b_strip_line_comments) {\n"
			/*  535 */ "line_comment_list.resize(line_list.size());\n"
			/*  536 */ "bool b_in_multiline_comment = false;\n"
			/*  537 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  538 */ "std::string &r_s_line = line_list[i];\n"
			/*  539 */ "" /* get a line */
			/*  541 */ "_ASSERTE(!r_s_line.empty() && (i + 1 == n || r_s_line[r_s_line.length() - 1"
					   "] == \'\\n\'));\n"
			/*  542 */ "" /* make sure each line ends in newline at this stage */
			/*  544 */ "size_t b = 0, e = r_s_line.length();\n"
			/*  545 */ "if(b_in_multiline_comment) {\n"
			/*  546 */ "if((b = r_s_line.find(\"*/\")) != std::string::npos) {\n"
			/*  547 */ "++ b;\n"
			/*  548 */ "_ASSERTE(r_s_line[b - 1] == \'*\' && r_s_line[b] == \'/\');\n"
			/*  549 */ "" /* ignore everything else, just look for the end of the comment */
			/*  551 */ "size_t b2 = 0;\n"
			/*  552 */ "while(isspace(uint8_t(r_s_line[b2])))\n"
			/*  553 */ "++ b2;\n"
			/*  554 */ "" /* find the beginning of the comment text */
			/*  556 */ "_ASSERTE(b > 0);\n"
			/*  557 */ "size_t e4 = b - 1;\n"
			/*  558 */ "while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - 1])))\n"
			/*  559 */ "-- e4;\n"
			/*  560 */ "" /* find the end of the comment text */
			/*  562 */ "std::string s_comment;\n"
			/*  563 */ "s_comment.insert(s_comment.begin(), r_s_line.begin() + b2, r_s_line.begin()"
					   " + e4);\n"
			/*  564 */ "if(!s_comment.empty())\n"
			/*  565 */ "line_comment_list[i].push_back(s_comment);\n"
			/*  566 */ "r_s_line.erase(r_s_line.begin(), r_s_line.begin() + (b + 1));\n"
			/*  567 */ "" /* process the comment */
			/*  569 */ "b = 0;\n" /* !! */
			/*  570 */ "e = r_s_line.length();\n" /* this changed */
			/*  571 */ "b_in_multiline_comment = false;\n" /* !! */
			/*  572 */ "} else {\n" /* the comment is this whole line */
			/*  573 */ "b = 0;\n"
			/*  574 */ "size_t e2 = e;\n"
			/*  575 */ "while(e2 > b && (r_s_line[e2 - 1] == \'\\n\' || r_s_line[e2 - 1] == \'\\r\'"
					   "))\n"
			/*  576 */ "-- e2;\n"
			/*  577 */ "" /* find end of line */
			/*  579 */ "size_t b2 = 0;\n"
			/*  580 */ "while(b2 < e2 && isspace(uint8_t(r_s_line[b2])))\n"
			/*  581 */ "++ b2;\n"
			/*  582 */ "" /* find the beginning of the comment text */
			/*  584 */ "size_t e4 = e2;\n"
			/*  585 */ "while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - 1])))\n"
			/*  586 */ "-- e4;\n"
			/*  587 */ "" /* find end of the comment text */
			/*  589 */ "std::string s_comment;\n"
			/*  590 */ "s_comment.insert(s_comment.begin(), r_s_line.begin() + b2, r_s_line.begin()"
					   " + e4);\n"
			/*  591 */ "if(!s_comment.empty())\n"
			/*  592 */ "line_comment_list[i].push_back(s_comment);\n"
			/*  593 */ "r_s_line.erase(r_s_line.begin(), r_s_line.begin() + e2);\n"
			/*  594 */ "" /* process the comment */
			/*  596 */ "e = b;\n"
			/*  597 */ "" /* nothing else to do on this line */
			/*  598 */ "}\n"
			/*  599 */ "}\n"
			/*  600 */ "" /* parse continuing comment */
			/*  602 */ "for(; b < e; ++ b) {\n"
			/*  603 */ "if(r_s_line[b] == \'\\\'\') {\n"
			/*  604 */ "++ b;\n"
			/*  605 */ "for(; b < e; ++ b) {\n"
			/*  606 */ "if(r_s_line[b] == \'\\\\\') {\n"
			/*  607 */ "++ b;\n"
			/*  608 */ "" /* can be whatever after it (mostly a single character, */
			/*  609 */ "" /* sometimes hexadecimal number), but will correctly skip "\'" */
			/*  610 */ "} else if(r_s_line[b] == \'\\\'\')\n"
			/*  611 */ "break;\n"
			/*  612 */ "" /* found the other (unescaped) apostrophe */
			/*  613 */ "}\n"
			/*  614 */ "if(b == e || r_s_line[b] == \'\\\'\')\n"
			/*  615 */ "continue;\n"
			/*  616 */ "}\n"
			/*  617 */ "" /* eat "C" character literals */
			/*  619 */ "if(r_s_line[b] == \'\\\"\') {\n"
			/*  620 */ "++ b;\n"
			/*  621 */ "for(; b < e; ++ b) {\n"
			/*  622 */ "if(r_s_line[b] == \'\\\\\') {\n"
			/*  623 */ "++ b;\n"
			/*  624 */ "" /* can be whatever after it (mostly a single character, */
			/*  625 */ "" /* sometimes a hexadecimal number), but will correctly skip "\"" */
			/*  626 */ "} else if(r_s_line[b] == \'\\\"\')\n"
			/*  627 */ "break;\n"
			/*  628 */ "" /* found the other (unescaped) quote */
			/*  629 */ "}\n"
			/*  630 */ "if(b == e || r_s_line[b] == \'\\\"\')\n"
			/*  631 */ "continue;\n"
			/*  632 */ "}\n"
			/*  633 */ "" /* eat "C" string literals */
			/*  635 */ "if(r_s_line[b] == \'/\' && b + 1 < e) {\n"
			/*  636 */ "if(r_s_line[b + 1] == \'/\') {\n"
			/*  637 */ "size_t e2 = e;\n"
			/*  638 */ "while(e2 > b && (r_s_line[e2 - 1] == \'\\n\' || r_s_line[e2 - 1] == \'\\r\'"
					   "))\n"
			/*  639 */ "-- e2;\n"
			/*  640 */ "" /* find end of line */
			/*  642 */ "size_t b2 = b + 2;\n"
			/*  643 */ "while(b2 < e2 && isspace(uint8_t(r_s_line[b2])))\n"
			/*  644 */ "++ b2;\n"
			/*  645 */ "" /* find the beginning of the comment text */
			/*  647 */ "while(b > 0 && isspace(uint8_t(r_s_line[b - 1])))\n"
			/*  648 */ "-- b;\n"
			/*  649 */ "" /* will erase the preceding whitespace as well */
			/*  651 */ "std::string s_comment;\n"
			/*  652 */ "s_comment.insert(s_comment.begin(), r_s_line.begin() + b2, r_s_line.begin()"
					   " + e2);\n"
			/*  653 */ "if(!s_comment.empty())\n"
			/*  654 */ "line_comment_list[i].push_back(s_comment);\n"
			/*  655 */ "r_s_line.erase(r_s_line.begin() + b, r_s_line.begin() + e2);\n"
			/*  656 */ "break;\n"
			/*  657 */ "}\n"
			/*  658 */ "" /* found a line comment */
			/*  660 */ "if(r_s_line[b + 1] == \'*\') {\n"
			/*  661 */ "size_t e2 = e;\n"
			/*  662 */ "while(e2 > b && (r_s_line[e2 - 1] == \'\\n\' || r_s_line[e2 - 1] == \'\\r\'"
					   "))\n"
			/*  663 */ "-- e2;\n"
			/*  664 */ "" /* find end of line */
			/*  666 */ "size_t b2 = b + 2;\n"
			/*  667 */ "while(b2 < e2 && isspace(uint8_t(r_s_line[b2])))\n"
			/*  668 */ "++ b2;\n"
			/*  669 */ "" /* find the beginning of the comment text */
			/*  671 */ "size_t e3 = b2 + 1;\n"
			/*  672 */ "while(e3 < e2 && (r_s_line[e3 - 1] != \'*\' || r_s_line[e3] != \'/\'))\n"
			/*  673 */ "++ e3;\n"
			/*  674 */ "" /* find the end of the comment text */
			/*  676 */ "while(b > 0 && isspace(uint8_t(r_s_line[b - 1])))\n"
			/*  677 */ "-- b;\n"
			/*  678 */ "" /* will erase the preceding whitespace as well */
			/*  680 */ "std::string s_comment;\n"
			/*  681 */ "if(e3 < e2 && r_s_line[e3 - 1] == \'*\' && r_s_line[e3] == \'/\') {\n"
			/*  682 */ "" /* the comment ends on this line */
			/*  684 */ "_ASSERTE(e3 > 0);\n"
			/*  685 */ "size_t e4 = e3 - 1;\n"
			/*  686 */ "while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - 1])))\n"
			/*  687 */ "-- e4;\n"
			/*  688 */ "" /* find end of the comment text */
			/*  690 */ "s_comment.insert(s_comment.begin(), r_s_line.begin() + b2, r_s_line.begin()"
					   " + e4);\n"
			/*  691 */ "r_s_line.erase(r_s_line.begin() + b, r_s_line.begin() + e3 + 1);\n"
			/*  692 */ "" /* get the comment */
			/*  694 */ "e = r_s_line.length();\n" /* this changed */
			/*  695 */ "-- b;\n" /* compensate for ++ b in the outer loop */
			/*  696 */ "" /* (there can be more separate comments on a single line!) */
			/*  697 */ "} else {\n"
			/*  698 */ "b_in_multiline_comment = true;\n" /* the comment carries to the next line */
			/*  700 */ "size_t e4 = e2;\n"
			/*  701 */ "while(e4 > b2 && isspace(uint8_t(r_s_line[e4 - 1])))\n"
			/*  702 */ "-- e4;\n"
			/*  703 */ "" /* find end of the comment text */
			/*  705 */ "s_comment.insert(s_comment.begin(), r_s_line.begin() + b2, r_s_line.begin()"
					   " + e4);\n"
			/*  706 */ "r_s_line.erase(r_s_line.begin() + b, r_s_line.begin() + e2);\n"
			/*  707 */ "e = b;\n" /* we are finished with this line */
			/*  708 */ "}\n"
			/*  709 */ "" /* extract the comment */
			/*  711 */ "if(!s_comment.empty())\n"
			/*  712 */ "line_comment_list[i].push_back(s_comment);\n"
			/*  713 */ "}\n"
			/*  714 */ "" /* found a multiline comment */
			/*  715 */ "}\n"
			/*  716 */ "" /* eat comments */
			/*  717 */ "}\n"
			/*  718 */ "" /* parse "C" strings, characters and comments / C++ comments */
			/*  719 */ "}\n"
			/*  720 */ "" /* for each line */
			/*  722 */ "for(size_t i = 0, n = line_comment_list.size(); i < n; ++ i) {\n"
			/*  723 */ "std::vector<std::string> &r_comments = line_comment_list[i];\n"
			/*  724 */ "for(size_t j = 0, m = r_comments.size(); j < m; ++ j) {\n"
			/*  725 */ "std::string &r_comment = r_comments[j];\n"
			/*  726 */ "size_t n_pos = 0;\n"
			/*  727 */ "while((n_pos = r_comment.find(\"/*\")) != std::string::npos)\n"
			/*  728 */ "r_comment[++ n_pos] = \'+\';\n"
			/*  729 */ "n_pos = 0;\n"
			/*  730 */ "while((n_pos = r_comment.find(\"*/\")) != std::string::npos)\n"
			/*  731 */ "r_comment[n_pos] = \'+\';\n"
			/*  732 */ "++ n_pos;\n"
			/*  733 */ "}\n"
			/*  734 */ "}\n"
			/*  735 */ "" /* replace comments inside comments to avoid warnings when building the header */
			/*  736 */ "}\n"
			/*  737 */ "" /* extract comments from the text */
			/*  739 */ "if(b_discard_empty_lines) {\n"
			/*  740 */ "_ASSERTE(line_no.empty() || line_no.size() == line_list.size());\n"
			/*  741 */ "std::string s_line, s_dummy;\n"
			/*  742 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  743 */ "s_line = line_list[i];\n"
			/*  744 */ "" /* get a copy of the line */
			/*  746 */ "stl_ut::TrimSpace(s_line);\n"
			/*  747 */ "" /* trim space */
			/*  749 */ "if(s_line.empty()) {\n"
			/*  750 */ "if(line_comment_list[i].empty()) {\n"
			/*  751 */ "line_list.erase(line_list.begin() + i);\n"
			/*  752 */ "if(!line_no.empty())\n"
			/*  753 */ "line_no.erase(line_no.begin() + i);\n"
			/*  754 */ "if(!line_comment_list.empty())\n"
			/*  755 */ "line_comment_list.erase(line_comment_list.begin() + i);\n"
			/*  756 */ "-- i;\n"
			/*  757 */ "-- n;\n"
			/*  758 */ "" /* no comments, just delete the line */
			/*  759 */ "} else {\n"
			/*  760 */ "line_list[i].clear();\n"
			/*  761 */ "" /* there is a comment, just keep the empty line as a placeholder */
			/*  762 */ "}\n"
			/*  763 */ "}\n"
			/*  764 */ "" /* discard empty ones */
			/*  765 */ "}\n"
			/*  766 */ "_ASSERTE(line_no.empty() || line_no.size() == line_list.size());\n"
			/*  767 */ "}\n"
			/*  768 */ "" /* discard empty lines */
			/*  770 */ "{\n"
			/*  771 */ "n_crc32 = CCrc_32::n_Start();\n"
			/*  772 */ "n_file_size = 0;\n"
			/*  773 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  774 */ "n_crc32 = CCrc_32::n_Crc(line_list[i].length() * sizeof(char), line_list[i]"
					   ".data(), n_crc32);\n"
			/*  775 */ "n_file_size += line_list[i].length();\n"
			/*  776 */ "}\n"
			/*  777 */ "n_crc32 = CCrc_32::n_Finalize(n_crc32);\n"
			/*  778 */ "" /* calculate CRC */
			/*  779 */ "}\n"
			/*  780 */ "" /* count file size after all the changes */
			/*  782 */ "if(b_verbose && b_binary_mode) {\n"
			/*  783 */ "printf(\"saved \" PRIsizeB \"B in text processing\\n\",\n"
			/*  784 */ "PRIsizeBparams(n_orig_file_size - n_file_size));\n"
			/*  785 */ "}\n"
			/*  786 */ "}\n"
			/*  787 */ "if(!b_binary_mode) {\n"
			/*  788 */ "std::for_each(line_list.begin(), line_list.end(), EscapeString);\n"
			/*  789 */ "" /* escape strange characters */
			/*  791 */ "uint64_t n_print_size = 0;\n"
			/*  792 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i)\n"
			/*  793 */ "n_print_size += line_list[i].length();\n"
			/*  794 */ "" /* count length */
			/*  796 */ "if(n_max_line_length > 0) {\n"
			/*  797 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  798 */ "size_t n_tab_num = std::count(line_list[i].begin(), line_list[i].end(), \'"
					   "\\t\');\n" /* may not compile in msvc60 */
			/*  799 */ "if(line_list[i].length() + n_tab_num * (n_tab_size - 1) > n_max_line_length"
					   ") {\n" /* * (n_tab_size - 1) because one character is counted already */
			/*  800 */ "std::string &r_s_line_i = line_list[i];\n"
			/*  801 */ "int n_cut;\n"
			/*  802 */ "unsigned int l = r_s_line_i.length(), chars = 0;;\n"
			/*  803 */ "for(n_cut = 0; unsigned(n_cut) < l; ++ n_cut) {\n"
			/*  804 */ "unsigned int chars2 = chars + ((r_s_line_i[n_cut] == \'\\t\')? n_tab_size :"
					   " 1);\n"
			/*  805 */ "if(chars2 > n_max_line_length && (chars > n_max_line_length ||\n"
			/*  806 */ "(n_max_line_length - chars) < (chars2 - n_max_line_length + 1)))\n"
			/*  807 */ "break;\n" /* find the precise position of the cut, minimizing the distance from the cut line */
			/*  808 */ "chars = chars2;\n"
			/*  809 */ "}\n"
			/*  810 */ "" /* int n_cut = n_max_line_length - n_tab_num * (n_tab_size - 1); // try to fixup (not precise) */
			/*  811 */ "if(n_cut <= 0)\n"
			/*  812 */ "n_cut = n_max_line_length;\n" /* ... */
			/*  813 */ "if(n_cut >= r_s_line_i.length())\n"
			/*  814 */ "n_cut = r_s_line_i.length();\n" /* 2016-06-16 - fixed a bug with out of bounds access triggered by lines with many tabs on them where the imprecise estimate overshoots past the length of the line */
			/*  815 */ "_ASSERTE(n_cut > 0);\n"
			/*  816 */ "" /* decide where to cut to have no more than n_max_line_length characters in the header */
			/*  818 */ "while((n_cut > 0 && r_s_line_i[n_cut - 1] == \'\\\\\') ||\n"
			/*  819 */ "(n_cut > 1 && r_s_line_i[n_cut - 2] == \'\\\\\' && r_s_line_i[n_cut - 1] =="
					   " \'x\') ||\n"
			/*  820 */ "(n_cut > 2 && r_s_line_i[n_cut - 3] == \'\\\\\' && r_s_line_i[n_cut - 2] =="
					   " \'x\'))\n"
			/*  821 */ "n_cut -= (r_s_line_i[n_cut - 1] == \'\\\\\')? 1 : (r_s_line_i[n_cut - 1] =="
					   " \'x\')? 2 : 3;\n"
			/*  822 */ "" /* can't leave '\\' at the end of the line (shouldn't cut escape sequences in two parts) */
			/*  823 */ "" /* note that '\\x12' will still be cut by this (the compilers do not like that) // t_odo - test it */
			/*  825 */ "if(n_cut <= 0 || n_cut == r_s_line_i.length())\n"
			/*  826 */ "continue;\n"
			/*  827 */ "" /* leave long line, couldn't cut because of abuse of escape sequences */
			/*  829 */ "std::string s_second_line;\n"
			/*  830 */ "s_second_line.insert(s_second_line.end(),\n"
			/*  831 */ "line_list[i].begin() + n_cut, line_list[i].end());\n"
			/*  832 */ "line_list[i].erase(line_list[i].begin() + n_cut, line_list[i].end());\n"
			/*  833 */ "line_list.insert(line_list.begin() + (i + 1), s_second_line);\n"
			/*  834 */ "++ n;\n" /* !! */
			/*  836 */ "if(!line_no.empty())\n"
			/*  837 */ "line_no.insert(line_no.begin() + i + 1, -1);\n" /* insert -1 *after* so the lines do not repeat */
			/*  838 */ "if(!line_comment_list.empty())\n"
			/*  839 */ "line_comment_list.insert(line_comment_list.begin() + i, std::vector<std::st"
					   "ring>());\n" /* insert empty comment *before* as there will likely be more space on the subsequent lines */
			/*  840 */ "" /* duplicate line numbers and comments as well, if we need them */
			/*  841 */ "}\n"
			/*  842 */ "}\n"
			/*  843 */ "_ASSERTE(line_no.empty() || line_no.size() == line_list.size());\n"
			/*  844 */ "_ASSERTE(line_comment_list.empty() || line_comment_list.size() == line_comm"
					   "ent_list.size());\n"
			/*  845 */ "}\n"
			/*  846 */ "" /* break long lines to multiple ones (but without introducing new line breaks) */
			/*  848 */ "if(n_print_size > n_max_string_length) {\n" /* note that n_print_size could be n_file_size as well, but some compilers might actually limit that instead */
			/*  849 */ "s_data = \"\\t\\tconst char *p_text_array[] = {\\n\";\n"
			/*  850 */ "size_t n_cur_size = 0;\n"
			/*  851 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  852 */ "size_t n_last_line = line_list[i].length();\n"
			/*  853 */ "if(n_cur_size + n_last_line <= n_max_string_length) {\n"
			/*  854 */ "if(i)\n"
			/*  855 */ "s_data += \"\\n\";\n"
			/*  856 */ "n_cur_size += n_last_line;\n"
			/*  857 */ "} else {\n"
			/*  858 */ "if(i)\n"
			/*  859 */ "s_data += \",\\n\";\n"
			/*  860 */ "n_cur_size = n_last_line;\n"
			/*  861 */ "}\n"
			/*  862 */ "s_data += \"\\t\\t\\t\";\n"
			/*  863 */ "if(b_prefix_line_numbers) {\n"
			/*  864 */ "char p_s_line_no[64];\n"
			/*  865 */ "if(line_no[i] > 0) {\n"
			/*  866 */ "stl_ut::Format(p_s_line_no, sizeof(p_s_line_no),\n"
			/*  867 */ "p_s_line_no_format, line_no[i]);\n"
			/*  868 */ "s_data += p_s_line_no;\n"
			/*  869 */ "} else\n"
			/*  870 */ "s_data += p_s_hide_line_no;\n"
			/*  871 */ "}\n"
			/*  872 */ "s_data += \"\\\"\";\n"
			/*  873 */ "s_data += line_list[i];\n"
			/*  874 */ "s_data += \"\\\"\";\n"
			/*  875 */ "if(!line_comment_list.empty() && !line_comment_list[i].empty()) {\n"
			/*  876 */ "for(size_t j = 0, m = line_comment_list[i].size(); j < m; ++ j) {\n"
			/*  877 */ "s_data += \" /* \";\n"
			/*  878 */ "s_data += line_comment_list[i][j];\n"
			/*  879 */ "s_data += \" */\";\n"
			/*  880 */ "}\n"
			/*  881 */ "" /* insert comments */
			/*  882 */ "}\n"
			/*  883 */ "}\n"
			/*  884 */ "s_data += \"\\n\\t\\t};\\n\";\n"
			/*  885 */ "" /* need to split it */
			/*  887 */ "std::string s_size;\n"
			/*  888 */ "if(!stl_ut::Format(s_size, \"\\t\\tchar *p_s_text;\\n\\t\\tif(!(p_s_text = "
					   "new(std::nothrow) char[\"\n"
			/*  889 */ "PRIu64 \"]))\\n\\t\\t\\treturn 0;\\n\", n_file_size + 1))\n"
			/*  890 */ "throw std::bad_alloc();\n" /* retrhow */
			/*  891 */ "s_data += s_size;\n"
			/*  893 */ "" /* s_data += "\t\t*p_s_text = 0;\n" */
			/*  894 */ "" /* "\t\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_array[0]); i < n; ++ i)\n" */
			/*  895 */ "" /* "\t\t\tstrcat(p_s_text, p_text_array[i]);\n" */
			/*  896 */ "" /* "\t\treturn p_s_text;\n"; */
			/*  897 */ "" /* uses strcat; ugly, inefficient */
			/*  899 */ "" /* std::string s_concat; */
			/*  900 */ "" /* if(!stl_ut::Format(s_concat, "\t\tchar *p_s_dest = p_s_text;\n" */
			/*  901 */ "" /* "\t\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_array[0]); i < n; ++ i) {\n" */
			/*  902 */ "" /* "\t\t\tsize_t n_chunk = (i + 1 < n)? " PRIsize " : " PRIsize ";\n" */
			/*  903 */ "" /* "\t\t\tmemcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char));\n" "\t\t\tp_s_dest += n_chunk;\n" */
			/*  904 */ "" /* "\t\t}\n" "\t\t*p_s_dest = 0;\n" "\t\treturn p_s_text;\n", n_max_string_length, */
			/*  905 */ "" /* size_t(n_file_size % n_max_string_length))) */
			/*  906 */ "" /* throw std::bad_alloc(); // retrhow */
			/*  907 */ "" /* s_data += s_concat; */ /* can't use as we are deciding on n_print_size instead of n_file_size, it is hard to calculate what n_chunk should be */
			/*  908 */ "" /* better concat code, using memcpy() */
			/*  910 */ "std::string s_concat;\n"
			/*  911 */ "if(!stl_ut::Format(s_concat, \"\\t\\tchar *p_s_dest = p_s_text;\\n\"\n"
			/*  912 */ "\"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_array[0]"
					   "); i < n; ++ i) {\\n\"\n"
			/*  913 */ "\"\\t\\t\\tsize_t n_chunk = strlen(p_text_array[i]);\\n\"\n"
			/*  914 */ "\"\\t\\t\\tmemcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char));\\n\" "
					   "\"\\t\\t\\tp_s_dest += n_chunk;\\n\"\n"
			/*  915 */ "\"\\t\\t}\\n\" \"\\t\\t*p_s_dest = 0;\\n\" \"\\t\\treturn p_s_text;\\n\", n"
					   "_max_string_length,\n"
			/*  916 */ "size_t(n_file_size % n_max_string_length)))\n"
			/*  917 */ "throw std::bad_alloc();\n" /* retrhow */
			/*  918 */ "s_data += s_concat;\n"
			/*  919 */ "" /* better concat code, using memcpy() and strlen() */
			/*  921 */ "" /* need to provide code to concat it back */
			/*  923 */ "b_is_dynamic = true;\n"
			/*  924 */ "" /* the caller needs to dispose of the text */
			/*  925 */ "} else {\n"
			/*  926 */ "s_data = \"\\t\\tconst char *p_s_text =\\n\";\n"
			/*  927 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i) {\n"
			/*  928 */ "s_data += \"\\t\\t\\t\";\n"
			/*  929 */ "if(b_prefix_line_numbers) {\n"
			/*  930 */ "char p_s_line_no[64];\n"
			/*  931 */ "if(line_no[i] > 0) {\n"
			/*  932 */ "stl_ut::Format(p_s_line_no, sizeof(p_s_line_no),\n"
			/*  933 */ "p_s_line_no_format, line_no[i]);\n"
			/*  934 */ "s_data += p_s_line_no;\n"
			/*  935 */ "} else\n"
			/*  936 */ "s_data += p_s_hide_line_no;\n"
			/*  937 */ "}\n"
			/*  938 */ "s_data += \"\\\"\";\n"
			/*  939 */ "s_data += line_list[i];\n"
			/*  940 */ "if(!line_comment_list.empty() && !line_comment_list[i].empty()) {\n"
			/*  941 */ "s_data += (i + 1 == n)? \"\\\";\" : \"\\\"\";\n"
			/*  943 */ "for(size_t j = 0, m = line_comment_list[i].size(); j < m; ++ j) {\n"
			/*  944 */ "s_data += \" /* \";\n"
			/*  945 */ "s_data += line_comment_list[i][j];\n"
			/*  946 */ "s_data += \" */\";\n"
			/*  947 */ "}\n"
			/*  948 */ "" /* insert comments */
			/*  950 */ "s_data += \"\\n\";\n"
			/*  951 */ "} else\n"
			/*  952 */ "s_data += (i + 1 == n)? \"\\\";\\n\\n\" : \"\\\"\\n\";\n"
			/*  953 */ "}\n"
			/*  954 */ "" /* just print them all */
			/*  956 */ "s_data += \"\\t\\treturn p_s_text;\\n\";\n"
			/*  958 */ "b_is_dynamic = false;\n"
			/*  959 */ "" /* the caller does not need to dispose of the text */
			/*  960 */ "}\n"
			/*  961 */ "} else {\n"
			/*  962 */ "TBuffer t_file;\n"
			/*  963 */ "if(!b_treat_binary_as_text) {\n"
			/*  964 */ "if(!ReadFile(t_file, p_s_infile)) {\n"
			/*  965 */ "fprintf(stderr, \"error: failed to load \\\'%s\\\'\\n\", p_s_infile);\n"
			/*  966 */ "return -1;\n"
			/*  967 */ "}\n"
			/*  968 */ "n_file_size = t_file.n_Size();\n"
			/*  969 */ "n_orig_file_size = n_file_size;\n"
			/*  970 */ "n_crc32 = CCrc_32::n_Crc(t_file.n_Size(), t_file.p_Data());\n"
			/*  971 */ "n_orig_crc32 = n_crc32;\n"
			/*  972 */ "" /* calculate CRC */
			/*  973 */ "} else {\n"
			/*  974 */ "s_file.erase();\n"
			/*  975 */ "for(size_t i = 0, n = line_list.size(); i < n; ++ i)\n"
			/*  976 */ "s_file += line_list[i];\n"
			/*  977 */ "_ASSERTE(n_file_size == s_file.length() * sizeof(char));\n"
			/*  978 */ "n_file_size = s_file.length() * sizeof(char);\n"
			/*  979 */ "if(!t_file.Resize(s_file.length() * sizeof(char)))\n"
			/*  980 */ "throw std::bad_alloc();\n" /* rehtrow */
			/*  981 */ "memcpy(t_file.p_Data(), s_file.data(), s_file.length() * sizeof(char));\n"
			/*  982 */ "" /* just concat; already have a CRC */
			/*  983 */ "}\n"
			/*  984 */ "" /* input data */
			/*  986 */ "if(b_verbose)\n"
			/*  987 */ "printf(\"compressing ... \");\n"
			/*  989 */ "TBuffer t_bwt_data;\n"
			/*  990 */ "uint32_t n_bwt_primary_index;\n"
			/*  991 */ "{\n"
			/*  992 */ "if(!CBurrowsWheelerTransform::Encode(t_file, t_bwt_data))\n"
			/*  993 */ "throw std::bad_alloc();\n" /* rethrow */
			/*  994 */ "_ASSERTE(t_bwt_data.n_Size() == t_file.n_Size() + sizeof(uint32_t));\n"
			/*  995 */ "n_bwt_primary_index = *(uint32_t*)t_bwt_data.p_Data();\n"
			/*  996 */ "TBuffer t_tmp;\n"
			/*  997 */ "if(!t_tmp.Resize(t_file.n_Size()))\n"
			/*  998 */ "throw std::bad_alloc();\n" /* rethrow */
			/*  999 */ "memcpy(t_tmp.p_Data(), t_bwt_data.p_Data() + sizeof(uint32_t), t_file.n_Siz"
					   "e());\n"
			/* 1000 */ "t_tmp.Swap(t_bwt_data);\n"
			/* 1001 */ "}\n"
			/* 1002 */ "" /* compress the whole file with BWT (do not expect to have very big files in here) */
			/* 1004 */ "CMoveToFrontTransform::Encode(t_bwt_data, CMoveToFrontTransform::algo_MTF);"
					   "\n" /* todo - enable this */
			/* 1005 */ "" /* also MTF it, produces shorter files and is easy to decompress */
			/* 1007 */ "TBuffer t_packed_data;\n"
			/* 1008 */ "if(!CRunLengthCodec::Encode(t_bwt_data, t_packed_data))\n"
			/* 1009 */ "throw std::bad_alloc();\n" /* rethrow */
			/* 1010 */ "" /* pack using simple RLE (easy to unpack) */
			/* 1012 */ "size_t n_afterhuff = t_packed_data.n_Size();\n"
			/* 1014 */ "{\n"
			/* 1015 */ "TBuffer t_tmp;\n"
			/* 1016 */ "if(!CHuffmanCodec::Encode(t_packed_data, t_tmp))\n"
			/* 1017 */ "throw std::bad_alloc();\n" /* rethrow */
			/* 1018 */ "t_packed_data.Swap(t_tmp);\n"
			/* 1019 */ "}\n"
			/* 1020 */ "" /* huffman step */
			/* 1022 */ "const char *p_s_base85_alphabet = \"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ\""
					   "\n"
			/* 1023 */ "\"abcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>.@^_,{|}~\";\n" /* as RFC 1924, but '?' is '.' and '`' is ',' */
			/* 1024 */ "" /* modified alphabet for Base-85 that will not cause trigraphs */
			/* 1026 */ "std::string s_base64;\n"
			/* 1027 */ "if(b_use_base85) {\n"
			/* 1028 */ "if(!CModifiedBase85::Encode(s_base64, t_packed_data.n_Size() - sizeof(uint3"
					   "2_t),\n"
			/* 1029 */ "t_packed_data.p_Data() + sizeof(uint32_t), true, p_s_base85_alphabet))\n"
			/* 1030 */ "throw std::bad_alloc();\n" /* rethrow */
			/* 1031 */ "" /* encode as Base-85 with explicit null coding, skip huffman unpack length, we save it otherwise */
			/* 1032 */ "} else {\n"
			/* 1033 */ "if(!CModifiedBase64::Encode(s_base64, t_packed_data.n_Size() - sizeof(uint3"
					   "2_t),\n"
			/* 1034 */ "t_packed_data.p_Data() + sizeof(uint32_t)))\n"
			/* 1035 */ "throw std::bad_alloc();\n" /* rethrow */
			/* 1036 */ "" /* encode as Base-64, skip huffman unpack length, we save it otherwise */
			/* 1037 */ "}\n"
			/* 1039 */ "{\n"
			/* 1040 */ "if(b_verbose) {\n"
			/* 1041 */ "printf(\"packed \" PRIu64 \" B to \" PRIsize \" B of Base-%d text\\n\",\n"
			/* 1042 */ "n_orig_file_size, s_base64.length(), (b_use_base85)? 85 : 64);\n"
			/* 1043 */ "printf(\"testing decompress ... \");\n"
			/* 1044 */ "}\n"
			/* 1046 */ "uint8_t *p_data;\n"
			/* 1047 */ "if(b_use_base85) {\n"
			/* 1048 */ "p_data = p_Decode_BWT_MTF_RLE_Huff_Base85(s_base64.c_str(),\n"
			/* 1049 */ "size_t(n_file_size), n_afterhuff, n_bwt_primary_index);\n"
			/* 1050 */ "} else {\n"
			/* 1051 */ "p_data = p_Decode_BWT_MTF_RLE_Huff_Base64(s_base64.c_str(),\n"
			/* 1052 */ "size_t(n_file_size), n_afterhuff, n_bwt_primary_index);\n"
			/* 1053 */ "}\n"
			/* 1054 */ "if(!p_data)\n"
			/* 1055 */ "fprintf(stderr, \"error: decompress failed\\n\");\n"
			/* 1056 */ "else if(memcmp(p_data, t_file.p_Data(), size_t(n_file_size)))\n"
			/* 1057 */ "fprintf(stderr, \"error: decompress produces different results\\n\");\n"
			/* 1058 */ "else if(b_verbose)\n"
			/* 1059 */ "printf(\"decompress works\\n\");\n"
			/* 1060 */ "if(p_data)\n"
			/* 1061 */ "delete[] p_data;\n"
			/* 1062 */ "}\n"
			/* 1063 */ "" /* test decompress */
			/* 1065 */ "if(b_use_base85) {\n"
			/* 1066 */ "" /* size_t n_pos = 0; */
			/* 1067 */ "" /* while((n_pos = s_base64.find("??", n_pos)) != std::string::npos) { */
			/* 1068 */ "" /* const char *p_s_trigraph_list = "=(</)>!-"; */
			/* 1069 */ "" /* if(n_pos + 2 < s_base64.length() && strchr(p_s_trigraph_list, s_base64[n_pos + 2])) */
			/* 1070 */ "" /* s_base64.insert(n_pos + 1, 1, '\\'); */
			/* 1071 */ "" /* else */
			/* 1072 */ "" /* ++ n_pos; // false alarm, not a trigraph */
			/* 1073 */ "" /* } */
			/* 1074 */ "_ASSERTE(s_base64.find(\"??\") == std::string::npos);\n"
			/* 1075 */ "" /* using a modified alphabet that does not contain question marks */
			/* 1076 */ "} else {\n"
			/* 1077 */ "_ASSERTE(s_base64.find(\"??\") == std::string::npos);\n"
			/* 1078 */ "" /* would not expect trigraphs here, except if using a modified alphabet */
			/* 1079 */ "}\n"
			/* 1080 */ "" /* Base-85 may contain trigraphs, need to escape them properly */
			/* 1082 */ "bool b_have_to_free = false;\n"
			/* 1084 */ "size_t n_print_size = s_base64.length();\n"
			/* 1085 */ "if(n_print_size > n_max_string_length) {\n" /* note that n_print_size could be n_file_size as well, but some compilers might actually limit that instead */
			/* 1086 */ "s_data = \"\\t\\tconst char *p_text_array[] = {\\n\";\n"
			/* 1087 */ "size_t n_cur_size = 0;\n"
			/* 1088 */ "for(size_t i = 0; i < n_print_size;) {\n"
			/* 1089 */ "size_t n_space = min(size_t(n_max_line_length),\n"
			/* 1090 */ "min(size_t(n_max_string_length) - n_cur_size, n_print_size - i));\n"
			/* 1092 */ "if(n_space) {\n"
			/* 1093 */ "if(i)\n"
			/* 1094 */ "s_data += \"\\n\";\n"
			/* 1095 */ "n_cur_size += n_space;\n"
			/* 1096 */ "} else {\n"
			/* 1097 */ "if(i)\n"
			/* 1098 */ "s_data += \",\\n\";\n"
			/* 1099 */ "n_cur_size = n_space = min(size_t(n_max_line_length), n_print_size - i);\n"
			/* 1100 */ "}\n"
			/* 1101 */ "s_data += \"\\t\\t\\t\\\"\";\n"
			/* 1102 */ "s_data.insert(s_data.end(), s_base64.begin() + i,\n"
			/* 1103 */ "s_base64.begin() + (i + n_space));\n"
			/* 1104 */ "i += n_space;\n"
			/* 1105 */ "s_data += \"\\\"\";\n"
			/* 1106 */ "}\n"
			/* 1107 */ "s_data += \"\\n\\t\\t};\\n\";\n"
			/* 1108 */ "" /* need to split it */
			/* 1110 */ "std::string s_size;\n"
			/* 1111 */ "if(!stl_ut::Format(s_size, \"\\t\\tchar *p_s_base%d;\\n\\t\\tif(!(p_s_base%"
					   "d = new(std::nothrow) char[\"\n"
			/* 1112 */ "PRIsize \"]))\\n\\t\\t\\treturn 0;\\n\", n_base, n_base, n_print_size + 1))"
					   "\n"
			/* 1113 */ "throw std::bad_alloc();\n" /* retrhow */
			/* 1114 */ "s_data += s_size;;\n"
			/* 1115 */ "" /* s_data += "\t\t*p_s_base64 = 0;\n" */
			/* 1116 */ "" /* "\t\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_array[0]); i < n; ++ i)\n" */
			/* 1117 */ "" /* "\t\t\tstrcat(p_s_base64, p_text_array[i]);\n"; */
			/* 1118 */ "" /* uses strcat; ugly, inefficient */
			/* 1120 */ "std::string s_concat;\n"
			/* 1121 */ "if(!stl_ut::Format(s_concat, \"\\t\\tchar *p_s_dest = p_s_base%d;\\n\"\n"
			/* 1122 */ "\"\\t\\tfor(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_array[0]"
					   "); i < n; ++ i) {\\n\"\n"
			/* 1123 */ "\"\\t\\t\\tsize_t n_chunk = (i + 1 < n)? \" PRIsize \" : \" PRIsize \";\\n"
					   "\"\n"
			/* 1124 */ "\"\\t\\t\\tmemcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char));\\n\" "
					   "\"\\t\\t\\tp_s_dest += n_chunk;\\n\"\n"
			/* 1125 */ "\"\\t\\t}\\n\" \"\\t\\t*p_s_dest = 0;\\n\", n_base, n_max_string_length,\n"
			/* 1126 */ "size_t(n_print_size % n_max_string_length)))\n"
			/* 1127 */ "throw std::bad_alloc();\n" /* retrhow */
			/* 1128 */ "s_data += s_concat;\n"
			/* 1129 */ "" /* better concat code, using memcpy */
			/* 1130 */ "" /* need to provide code to concat it back */
			/* 1132 */ "b_have_to_free = true;\n"
			/* 1133 */ "" /* the caller needs to dispose of the text */
			/* 1134 */ "} else {\n"
			/* 1135 */ "s_data = (b_use_base85)? \"\\t\\tconst char *p_s_base85 = \" : \"\\t\\tcons"
					   "t char *p_s_base64 = \";\n"
			/* 1136 */ "for(size_t i = 0; i < n_print_size;) {\n"
			/* 1137 */ "size_t n_line_length = (i)? n_max_line_length : n_max_line_length -\n"
			/* 1138 */ "strlen(\"const char *p_s_baseXX = \") + n_tab_size;\n" /* n_max_line_length expects three tabs but there are only two */
			/* 1139 */ "size_t n_space = min(n_line_length, n_print_size - i);\n"
			/* 1140 */ "s_data += (i)? \"\\t\\t\\t\\\"\" : \"\\\"\";\n"
			/* 1141 */ "s_data.insert(s_data.end(), s_base64.begin() + i,\n"
			/* 1142 */ "s_base64.begin() + (i + n_space));\n"
			/* 1143 */ "i += n_space;\n"
			/* 1144 */ "s_data += (i == n_print_size)? \"\\\";\\n\" : \"\\\"\\n\";\n"
			/* 1145 */ "}\n"
			/* 1146 */ "" /* just print it all */
			/* 1148 */ "b_have_to_free = false;\n"
			/* 1149 */ "" /* the caller does not need to dispose of the text */
			/* 1150 */ "}\n"
			/* 1152 */ "std::string s_decompress;\n"
			/* 1153 */ "if(b_have_to_free) {\n"
			/* 1154 */ "s_data += \"\\t\\tchar *p_data = \";\n"
			/* 1155 */ "} else\n"
			/* 1156 */ "s_data += \"\\t\\treturn \";\n"
			/* 1157 */ "if(b_shared_decompress) {\n"
			/* 1158 */ "if(!stl_ut::Format(s_decompress, \"%s(p_s_base%d, \" PRIu64 \", \" PRIsize "
					   "\", \"\n"
			/* 1159 */ "PRIsize \");\\n\", \"p_Call_Decompress\", n_base, n_file_size, n_afterhuff,"
					   "\n"
			/* 1160 */ "size_t(n_bwt_primary_index)))\n"
			/* 1161 */ "throw std::bad_alloc();\n" /* rethrow */
			/* 1162 */ "} else {\n"
			/* 1163 */ "if(!stl_ut::Format(s_decompress, \"%s%d(p_s_base%d, \" PRIu64 \", \" PRIsiz"
					   "e \", \"\n"
			/* 1164 */ "PRIsize \");\\n\", \"(char*)p_Decode_BWT_MTF_RLE_Huff_Base\", n_base, n_bas"
					   "e,\n"
			/* 1165 */ "n_file_size, n_afterhuff, size_t(n_bwt_primary_index)))\n"
			/* 1166 */ "throw std::bad_alloc();\n" /* rethrow */
			/* 1167 */ "}\n"
			/* 1168 */ "s_data += s_decompress;\n"
			/* 1169 */ "" /* prepare the call to the decompress routine */
			/* 1171 */ "if(b_have_to_free) {\n"
			/* 1172 */ "if(b_use_base85)\n"
			/* 1173 */ "s_data += \"\\t\\tdelete[] p_s_base85;\\n\";\n"
			/* 1174 */ "else\n"
			/* 1175 */ "s_data += \"\\t\\tdelete[] p_s_base64;\\n\";\n"
			/* 1176 */ "s_data += \"\\t\\treturn p_data;\\n\";\n"
			/* 1177 */ "}\n"
			/* 1178 */ "" /* return the data */
			/* 1180 */ "b_is_dynamic = true;\n"
			/* 1181 */ "" /* the caller needs to dispose of the text */
			/* 1182 */ "}\n"
			/* 1183 */ "} catch(std::bad_alloc&) {\n"
			/* 1184 */ "fprintf(stderr, \"error: not enough memory\\n\");\n"
			/* 1185 */ "return -1;\n"
			/* 1186 */ "}\n"
			/* 1187 */ "" /* throws */
			/* 1189 */ "{\n"
			/* 1190 */ "std::string s_ident, s_header;\n"
			/* 1191 */ "if(!stl_ut::AssignCStr(s_ident, p_s_name_file) ||\n"
			/* 1192 */ "!stl_ut::AssignCStr(s_header, p_s_name_file)) {\n"
			/* 1193 */ "fprintf(stderr, \"error: not enough memory\\n\");\n"
			/* 1194 */ "return -1;\n"
			/* 1195 */ "}\n"
			/* 1196 */ "for(size_t i = 0, n = s_ident.length(); i < n; ++ i) {\n"
			/* 1197 */ "if(isalpha(uint8_t(s_ident[i])))\n"
			/* 1198 */ "s_ident[i] = toupper(uint8_t(s_ident[i]));\n"
			/* 1199 */ "else if(!isdigit(uint8_t(s_ident[i]))) {\n"
			/* 1200 */ "s_ident[i] = \'_\';\n"
			/* 1201 */ "s_header[i] = \'_\';\n"
			/* 1202 */ "}\n"
			/* 1203 */ "}\n"
			/* 1204 */ "" /* create class name */
			/* 1206 */ "FILE *p_fw;\n"
			/* 1207 */ "#if defined(_MSC_VER) && !defined(__MWERKS__) && _MSC_VER >= 1400\n"
			/* 1208 */ "if(fopen_s(&p_fw, p_s_outfile, \"w\")) {\n"
			/* 1209 */ "#else\n" /* _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400 */
			/* 1210 */ "if(!(p_fw = fopen(p_s_outfile, \"w\"))) {\n"
			/* 1211 */ "#endif\n" /* _MSC_VER && !__MWERKS__ && _MSC_VER >= 1400 */
			/* 1212 */ "fprintf(stderr, \"error: failed to open \\\'%s\\\' for writing\\n\", p_s_ou"
					   "tfile);\n"
			/* 1213 */ "return -1;\n"
			/* 1214 */ "}\n"
			/* 1216 */ "fprintf(p_fw, \"/**\\n\");\n"
			/* 1217 */ "fprintf(p_fw, \" *\\t@file %s\\n\", p_s_outfile);\n"
			/* 1218 */ "fprintf(p_fw, \" *\\t@brief file in header, generated from \\\'%s\\\'\\n\","
					   " p_s_name_file);\n"
			/* 1219 */ "if(b_binary_mode)\n"
			/* 1220 */ "fprintf(p_fw, \" *\\t\\tusing BWT / RLE / Huff / Base%d pipe\\n\", n_base);"
					   "\n"
			/* 1221 */ "else\n"
			/* 1222 */ "fprintf(p_fw, \" *\\t\\tstored as plain text\\n\");\n"
			/* 1223 */ "TFileInfo::TTime t_time = TFileInfo(p_s_name_file).p_time[TFileInfo::time_L"
					   "astWrite];\n"
			/* 1224 */ "fprintf(p_fw, \" *\\t@date %4d-%02d-%02d %02d:%02d:%02d\\n\", t_time.n_year"
					   ",\n"
			/* 1225 */ "t_time.n_month, t_time.n_day, t_time.n_hour, t_time.n_minute, t_time.n_seco"
					   "nd);\n"
			/* 1226 */ "fprintf(p_fw, \" *\\t@author FileToHeader \" APP_VERSION \" (built \" __DAT"
					   "E__ \")\\n\");\n"
			/* 1227 */ "fprintf(p_fw, \" */\\n\\n\");\n"
			/* 1228 */ "fprintf(p_fw, \"#pragma once\\n\");\n"
			/* 1229 */ "fprintf(p_fw, \"#ifndef __%s_FILE_IN_HEADER_INCLUDED\\n\", s_ident.c_str())"
					   ";\n"
			/* 1230 */ "fprintf(p_fw, \"#define __%s_FILE_IN_HEADER_INCLUDED\\n\\n\", s_ident.c_str"
					   "());\n"
			/* 1231 */ "" /* generate nice header // t_odo - do the same in ImageToHeader */
			/* 1233 */ "fprintf(p_fw, \"/**\\n\");\n"
			/* 1234 */ "fprintf(p_fw, \" *\\t@brief file in header, generated from \\\'%s\\\'\\n\","
					   " p_s_name_file);\n"
			/* 1235 */ "fprintf(p_fw, \" */\\n\");\n"
			/* 1236 */ "if(!p_s_classname)\n"
			/* 1237 */ "fprintf(p_fw, \"class C%s {\\n\", s_header.c_str());\n"
			/* 1238 */ "else\n"
			/* 1239 */ "fprintf(p_fw, \"class %s {\\n\", p_s_classname);\n" /* class name override */
			/* 1240 */ "fprintf(p_fw, \"public:\\n\");\n"
			/* 1241 */ "fprintf(p_fw, \"\\t/**\\n\"\n"
			/* 1242 */ "\"\\t *\\t@brief gets size of the data\\n\"\n"
			/* 1243 */ "\"\\t *\\t@return Returns size of the data, in bytes, not including the ter"
					   "minating zero.\\n\"\n"
			/* 1244 */ "\"\\t */\\n\");\n"
			/* 1245 */ "if(n_orig_file_size == n_file_size) {\n"
			/* 1246 */ "fprintf(p_fw, \"\\tstatic inline size_t n_Size()\\n\\t{\\n\\t\\treturn \" P"
					   "RIu64\n"
			/* 1247 */ "\"; // matches original file\\n\\t}\\n\\n\", n_file_size);\n"
			/* 1248 */ "} else {\n"
			/* 1249 */ "fprintf(p_fw, \"\\tstatic inline size_t n_Size()\\n\\t{\\n\\t\\treturn \" P"
					   "RIu64\n"
			/* 1250 */ "\"; // original file \" PRIu64 \" B\\n\\t}\\n\\n\", n_file_size, n_orig_fil"
					   "e_size);\n"
			/* 1251 */ "}\n"
			/* 1252 */ "fprintf(p_fw, \"\\t/**\\n\"\n"
			/* 1253 */ "\"\\t *\\t@brief determines whether the stored string is dynamically alloca"
					   "ted\\n\"\n"
			/* 1254 */ "\"\\t *\\t@return Returns true if the caller of p_Data() needs to free the "
					   "memory.\\n\"\n"
			/* 1255 */ "\"\\t */\\n\");\n"
			/* 1256 */ "fprintf(p_fw, \"\\tstatic inline bool b_Dynamic()\\n\\t{\\n\\t\\treturn %s;"
					   "\\n\\t}\\n\\n\",\n"
			/* 1257 */ "(b_is_dynamic)? \"true\" : \"false\");\n"
			/* 1258 */ "fprintf(p_fw, \"\\t/**\\n\"\n"
			/* 1259 */ "\"\\t *\\t@brief gets CRC\\n\"\n"
			/* 1260 */ "\"\\t *\\t@return Returns CRC32 of the stored data.\\n\"\n"
			/* 1261 */ "\"\\t *\\t@note The stored CRC may differ from the original file if data pr"
					   "ocessing was enabled.\\n\"\n"
			/* 1262 */ "\"\\t */\\n\");\n"
			/* 1263 */ "if(n_orig_crc32 == n_crc32) {\n"
			/* 1264 */ "fprintf(p_fw, \"\\tstatic inline uint32_t n_CRC32()\\n\\t{\\n\\t\\treturn 0"
					   "x%08x;\"\n"
			/* 1265 */ "\" // matches original file\\n\\t}\\n\\n\", n_crc32);\n"
			/* 1266 */ "} else {\n"
			/* 1267 */ "fprintf(p_fw, \"\\tstatic inline uint32_t n_CRC32()\\n\\t{\\n\\t\\treturn 0"
					   "x%08x;\"\n"
			/* 1268 */ "\" // original file 0x%08x\\n\\t}\\n\\n\", n_crc32, n_orig_crc32);\n"
			/* 1269 */ "}\n"
			/* 1270 */ "fprintf(p_fw, \"\\t/**\\n\"\n"
			/* 1271 */ "\"\\t *\\t@brief gets data\\n\"\n"
			/* 1272 */ "\"\\t *\\n\"\n"
			/* 1273 */ "\"\\t *\\t@return Returns data of the file on success, 0 on failure (not en"
					   "ough memory).\\n\"\n"
			/* 1274 */ "\"\\t *\\n\"\n"
			/* 1275 */ "\"\\t *\\t@note The data (despite it may be binary), is additionally null t"
					   "erminated to make\\n\"\n"
			/* 1276 */ "\"\\t *\\t\\tit easier to use (the terminating null is not counted in n_Siz"
					   "e()).\\n\"\n"
			/* 1277 */ "\"\\t *\\t@note See also b_Dynamic().\\n\"\n"
			/* 1278 */ "\"\\t */\\n\");\n"
			/* 1279 */ "if(b_is_dynamic)\n"
			/* 1280 */ "fprintf(p_fw, \"\\tstatic inline char *p_Data()\\n\\t{\\n\");\n"
			/* 1281 */ "else\n"
			/* 1282 */ "fprintf(p_fw, \"\\tstatic inline const char *p_Data()\\n\\t{\\n\");\n"
			/* 1283 */ "fprintf(p_fw, \"%s\", s_data.c_str());\n"
			/* 1284 */ "fprintf(p_fw, \"\\t}\\n\");\n"
			/* 1286 */ "uint32_t n_decompressor_crc = 0;\n"
			/* 1287 */ "std::string s_decompress_src;\n"
			/* 1288 */ "if(b_binary_mode) {\n"
			/* 1289 */ "if(b_binary_mode) {\n"
			/* 1290 */ "#if 1\n"
			/* 1291 */ "char *p_s_deco;\n"
			/* 1292 */ "if(b_use_base85)\n"
			/* 1293 */ "p_s_deco = CDecompress85_h::p_Data();\n" /* use itself to generate compressed decompressor */
			/* 1294 */ "else\n"
			/* 1295 */ "p_s_deco = CDecompress64_h::p_Data();\n" /* use itself to generate compressed decompressor */
			/* 1296 */ "if(!p_s_deco || !stl_ut::AssignCStr(s_decompress_src, p_s_deco)) {\n"
			/* 1297 */ "if(p_s_deco)\n"
			/* 1298 */ "delete[] p_s_deco;\n"
			/* 1299 */ "fprintf(stderr, \"error: failed to decompress the decompress routines\\n\")"
					   ";\n"
			/* 1300 */ "#else\n"
			/* 1301 */ "if(!ReadFile(s_decompress_src, (b_use_base85)? \"Decompress64.h\" : \"Decom"
					   "press85.h\")) {\n" /* uncool, hard to use from commandline */
			/* 1302 */ "fprintf(stderr, \"error: failed to read \\\'Decompress.h\\\',\"\n",
			/* 1303 */ "\" unable to include decompress routines\\n\");\n"
			/* 1304 */ "#endif\n"
			/* 1305 */ "fclose(p_fw);\n"
			/* 1306 */ "return -1;\n"
			/* 1307 */ "} else {\n"
			/* 1308 */ "size_t n_pos = 0;\n"
			/* 1309 */ "while((n_pos = s_decompress_src.find(\"\\r\\n\", n_pos)) != std::string::np"
					   "os)\n"
			/* 1310 */ "s_decompress_src.erase(n_pos, 1);\n"
			/* 1311 */ "" /* condense newlines */
			/* 1313 */ "n_decompressor_crc = CCrc_32::n_Crc(s_decompress_src.length() *\n"
			/* 1314 */ "sizeof(char), s_decompress_src.data());\n"
			/* 1315 */ "" /* calculate CRC of it */
			/* 1316 */ "}\n"
			/* 1317 */ "}\n"
			/* 1318 */ "}\n"
			/* 1319 */ "" /* read the decompressor */
			/* 1321 */ "if(b_binary_mode) {\n"
			/* 1322 */ "if(b_shared_decompress) {\n"
			/* 1323 */ "fprintf(p_fw, \"\\nprotected:\\n\"\n"
			/* 1324 */ "\"\\t/**\\n\"\n"
			/* 1325 */ "\"\\t *\\t@copydoc CFTHDecompressCode_%08x::p_Decode_BWT_MTF_RLE_Huff_Base%"
					   "d\\n\"\n"
			/* 1326 */ "\"\\t */\\n\"\n"
			/* 1327 */ "\"\\tstatic inline char *p_Call_Decompress(const char *p_s_base%d,\\n\"\n"
			/* 1328 */ "\"\\t\\tint n_data_size, int n_huff_stage_size, uint32_t n_bwt_primary_inde"
					   "x);\\n\",\n"
			/* 1329 */ "n_decompressor_crc, n_base, n_base);\n"
			/* 1330 */ "" /* specify a small routine that will call decompressor once it's been declared */
			/* 1332 */ "fprintf(p_fw, \"};\\n\");\n"
			/* 1333 */ "" /* end the previos class */
			/* 1335 */ "fprintf(p_fw, \"\\n#ifndef __FILE_TO_HEADER_DECOMPRESS_%08X_INCLUDED\\n\", "
					   "n_decompressor_crc);\n"
			/* 1336 */ "fprintf(p_fw, \"#define __FILE_TO_HEADER_DECOMPRESS_%08X_INCLUDED\\n\\n\", "
					   "n_decompressor_crc);\n"
			/* 1338 */ "fprintf(p_fw, \"/**\\n\"\n"
			/* 1339 */ "\" *\\t@brief decompression routine implementation\\n\"\n"
			/* 1340 */ "" /* " *\t@note While this allows all the compressed files to share decompressor implementation,\n" */
			/* 1341 */ "" /* " *\t\tit restricts all the files to be included in a single .cpp file, otherwise linking\n" */
			/* 1342 */ "" /* " *\t\tfails because of duplicate symbols (remove body of decompress function in such case).\n" */
			/* 1343 */ "\" */\\n\"\n"
			/* 1344 */ "\"class CFTHDecompressCode_%08x {\\npublic:\\n\", n_decompressor_crc);\n"
			/* 1345 */ "fprintf(p_fw, \"%s\", s_decompress_src.c_str());\n"
			/* 1346 */ "" /* include decompress routines */
			/* 1348 */ "fprintf(p_fw, \"};\\n\\n#endif // __FILE_TO_HEADER_DECOMPRESS_%08X_INCLUDED"
					   "\\n\\n\", n_decompressor_crc);\n"
			/* 1350 */ "fprintf(p_fw, \"inline char *%s%s::p_Call_Decompress(const char *p_s_base%d"
					   ",\\n\"\n"
			/* 1351 */ "\"\\tint n_data_size, int n_huff_stage_size, uint32_t n_bwt_primary_index)"
					   "\\n\"\n"
			/* 1352 */ "\"{\\n\"\n"
			/* 1353 */ "\"\\treturn (char*)CFTHDecompressCode_%08x::p_Decode_BWT_MTF_RLE_Huff_Base%"
					   "d(p_s_base%d,\\n\"\n"
			/* 1354 */ "\"\\t\\tn_data_size, n_huff_stage_size, n_bwt_primary_index);\\n\"\n"
			/* 1355 */ "\"}\\n\"\n"
			/* 1356 */ "\"// a dummy function that calls the decompressor, which is now declared\\n"
					   "\"\n"
			/* 1357 */ "\"// (allows us to keep it at the end of the file)\\n\",\n"
			/* 1358 */ "(p_s_classname)? \"\" : \"C\", (p_s_classname)? p_s_classname : s_header.c_"
					   "str(),\n" /* fix: use p_s_classname here as well */
			/* 1359 */ "n_base, n_decompressor_crc, n_base, n_base);\n"
			/* 1360 */ "" /* implement the body of the dummy routine that calls the decompress after we declared it */
			/* 1361 */ "} else {\n"
			/* 1362 */ "fprintf(p_fw, \"\\nprotected:\\n%s};\\n\", s_decompress_src.c_str());\n"
			/* 1363 */ "" /* otherwise make the decompressor a part of the file class */
			/* 1364 */ "}\n"
			/* 1365 */ "} else\n"
			/* 1366 */ "fprintf(p_fw, \"};\\n\");\n"
			/* 1367 */ "" /* include decompressor, make it so that the code can be shared if more than a single file is included */
			/* 1369 */ "fprintf(p_fw, \"\\n#endif // !__%s_FILE_IN_HEADER_INCLUDED\\n\", s_ident.c_"
					   "str());\n"
			/* 1371 */ "if(ferror(p_fw)) {\n"
			/* 1372 */ "fprintf(stderr, \"error: failed to write code to \\\'%s\\\'\\n\", p_s_outfi"
					   "le);\n"
			/* 1373 */ "return -1;\n"
			/* 1374 */ "}\n"
			/* 1376 */ "fclose(p_fw);\n"
			/* 1377 */ "}\n"
			/* 1378 */ "" /* write C++ header file */
			/* 1380 */ "if(b_verbose)\n"
			/* 1381 */ "printf(\"\\ndone\\n\");\n"
			/* 1383 */ "return 0;\n"
			/* 1384 */ "}\n"
		};
		char *p_s_text;
		if(!(p_s_text = new(std::nothrow) char[32770]))
			return 0;
		char *p_s_dest = p_s_text;
		for(size_t i = 0, n = sizeof(p_text_array) / sizeof(p_text_array[0]); i < n; ++ i) {
			size_t n_chunk = strlen(p_text_array[i]);
			memcpy(p_s_dest, p_text_array[i], n_chunk * sizeof(char));
			p_s_dest += n_chunk;
		}
		*p_s_dest = 0;
		return p_s_text;
	}
};

#endif // !__MAIN_CPP_FILE_IN_HEADER_INCLUDED
